#ifndef __SIGNAL_LOADED
#define __SIGNAL_LOADED 1

/*
 *  <signal.h> - Signal Handling
 *
 *  Copyright (c) 1993 by Digital Equipment Corporation.  All rights reserved.
 *
 *  DEC C for OpenVMS VAX and OpenVMS AXP
 *  DEC C++ for OpenVMS VAX and OpenVMS AXP
 */


#ifdef __cplusplus
    extern "C" {
#endif


#if (defined(__MIA) && !defined(__XPG4))
#define __XPG4 1
#endif

typedef int	sig_atomic_t;

#define signal decc$signal
#define raise decc$raise
void	(*signal (int __sig, void (*__func)(int))) (int);
int	raise (int __sig);

#define SIG_DFL		(void (*)(int)) 0
#define SIG_ERR		(void (*)(int)) -1
#define SIG_IGN		(void (*)(int)) 1

#define SIGHUP		1	/* hangup */
#define SIGINT		2	/* interrupt */
#define SIGQUIT		3	/* quit */
#define SIGILL		4	/* illegal instruction (not reset when caught) */
#define SIGTRAP		5	/* trace trap (not reset when caught) */
#define SIGIOT		6	/* IOT instruction */
#define SIGEMT		7	/* EMT instruction */
#define SIGFPE		8	/* floating point exception */
#define SIGKILL		9	/* kill (cannot be caught or ignored) */
#define SIGBUS		10	/* bus error */
#define SIGSEGV		11	/* segmentation violation */
#define SIGSYS		12	/* bad argument to system call */
#define SIGPIPE		13	/* write to a pipe with no one to read it */
#define SIGALRM		14	/* alarm clock */
#define SIGTERM		15	/* software termination signal from kill */
#define SIGABRT		SIGIOT	/* ? */

#ifdef __XPG4
#define SIGUSR1		16	/* user defined signal 1 */
#define SIGUSR2		17	/* user defined signal 2 */
#endif

/*
 *  VAX C Extensions
 *
 *  These definitions are hidden when DEC C is in strict ANSI C compatibility
 *  mode.  The user can turn them back on using the command line option
 *  /UNDEFINE="__HIDE_FORBIDDEN_NAMES"
 */

#ifndef __HIDE_FORBIDDEN_NAMES

#ifdef __XPG4
#define NSIG			17	/* number of signals */
#else
#define NSIG			15	/* number of signals */
#endif
#define BADSIG			(void (*)())-1

#define ILL_RESAD_FAULT		0x0	/* reserved addressing mode fault */
#define ILL_PRIVIN_FAULT	0x1	/* privilidged instruction fault */
#define ILL_RESOP_FAULT		0x2	/* reserved operand fault */

#define FPE_INTOVF_TRAP		0X1
#define FPE_INTDIV_TRAP		0X2
#define FPE_FLTOVF_TRAP		0X3
#define FPE_FLTDIV_TRAP		0X4
#define FPE_FLTUND_TRAP		0X5
#define FPE_DECOVF_TRAP		0X6
#ifdef __VAX
#define FPE_SUBRNG_TRAP		0X7
#else
#define FPE_INXRES_TRAP		0X7
#endif
#define FPE_FLTOVF_FAULT	0X8
#define FPE_FLTDIV_FAULT	0X9
#define FPE_FLTUND_FAULT	0XA
#ifndef __VAX
#define FPE_INVOPR_TRAP		0XB
#endif

struct	sigvec
{
	void	(*sv_handler)();	/* handler address */
	int	sv_mask;		/* mask of signals to be blocked */
	int	sv_onstack;		/* flag to indicate signal stack */
};

struct	sigcontext
{
	int	sc_onstack;		/* signal stack flag to restore */
	int	sc_mask;		/* signal mask to restore */
	int	sc_sp;			/* stack pointerto restore */
	int	sc_pc;			/* pc to return to */
	int	sc_ps;			/* psl to restore */
};

struct	sigstack
{
	char	*ss_sp;			/* signal stack pointer */
	int	ss_onstack;		/* current status */
};

void	(*ssignal (int __sig, void (*__action)(int, ...)) ) (int, ...);
int	gsignal		(int __sig, ...);
int	kill		(int __pid, int __sig);
int	alarm		(unsigned int __seconds);
int	pause		(void);
int	sleep		(unsigned __seconds);
int	sigvec		(int __sigveca, struct sigvec *__sv, struct sigvec *__osv);
int	sigblock	(int __mask);
int	sigsetmask	(int __mask);
int	sigstack	(struct sigstack *__ss, struct sigstack *__oss);
int	sigpause	(int __mask);
void	VAXC$CRTL_INIT	(void);

#ifndef __cplusplus
void	DECC$CRTL_INIT	(void);
#endif

void	VAXC$ESTABLISH	(unsigned int (*__exception_handler)(void *__sigarr, void *__mecharr));

#endif	/* __HIDE_FORBIDDEN_NAMES */

#ifdef __cplusplus
    }
#endif

#endif	/* __SIGNAL_LOADED */
