/* <acedef.h>
 *
 *	Access Control list Entry structure definitions
 */
#ifndef _ACEDEF_H
#define _ACEDEF_H

#define ACE$C_KEYID		1	/* key identifier entry */
#define ACE$C_RMSJNL_BI		2	/* RMS BI journal */
#define ACE$C_RMSJNL_AI		3	/* RMS AI journal */
#define ACE$C_RMSJNL_AT		4	/* RMS AT journal */
#define ACE$C_AUDIT		5	/* security audit journal entry */
#define ACE$C_ALARM		6	/* security alarm entry */
#define ACE$C_INFO		7	/* general purpose information */
#define ACE$C_RMSJNL_RU_DEFAULT 8	/* RU journal default volume */
#define ACE$C_DIRDEF		9	/* directory default protection */
#define ACE$C_RMSJNL_RU		10	/* RU journal (many per file) */
#define ACE$C_SUBSYSTEM_IDS	11	/* protected subsystem ids */
#define ACE$C_OIL		12	/* Object Information Label */
#define ACE$C_NEW_OWNER		13	/* Protection for owner ACE */
#define ACE$C_MAX_CODE		14	/* Maximum ACE type code plus 1 */
 /* ACE types registered to outside products. Not recognized by VMS software. */
 /* Registered for Pathworks... */
#define ACE$C_PATHWORKS		128	/* Pathworks common ACE */
#define ACE$C_LANMAN_SECURITY	129	/* LANMAN security */
#define ACE$C_LANMAN_ATTRIB	130	/* LANMAN extended attributes */
#define ACE$C_NETWARE		131	/* Netware trustee */
#define ACE$C_MAC_COMMENT	132	/* MacIntosh comment */
#define ACE$C_PATHWORKS_1	133	/* reserved to Pathworks */
#define ACE$C_PATHWORKS_2	134	/* reserved to Pathworks */
#define ACE$C_PATHWORKS_3	135	/* reserved to Pathworks */
#define ACE$C_RESERVED	      255	/* reserved ACE type */
#define ACE$C_APPLICATION	7	/* alternate application ACE code */
#define ACE$C_CUST	1		/* customer defined */
#define ACE$C_CSS	2		/* CSS defined */
#define ACE$C_VMS	3		/* VMS defined */
#define ACE$V_SUCCESS	0
#define ACE$V_FAILURE	1
#define ACE$V_DEFAULT	8
#define ACE$V_PROTECTED 9
#define ACE$V_HIDDEN	10
#define ACE$V_NOPROPAGATE 11
#define ACE$M_SUCCESS	(1<<ACE$V_SUCCESS)	/* 0x01 */
#define ACE$M_FAILURE	(1<<ACE$V_FAILURE)	/* 0x02 */
#define ACE$M_DEFAULT	(1<<ACE$V_DEFAULT)	/* 0x0100 */
#define ACE$M_PROTECTED (1<<ACE$V_PROTECTED)	/* 0x0200 */
#define ACE$M_HIDDEN	(1<<ACE$V_HIDDEN)	/* 0x0400 */
#define ACE$M_NOPROPAGATE (1<<ACE$V_NOPROPAGATE) /* 0x0800 */
#define ACE$V_READ	0
#define ACE$V_WRITE	1
#define ACE$V_EXECUTE	2
#define ACE$V_DELETE	3
#define ACE$V_CONTROL	4
#define ACE$M_READ	(1<<ACE$V_READ)		/* 0x01 */
#define ACE$M_WRITE	(1<<ACE$V_WRITE)	/* 0x02 */
#define ACE$M_EXECUTE	(1<<ACE$V_EXECUTE)	/* 0x04 */
#define ACE$M_DELETE	(1<<ACE$V_DELETE)	/* 0x08 */
#define ACE$M_CONTROL	(1<<ACE$V_CONTROL)	/* 0x10 */
#define ACE$K_LENGTH 8			/* length of the overhead area */
#define ACE$C_LENGTH 8
#define ACE$C_RMS_ATTRIBUTES 0		/* variant of ACE for file attributes */
#define ACE$K_RMS_ATTRIBUTES 0		/* variant of ACE for file attributes */
#define ACE$K_RMSATR_MINOR_V50 2	/* minor ID for VMS 5.0 */
#define ACE$K_RMSATR_MINOR_VDW 2	/* minor ID for DECwindows V1.0 */
#define ACE$C_RMSATR_MINOR_ID 2		/* current minor ID (obsolete symbol) */
#define ACE$K_RMSATR_MINOR_ID 2
#define ACE$C_RMSATR_MAJOR_ID 1		/* current major ID */
#define ACE$K_RMSATR_MAJOR_ID 1
#define ACE$V_STATISTICS 0
#define ACE$V_XLATE_DEC  1
#define ACE$M_STATISTICS (1<<ACE$V_STATISTICS)	/* 0x01 */
#define ACE$M_XLATE_DEC  (1<<ACE$V_XLATE_DEC)	/* 0x02 */
#define ACE$S_RMSATR 20			/* size of RMS file attributes ACE (fixed fields) */
#define ACE$S_RMSATR_V50 20		/* " */
#define ACE$S_RMSATR_VDW 20		/* " */
/* Beyond the fixed fields, variable length information will by stored */
#define ACE$_RMSATR_ORGANIZATION 1	/* organizational extension object ID */
#define ACE$_RMSATR_SEMANTICS 2		/* file semantics object ID */
#define ACE$K_RMSATR_ORG_MAX_LEN 64
#define ACE$K_RMSATR_SEM_MAX_LEN 64
#define ACE$S_RMSJNL_RU_DEFAULT 17	/* length of RMSJNL RU default ACE */
#define ACE$V_JOURNAL_DISABLED	0
#define ACE$V_BACKUP_DONE	1
#define ACE$M_JOURNAL_DISABLED	(1<<ACE$V_JOURNAL_DISABLED)	/* 0x01 */
#define ACE$M_BACKUP_DONE	(1<<ACE$V_BACKUP_DONE)		/* 0x02 */
#define ACE$S_RMSJNL_RU 38		/* length of RMSJNL RU ACE */
#define ACE$S_RMSJNL	50		/* length of RMSJNL AI/BI/AT ACE */
#define ACE$S_OIL_S64I64 32		/* length of type 0 OIL ACE */
#define ACE$S_OIL_S128	32		/* length of type 1 OIL ACE */
#define ACE$S_OIL	32		/* maximum OIL ACE Size */
struct acedef {
    unsigned char ace$b_size;			/* size of the entry */
    unsigned char ace$b_type;			/* type of entry */
    union {
	unsigned short ace$w_flags;		/* type dependent & independent flags */
	struct {				/* flags for INFO type ACE */
	    unsigned ace$v_info_type : 4;	/* INFO ACE subtype */
	    unsigned		     : 4;
	} ace$r_flags_info;
	struct {				/* flags for KEYID type */
	    unsigned ace$v_reserved  : 4;	/* count of reserved longwords */
	    unsigned		     : 4;
	} ace$r_flags_keyid;
	struct {
	    unsigned ace$v_success   : 1;	/* audit or alarm upon success */
	    unsigned ace$v_failure   : 1;	/* audit ot alarm upon failure */
	    unsigned		     : 6;
	} ace$r_flags_bits0;
	struct {				/* type independent flags */
	    unsigned			: 8;
	    unsigned ace$v_default	: 1;	/* directory default entry */
	    unsigned ace$v_protected	: 1;	/* protected ACE */
	    unsigned ace$v_hidden	: 1;	/* hidden ACE */
	    unsigned ace$v_nopropagate	: 1;	/* no propagation between versions */
	    unsigned			: 4;
	} ace$r_flags_bits;
    } ace$r_flags_overlay;
    union {				/* start of ACE overlayed area */
	struct {			/* key-id and security audit types */
	    union {
		unsigned long ace$l_access;	/* access rights bitmask */
		struct {
		    unsigned ace$v_read    : 1; /* allowed to read */
		    unsigned ace$v_write   : 1; /* " to write */
		    unsigned ace$v_execute : 1; /* " to execute */
		    unsigned ace$v_delete  : 1; /* " to delete */
		    unsigned ace$v_control : 1; /* all privileges of the owner */
		    unsigned		   : 3;
		} ace$r_access_bits;
	    } ace$r_access_overlay;
	    union {
		unsigned long ace$l_key;	/* start of the key fields */
		char ace$t_auditname[16];	/* start of the security journal name */
	    } ace$r_key_overlay;
	} ace$r_key_aud_type;
	struct {
	    union {
		unsigned long ace$l_info_flags; /* INFO type application flags */
		struct {
		    unsigned short ace$w_application_flags;	/* VMS application flags word */
		    unsigned short ace$w_application_facility;	/* VMS application facility code */
		} ace$r_info_flags_bits;
	    } ace$r_info_flags_overlay;
	    union {
		char ace$t_info_start;		/* start of the information */
		struct {
		    unsigned short ace$w_rmsatr_variant;  /* which variant of the RMS attributes ACE */
		    unsigned char ace$b_rmsatr_fixlen;	  /* length of fixed format fields */
 /* (introduced at minor ID 3; older ACE's are assumed to be all fixed form) */
		    char ace$b_rmsatr_spare1;	/* currectly unused */
		    unsigned short ace$w_rmsatr_minor_id; /* RMS file attributes ACE minor ID */
		    unsigned short ace$w_rmsatr_major_id; /* RMS file attributes ACE major ID */
		    union {
			unsigned long ace$l_rms_attribute_flags; /* RMS file attributes flags definitions */
			struct {
			    unsigned ace$v_statistics : 1; /* statistics monitoring enabled on this file */
			    unsigned ace$v_xlate_dec  : 1; /* file semantics are DEC-local */
			    unsigned		      : 6;
			} ace$r_rmsatr_flags_bits;
		    } ace$r_rmsatr_flags_overlay;
		} ace$r_rmsatr_type;
	    } ace$r_info_data;
	} ace$r_info_type;
	struct {				/* used for all 5 RMSJNL_xxx ACEs */
	    char ace$t_volnam[12];		/* volume name of journal file */
	    unsigned char ace$b_volnam_len;	/* length of volume name of journal file */
	    unsigned char ace$b_rjrver;		/* RMS journal file structure level */
	    union {				/* file-id of journal file */
		unsigned short ace$w_fid[3];	/* file id */
		struct {
		    unsigned short ace$w_fid_num; /* file number */
		    unsigned short ace$w_fid_seq; /* sequence number */
		    union {
			unsigned short ace$w_fid_rvn; /* relative volume number */
			struct {
			    unsigned char ace$b_fid_rvn; /* alternate format RVN */
			    unsigned char ace$b_fid_nmx; /* alternate format file number extension */
			} ace$r_fid_rvn_fields;
		    } ace$r_fid_rvn_overlay;
		} ace$r_fid_fields;
	    } ace$r_fid_overlay;
	    union {
		unsigned short ace$w_rmsjnl_flags;
		struct {
		    unsigned ace$v_journal_disabled : 1; /* journaling disabled (AI, BI, AT only; set by BACKUP) */
		    unsigned ace$v_backup_done : 1;	 /* BACKUP done on this file; RMS -*/
			/* needs to write a backup marker (AI, BI, AT only; set by BACKUP) */
		    unsigned		       : 6;
		} ace$r_rmsjnl_flags_bits;
	    } ace$r_rmsjnl_flags_overlay;
	    unsigned long ace$l_jnlidx;		/* journal stream index number */
	    unsigned int ace$q_cdate[2];	/* creation date/time of journal */
	    unsigned long ace$l_backup_seqno;	/* BACKUP sequence number (to find where to start in journal). */
	    unsigned int ace$q_modification_time[2]; /* timestamp of last backup or last journal entry recovered. */
	} ace$r_rmsjnl_type;
	struct {
	    unsigned long ace$l_spare1;		/* for alignment */
	    unsigned long ace$l_sys_prot;	/* default system protection */
	    unsigned long ace$l_own_prot;	/* default owner protection */
	    unsigned long ace$l_grp_prot;	/* default group protection */
	    unsigned long ace$l_wor_prot;	/* default world protection */
	} ace$r_dirdef_type;
	struct {				/* protected subsystem ACE type */
	    unsigned long ace$l_spare2;		/* for alignment */
	    unsigned int ace$q_image_ids[2];	/* start of the image ids (a quadword for each identifier) */
	} ace$r_image_id_type;
	struct {				/* Object Information Label */
	    unsigned long ace$l_oil_flags;	/* for alignment */
	    unsigned long ace$l_brand_name;	/* OIL type-specific Info */
	    char ace$r_class_prot;		/* OIL class block */
	} ace$r_oil_type;
    } ace$r_ace_fields;
};

#endif	/*_ACEDEF_H*/
