/* <armdef.h>
 *
 *	Access Rights Mask longword definitions
 */
#ifndef _ARMDEF_H
#define _ARMDEF_H

#define ARM$V_READ	0
#define ARM$V_WRITE	1
#define ARM$V_EXECUTE	2
#define ARM$V_DELETE	3
#define ARM$V_CONTROL	4
#define ARM$M_READ	(1<<ARM$V_READ)		/* 0x01 */
#define ARM$M_WRITE	(1<<ARM$V_WRITE)	/* 0x02 */
#define ARM$M_EXECUTE	(1<<ARM$V_EXECUTE)	/* 0x04 */
#define ARM$M_DELETE	(1<<ARM$V_DELETE)	/* 0x08 */
#define ARM$M_CONTROL	(1<<ARM$V_CONTROL)	/* 0x10 */
#define ARM$V_CREATE	2
#define ARM$M_CREATE	(1<<ARM$V_CREATE)	/* 0x04 */
#define ARM$V_LOCK	2
#define ARM$M_LOCK	(1<<ARM$V_LOCK)		/* 0x04 */
#define ARM$V_PHYSICAL	2
#define ARM$V_LOGICAL	3
#define ARM$M_PHYSICAL	(1<<ARM$V_PHYSICAL)	/* 0x04 */
#define ARM$M_LOGICAL	(1<<ARM$V_LOGICAL)	/* 0x08 */
#define ARM$V_ASSOCIATE 0
#define ARM$M_ASSOCIATE (1<<ARM$V_ASSOCIATE)	/* 0x01 */
#define ARM$V_SUBMIT	1
#define ARM$V_MANAGE	2
#define ARM$M_SUBMIT	(1<<ARM$V_SUBMIT)	/* 0x02 */
#define ARM$M_MANAGE	(1<<ARM$V_MANAGE)	/* 0x04 */
#define ARM$V_USE	0
#define ARM$M_USE	(1<<ARM$V_USE)		/* 0x01 */

#ifndef NO_VMS_V6
union armdef {
    unsigned long arm$l_file_access;
    struct {
	unsigned arm$v_read	: 1;	/* read access */
	unsigned arm$v_write	: 1;	/* write access */
	unsigned arm$v_execute	: 1;	/* execute access */
	unsigned arm$v_delete	: 1;	/* delete access */
	unsigned arm$v_control	: 1;	/* control access */
	unsigned arm$v_fill	: 27;
    } arm$r_file_access_bits;
    unsigned long arm$l_volume_access;
    struct {
	unsigned		: 2;
	unsigned arm$v_create	: 1;	/* create access (volume) */
	unsigned		: 29;
    } arm$r_volume_access_bits;
    unsigned long arm$l_rsdm_access;
    struct {
	unsigned		: 2;
	unsigned arm$v_lock	: 1;	/* lock access (resource domain) */
	unsigned		: 29;
    } arm$r_rsdm_access_bits;
    unsigned long arm$l_device_access;
    struct {
	unsigned		: 2;
	unsigned arm$v_physical : 1;	/* physical I/O access (device) */
	unsigned arm$v_logical	: 1;	/* logical I/O access (device) */
	unsigned		: 28;
    } arm$r_device_access_bits;
    unsigned long arm$l_ceb_access;
    struct {
	unsigned arm$v_associate : 1;	/* associate access (common event cluster) */
	unsigned		: 31;
    } arm$r_ceb_access_bits;
    unsigned long arm$l_queue_access;
    struct {
	unsigned		: 1;
	unsigned arm$v_submit	: 1;	/* submit access (queue) */
	unsigned arm$v_manage	: 1;	/* manage access (queue) */
	unsigned		: 29;
    } arm$r_queue_access_bits;
    unsigned long arm$l_cap_access;
    struct {
	unsigned arm$v_use	: 1;	/* use access (capability) */
	unsigned		: 31;
    } arm$r_cap_access_bits;
};
#else
struct armdef {
    unsigned arm$v_read    : 1;		/* read access */
    unsigned arm$v_write   : 1;		/* write access */
    unsigned arm$v_execute : 1;		/* execute access */
    unsigned arm$v_delete  : 1;		/* delete access */
    unsigned arm$v_control : 1;		/* control access (modify attributes) */
    unsigned arm$v_fill    : 27;
};
#endif

#endif	/*_ARMDEF_H*/
