/* <brkdef.h>
 *
 *	Breakthru system service input definitions.
 */
#ifndef _BRKDEF_H
#define _BRKDEF_H

/* send-type codes */
#define BRK$C_DEVICE	1		/* device name */
#define BRK$C_USERNAME	2		/* user name */
#define BRK$C_ALLUSERS	3		/* all logged in users */
#define BRK$C_ALLTERMS	4		/* all terminals */
#define BRK$C_MAXSENDTYPE 4

/* Requestor ID's, DEC use only (0-31) */
#define BRK$C_GENERAL	0		/* general (or unspecified) */
#define BRK$C_PHONE	1		/* phone */
#define BRK$C_MAIL	2		/* mail */
#define BRK$C_QUEUE	3		/* queue manager */
#define BRK$C_SHUTDOWN	4		/* system shutdown */
#define BRK$C_URGENT	5		/* urgent message */
#define BRK$C_DCL	6		/* DCL (control T) */
#define BRK$C_OPCOM	7		/* operator message */
/* Note that only first 16 are really stored by TTDRIVER now */
#define BRK$C_USER1 32			/* reserved to customer */
#define BRK$C_USER2 33			/* " */
#define BRK$C_USER3 34
#define BRK$C_USER4 35
#define BRK$C_USER5 36
#define BRK$C_USER6 37
#define BRK$C_USER7 38
#define BRK$C_USER8 39
#define BRK$C_USER9 40
#define BRK$C_USER10 41
#define BRK$C_USER11 42
#define BRK$C_USER12 43
#define BRK$C_USER13 44
#define BRK$C_USER14 45
#define BRK$C_USER15 46
#define BRK$C_USER16 47

#define BRK$V_SCREEN		8
#define BRK$V_BOTTOM		9
#define BRK$V_NOREFRESH		10
#define BRK$V_CLUSTER		11
#define BRK$V_REMOTENODE	12
#define BRK$V_PROVIDE_COUNTS	13
#define BRK$V_CSID		14
#define BRK$M_SCREEN		(1<<BRK$V_SCREEN)		/* 0x0100 */
#define BRK$M_BOTTOM		(1<<BRK$V_BOTTOM)		/* 0x0200 */
#define BRK$M_NOREFRESH		(1<<BRK$V_NOREFRESH)		/* 0x0400 */
#define BRK$M_CLUSTER		(1<<BRK$V_CLUSTER)		/* 0x0800 */
#define BRK$M_REMOTENODE	(1<<BRK$V_REMOTENODE)		/* 0x1000 */
#define BRK$M_PROVIDE_COUNTS	(1<<BRK$V_PROVIDE_COUNTS)	/* 0x2000 */
#define BRK$M_CSID		(1<<BRK$V_CSID)			/* 0x4000 */
struct brk$flags_input {		/* mimics $BRDCSTDEF */
    unsigned brk$v_erase_lines	: 8;	/* number of lines to erase */
    unsigned brk$v_screen	: 1;	/* do screen formatted write */
    unsigned brk$v_bottom	: 1;	/* "screen" message at bottom */
    unsigned brk$v_norefresh	: 1;	/* refresh an interrupted read */
    unsigned brk$v_cluster	: 1;	/* broadcast to cluster */
    unsigned brk$v_remotenode	: 1;	/* specified remote target node */
    unsigned brk$v_provide_counts : 1;	/* return information in IOSB about */
					/* number of terminals notified     */
    unsigned brk$v_csid		: 1;	/* remote node is really a node CSID */
    unsigned			: 1;
};

#endif	/*_BRKDEF_H*/
