/* <cliservdef.h>
 *
 *	CLI callback service request definitions.
 */
#ifndef _CLISERVDEF_H
#define _CLISERVDEF_H

/* Define CLI service codes */
#define CLI$K_PAUSE	1	/* pause the image */
#define CLI$K_DEFLOCAL	2	/* define a symbol in the local table */
#define CLI$K_DEFGLOBAL 3	/* define a symbol in the global table */
#define CLI$K_CHAIN	4	/* pass an image to run after this one */
#define CLI$K_COMMAND	5	/* pass a command line to later execute */
#define CLI$K_CREALOG	6	/* define a process logical name */
#define CLI$K_DELELOG	7	/* delete a process logical name */
#define CLI$K_DISACTRLY 8	/* disable DCL control Y processing */
#define CLI$K_ENABCTRLY 9	/* enable DCL control Y processing */
#define CLI$K_GETSYM	10	/* return value of a symbol */
#define CLI$K_DELELCL	11	/* delete a local symbol */
#define CLI$K_DELEGBL	12	/* delete a global symbol */
#define CLI$K_DISAOOB	13	/* disable out-of-band character(s) */
#define CLI$K_ENABOOB	14	/* re-enable out-of-band character(s) */
#define CLI$K_SPAWN	15	/* spawn a subprocess */
#define CLI$K_ATTACH	16	/* attach to a process */
#define CLI$K_LIBDEFLOCAL  17	/* define a symbol in local table using lib$set_symbol */
#define CLI$K_LIBDEFGLOBAL 18	/* define a symbol in global table using lib$set_symbol */
#define CLI$K_LIBGETSYM 19	/* get a symbol value using lib$get_symbol */
#define CLI$K_LIBDELELCL 20	/* delete a symbol using lib$delete_symbol */
#define CLI$K_LIBDELEGBL 21	/* delete a global symbol using lib$delete_symbol */
#define CLI$K_SETCODESET 22	/* set code set */

/* Define local/global symbol flag returned by GETSYM */
#define CLI$K_LOCAL_SYM 1	/* Local symbol */
#define CLI$K_GLOBAL_SYM 2	/* Global symbol */

#endif	/*_CLISERVDEF_H*/
