/* <cqualdef.h>
 *
 *	"Common" DCL qualifiers
 */
#ifndef _CQUALDEF_H
#define _CQUALDEF_H

/*
   Note:  the VMS routines that use these are not included in the
   run-time library.
 */
#define LIB$V_CQF_CONFIRM	0
#define LIB$V_CQF_EXCLUDE	1
#define LIB$V_CQF_BEFORE	2
#define LIB$V_CQF_SINCE		3
#define LIB$V_CQF_CREATED	4
#define LIB$V_CQF_MODIFIED	5
#define LIB$V_CQF_EXPIRED	6
#define LIB$V_CQF_BACKUP	7
#define LIB$V_CQF_BYOWNER	8
#define LIB$M_CQF_CONFIRM	(1<<LIB$V_CQF_CONFIRM)		/* 0x01 */
#define LIB$M_CQF_EXCLUDE	(1<<LIB$V_CQF_EXCLUDE)		/* 0x02 */
#define LIB$M_CQF_BEFORE	(1<<LIB$V_CQF_BEFORE)		/* 0x04 */
#define LIB$M_CQF_SINCE		(1<<LIB$V_CQF_SINCE)		/* 0x08 */
#define LIB$M_CQF_CREATED	(1<<LIB$V_CQF_CREATED)		/* 0x10 */
#define LIB$M_CQF_MODIFIED	(1<<LIB$V_CQF_MODIFIED)		/* 0x20 */
#define LIB$M_CQF_EXPIRED	(1<<LIB$V_CQF_EXPIRED)		/* 0x40 */
#define LIB$M_CQF_BACKUP	(1<<LIB$V_CQF_BACKUP)		/* 0x80 */
#define LIB$M_CQF_BYOWNER	(1<<LIB$V_CQF_BYOWNER)		/* 0x0100 */

struct libcqualdef {
	    unsigned lib$v_cqf_confirm	: 1;
	    unsigned lib$v_cqf_exclude	: 1;
	    unsigned lib$v_cqf_before	: 1;
	    unsigned lib$v_cqf_since	: 1;
	    unsigned lib$v_cqf_created	: 1;
	    unsigned lib$v_cqf_modified : 1;
	    unsigned lib$v_cqf_expired	: 1;
	    unsigned lib$v_cqf_backup	: 1;
	    unsigned lib$v_cqf_byowner	: 1;
	    unsigned			: 23;
};

#endif	/*_CQUALDEF_H*/
