/* <cvtdef.h>
 *
 *	Floating point conversion definitions.
 */
#ifndef _CVTDEF_H
#define _CVTDEF_H

#define CVT$K_VAX_F	0	/* VAX F Floating point data */
#define CVT$K_VAX_D	1	/* VAX D Floating point data */
#define CVT$K_VAX_G	2	/* VAX G Floating point data */
#define CVT$K_VAX_H	3	/* VAX H Floating point data */
#define CVT$K_IEEE_S	4	/* IEEE S Floating point data */
#define CVT$K_IEEE_T	5	/* IEEE T Floating point data */
#define CVT$K_IBM_LONG	6	/* IBM Long Floating point data */
#define CVT$K_IBM_SHORT 7	/* IBM Short Floating point data */
#define CVT$K_CRAY	8	/* Cray Floating point data */
#define CVT$K_IEEE_X	9	/* IEEE X Floating point data */

#define CVT$V_ROUND_TO_NEAREST	0
#define CVT$V_TRUNCATE		1
#define CVT$V_ROUND_TO_POS	2
#define CVT$V_ROUND_TO_NEG	3
#define CVT$V_VAX_ROUNDING	4
#define CVT$V_BIG_ENDIAN	5
#define CVT$V_ERR_UNDERFLOW	6
#define CVT$M_ROUND_TO_NEAREST	(1<<CVT$V_ROUND_TO_NEAREST)	/* 0x01 */
#define CVT$M_TRUNCATE		(1<<CVT$V_TRUNCATE)		/* 0x02 */
#define CVT$M_ROUND_TO_POS	(1<<CVT$V_ROUND_TO_POS)		/* 0x04 */
#define CVT$M_ROUND_TO_NEG	(1<<CVT$V_ROUND_TO_NEG)		/* 0x08 */
#define CVT$M_VAX_ROUNDING	(1<<CVT$V_VAX_ROUNDING)		/* 0x10 */
#define CVT$M_BIG_ENDIAN	(1<<CVT$V_BIG_ENDIAN)		/* 0x20 */
#define CVT$M_ERR_UNDERFLOW	(1<<CVT$V_ERR_UNDERFLOW)	/* 0x40 */

struct cvt$r_conversion_options {
    unsigned cvt$v_round_to_nearest : 1;
    unsigned cvt$v_truncate	: 1;
    unsigned cvt$v_round_to_pos : 1;
    unsigned cvt$v_round_to_neg : 1;
    unsigned cvt$v_vax_rounding : 1;
    unsigned cvt$v_big_endian	: 1;
    unsigned cvt$v_err_underflow : 1;
    unsigned			: 25;	/* padding */
};

#endif	/*_CVTDEF_H*/
