/* <vms/lib/dqfdef.h>
 *
 *	F11DEF - disk quota record definitions		[not in Starlet]
 */
#ifndef _DQFDEF_H
#define _DQFDEF_H

/*
   Structure of disk quota file record. Each record contains the authorization
   and usage of a particular UIC for this volume set.
 */
#define DQF$V_ACTIVE	0
#define DQF$M_ACTIVE	(1<<DQF$V_ACTIVE)	/* 0x01 */
#define DQF$K_LENGTH	32
#define DQF$C_LENGTH	32
#define DQF$S_DQFDEF	32
struct dqfdef {
    union {
	unsigned long dqf$l_flags;	/* flags longword, containing... */
	struct {
	    unsigned dqf$v_active : 1;	/* record contains an active entry */
	    unsigned		  : 7;	/* padding */
	} dqf$r_flags_bits;
    } dqf$r_flags_overlay;
    unsigned long dqf$l_uic;		/* UIC of this record */
    unsigned long dqf$l_usage;		/* number of blocks in use */
    unsigned long dqf$l_permquota;	/* permanent disk quota */
    unsigned long dqf$l_overdraft;	/* overdraft limit */
};

#endif	/*_DQFDEF_H*/
