/* <dvidef.h>
 *
 * Get Device and Volume Information Data Identifier Definitions
 */
#ifndef _DVIDEF_H
#define _DVIDEF_H

#define DVI$_DEVCHAR	  2	/* device characteristics - VALUE - 4 bytes */
#define DVI$_DEVCLASS	  4	/* device class - VALUE - 1 byte */
#define DVI$_DEVTYPE	  6	/* device type - VALUE - 1 byte */
#define DVI$_DEVBUFSIZ	  8	/* device buffer size - VALUE - 2 bytes */
#define DVI$_DEVDEPEND	 10	/* device dependent information - VALUE - 4 bytes */
#define DVI$_UNIT	 12	/* unit number - VALUE - 4 bytes */
#define DVI$_PID	 14	/* process identification of device owner - VALUE - 4 bytes */
#define DVI$_OWNUIC	 16	/* UIC of device owner - VALUE - 4 bytes */
#define DVI$_VPROT	 18	/* volume protection mask - VALUE - 2 bytes */
#define DVI$_ERRCNT	 20	/* error count - VALUE - 2 bytes */
#define DVI$_OPCNT	 22	/* operation count - VALUE - 4 bytes */
#define DVI$_RECSIZ	 24	/* blocked record size - VALUE - 2 bytes */
#define DVI$_MAXBLOCK	 26	/* number of logical blocks on the volume (disk) - VALUE - 8 bytes */
#define DVI$_DEVDEPEND2  28	/* additional device dependent data - VALUE - 4 bytes */
#define DVI$_REFCNT	 30	/* reference count of processes - VALUE - 2 bytes */
#define DVI$_DEVNAM	 32	/* device name - STRING - 64 bytes */
#define DVI$_VOLNAM	 34	/* volume name - STRING - 12 bytes */
#define DVI$_SECTORS	 36	/* number of sectors per track (disk) - VALUE - 1 byte */
#define DVI$_TRACKS	 38	/* number of tracks per cylinder (disk) - VALUE - 1 byte */
#define DVI$_CYLINDERS	 40	/* number of cylinders on the volume (disk) - VALUE - 2 bytes */
#define DVI$_FREEBLOCKS  42	/* number of free blocks on the volume (disk) - VALUE - 4 bytes */
#define DVI$_LOGVOLNAM	 44	/* logical volume name - STRING - 64 bytes */
#define DVI$_VOLNUMBER	 46	/* number of this volume in volume set (disk) - VALUE - 4 byte */
#define DVI$_VOLCOUNT	 48	/* count of volumes in volume set (disk) - VALUE - 4 byte */
#define DVI$_ROOTDEVNAM  50	/* device name of root volume in volume set (disk) - STRING - 64 bytes */
#define DVI$_NEXTDEVNAM  52	/* device name of next volume in volume set (disk) - STRING - 64 bytes */
#define DVI$_TRANSCNT	 54	/* volume transaction count - VALUE - 2 bytes */
#define DVI$_MOUNTCNT	 56	/* mount count - VALUE - 2 bytes */
#define DVI$_CLUSTER	 58	/* volume cluster size (disk) - VALUE - 2 bytes */
#define DVI$_MAXFILES	 60	/* maximum files on volume (disk) - VALUE - 4 bytes */
#define DVI$_SERIALNUM	 62	/* volume serial number (disk) - VALUE - 4 bytes */
#define DVI$_ACPPID	 64	/* ACP process ID - VALUE - 4 bytes */
#define DVI$_ACPTYPE	 66	/* ACP type code - VALUE - 1 byte */
#define DVI$_CONCEALED	 68	/* device is a concealed device - BOOLEAN - 1 byte */
/* The following codes are the individual bits of the devchar longword. */
#define DVI$_REC	 70	/* device record oriented */
#define DVI$_CCL	 72	/* carriage control device */
#define DVI$_TRM	 74	/* device is a terminal */
#define DVI$_DIR	 76	/* device is directory structured */
#define DVI$_SDI	 78	/* device is single directory structured */
#define DVI$_SQD	 80	/* sequential block-oriented device (ie, magtape) */
#define DVI$_SPL	 82	/* device being spooled */
#define DVI$_OPR	 84	/* device is an operator */
#define DVI$_RCT	 86	/* disk contains RCT (DEC standard 166 disk) */
#define DVI$_NET	 88	/* network device */
#define DVI$_FOD	 90	/* files-oriented device (ie, disk and mt) */
#define DVI$_DUA	 92	/* device is dual ported */
#define DVI$_SHR	 94	/* device shareable */
#define DVI$_GEN	 96	/* device is a generic device */
#define DVI$_AVL	 98	/* device available for use */
#define DVI$_MNT	100	/* device is mounted */
#define DVI$_MBX	102	/* device is a mailbox */
#define DVI$_DMT	104	/* device marked for dismount */
#define DVI$_ELG	106	/* device has error logging enabled */
#define DVI$_ALL	108	/* device is allocated */
#define DVI$_FOR	110	/* device is mounted foreign (ie, non-file structured) */
#define DVI$_SWL	112	/* device is software write locked */
#define DVI$_IDV	114	/* device capable of providing input */
#define DVI$_ODV	116	/* device capable of providing output */
#define DVI$_RND	118	/* device allows random access */
#define DVI$_RTM	120	/* device is realtime in nature */
#define DVI$_RCK	122	/* device has read checking enabled */
#define DVI$_WCK	124	/* device has write checking enabled */
/* The following codes are the individual bits of the devdepend longword */
/* (as defined for terminals in $TTDEF).				 */
#define DVI$_TT_PASSALL		126
#define DVI$_TT_NOECHO		128
#define DVI$_TT_NOTYPEAHD	130
#define DVI$_TT_ESCAPE		132
#define DVI$_TT_HOSTSYNC	134
#define DVI$_TT_TTSYNC		136
#define DVI$_TT_SCRIPT		138
#define DVI$_TT_LOWER		140
#define DVI$_TT_MECHTAB		142
#define DVI$_TT_WRAP		144
#define DVI$_TT_CRFILL		146
#define DVI$_TT_LFFILL		148
#define DVI$_TT_SCOPE		150
#define DVI$_TT_REMOTE		152
#define DVI$_TT_EIGHTBIT	154
#define DVI$_TT_MBXDSABL	156
#define DVI$_TT_NOBRDCST	158
#define DVI$_TT_READSYNC	160
#define DVI$_TT_MECHFORM	162
#define DVI$_TT_HALFDUP		164
#define DVI$_TT_MODEM		166
#define DVI$_TT_OPER		168
#define DVI$_TT_PAGE		170
/* The following codes are the individual bits of the devdepend2 longword */
/* (as defined for terminals in $TT2DEF).				  */
#define DVI$_TT_LOCALECHO	172
#define DVI$_TT_AUTOBAUD	174
#define DVI$_TT_HANGUP		176
#define DVI$_TT_MODHANGUP	178
#define DVI$_TT_BRDCSTMBX	180
#define DVI$_TT_DMA		182
#define DVI$_TT_ALTYPEAHD	184
#define DVI$_TT_SETSPEED	186
#define DVI$_TT_DCL_MAILBX	188	/* temp definitions for DCL spawn */
#define DVI$_TT_EDITING		190
#define DVI$_TT_INSERT		192
#define DVI$_TT_FALLBACK	194
#define DVI$_TT_DIALUP		196
#define DVI$_TT_SECURE		198
#define DVI$_TT_DISCONNECT	200
#define DVI$_TT_PASTHRU		202
#define DVI$_TT_SIXEL		204
#define DVI$_TT_DRCS		206
#define DVI$_TT_PRINTER		208
#define DVI$_TT_APP_KEYPAD	210
#define DVI$_TT_SYSPWD		212
#define DVI$_TT_ANSICRT		214
#define DVI$_TT_REGIS		216
#define DVI$_TT_BLOCK		218
#define DVI$_TT_AVO		220
#define DVI$_TT_EDIT		222
#define DVI$_TT_DECCRT		224
/* The following codes are regular items. */
#define DVI$_STS		226	/* status longword */
#define DVI$_DEVSTS		228	/* device status word */
#define DVI$_DEVCHAR2		230	/* second device characteristics longword - VALUE - 4 bytes */
#define DVI$_FULLDEVNAM		232	/* fully qualified device name */
#define DVI$_LOCKID		234	/* device lock id - VALUE - 4 bytes */
#define DVI$_ALLDEVNAM		236	/* allocation class + device name */
#define DVI$_VOLSETMEM		238	/* volume set member */
#define DVI$_DEVLOCKNAM		240	/* device lock name */
/* The following codes support features of dual-path and shadow-set devices. */
#define DVI$_ALLOCLASS		242	/* allocation class of host(s) */
#define DVI$_ALT_HOST_AVAIL	244	/* alternate host is active */
#define DVI$_ALT_HOST_NAME	246	/* name of host serving alternate path */
#define DVI$_ALT_HOST_TYPE	248	/* type of alternate host */
#define DVI$_HOST_AVAIL		250	/* primary host is active */
#define DVI$_HOST_COUNT		252	/* number of paths to the device */
#define DVI$_HOST_NAME		254	/* name of host serving the primary path */
#define DVI$_HOST_TYPE		256	/* type of primary host (today one of "V785", "V780", "V750" or "HS50") */
#define DVI$_REMOTE_DEVICE	258	/* device is not connected to local node */
#define DVI$_SERVED_DEVICE	260	/* device is served to the cluster */
#define DVI$_SHDW_CATCHUP_COPYING 262	/* catch-up copy is in progress */
#define DVI$_SHDW_MASTER	264	/* device is "virtual" master device for shadow set */
#define DVI$_SHDW_MASTER_NAME	266	/* name of the "virtual" master device for a shadow set */
#define DVI$_SHDW_MEMBER	268	/* device is one of the volumes making a shadow set */
#define DVI$_SHDW_MERGE_COPYING 270	/* merge copy is in progress */
#define DVI$_SHDW_NEXT_MBR_NAME 272	/* name of the next device in shadow set */
/* The following codes are regular items. */
#define DVI$_TT_PHYDEVNAM	274	/* terminal physical device name - STRING - 64 bytes */
#define DVI$_TT_DECCRT2		276	/* DEC_CRT level 2 part of devdepend2 longword for terminals. */
#define DVI$_MEDIA_NAME		278	/* decoded media name from UCB$L_MEDIA_ID field (ie. RK07 ) */
#define DVI$_MEDIA_TYPE		280	/* decoded media type from UCB$L_MEDIA_ID field (ie. DM ) */
#define DVI$_MEDIA_ID		282	/* nondecoded media id from UCB$L_MEDIA_ID */
/* */
#define DVI$_SHDW_FAILED_MEMBER 284	/* member unit has been failed out from shadow set */
#define DVI$_MSCP_UNIT_NUMBER	286	/* MSCP unit number of device (internal */
					/*  hash value, not useful for customers or applications) */
#define DVI$_DISPLAY_DEVNAM	288	/* a displayable device name, useful for user */
					/*  displays but not for $ASSIGN */
#define DVI$_TT_ACCPORNAM	290	/* name of local port on remote system. -*/
					/*  Counted string in remote native format, ie: LAT, X.29 */
#define DVI$_DEVDEPEND3		292	/* device dependent longword 3 */
#define DVI$_TT_MULTISESSION	294	/* multi-session terminal */
#define DVI$_TT_DECCRT3		296	/* VT3xx series terminal */
#define DVI$_SET_HOST_TERMINAL	298	/* SET HOST session terminal */
#define DVI$_DFS_ACCESS		300	/* DFS client access point device */
#define DVI$_DAPDEVNAM		302	/* DAP device name, used to store the remote name string */
					/*  of a device that is accessed via the DAP protocol */
					/*  (without DECnet), such as certain console disks. */
#define DVI$_TT_DECCRT4		304	/* VT4xx series terminal */
#define DVI$_TT_CHARSET		306	/* terminal character set information */
/* The following codes are the individual bits of the TT_CHARSET longword */
/* in the terminal UCB (as defined in $TTCDEF).				  */
#define DVI$_TT_CS_KANA		308	/* Support Kana character set */
#define DVI$_TT_CS_KANJI	310	/* Support Kanji character set */
#define DVI$_TT_CS_HANZI	312	/* Support Hanzi character set */
#define DVI$_TT_CS_HANGUL	314	/* Support Hangul character set */
#define DVI$_TT_CS_HANYU	316	/* Support Hanyu character set */
#define DVI$_TT_CS_THAI		318	/* Support Thai character set */
/* The following codes are regular items */
#define DVI$_DEVDEPEND4		320	/* Device dependent longword 4 */
#define DVI$_DEVICE_TYPE_NAME	322	/* DDR Device type name */
#define DVI$_TT_ASIAN_MODE	324	/* Asian terminal I/O characteristics */

/* Define flag bits in the item code. */
#define DVI$V_SECONDARY  0
#define DVI$V_NOREDIRECT 15
#define DVI$M_SECONDARY  (1<<DVI$V_SECONDARY)	/* 0x01 */
#define DVI$M_NOREDIRECT (1<<DVI$V_NOREDIRECT)	/* 0x8000 */
struct dvidef {
    unsigned dvi$v_secondary	: 1;	/* use secondary device characteristics */
    unsigned dvi$v_item_code	: 14;	/* space for item code */
    unsigned dvi$v_noredirect	: 1;	/* don't redirect to virtual terminal */
};
/* Constant form of name for past compatibility. */
#define DVI$C_SECONDARY 1
/*
   The following ACP type codes are formally defined in $AQBDEF.
   These synonyms are available to user programs and they are
   guaranteed to be consistent by ASSUME's in SYSGETDEV.  Additions
   to the ACP type codes in $AQBDEF should be reflected here and
   in the ASSUMES in SYSGETDEV.
 */
#define DVI$C_ACP_F11V1 1	/* FILES-11 structure level 1 */
#define DVI$C_ACP_F11V2 2	/* FILES-11 structure level 2 */
#define DVI$C_ACP_MTA	3	/* magtape */
#define DVI$C_ACP_NET	4	/* networks */
#define DVI$C_ACP_REM	5	/* remote i/o */
#define DVI$C_ACP_HBS	6	/* host based shadowing */
#define DVI$C_ACP_F11V3 7	/* Files-11 presentation of ISO 9660 */
#define DVI$C_ACP_F11V4 8	/* Files-11 presentation of High Sierra */

#endif	/*_DVIDEF_H*/
