/* <egpsdef.h>
 *
 *	OBJFMT -- "EVAX" GSD entry - P-section definition
 */
#ifndef _EGPSDEF_H
#define _EGPSDEF_H

#define EGPS$V_PIC	0
#define EGPS$V_LIB	1
#define EGPS$V_OVR	2
#define EGPS$V_REL	3
#define EGPS$V_GBL	4
#define EGPS$V_SHR	5
#define EGPS$V_EXE	6
#define EGPS$V_RD	7
#define EGPS$V_WRT	8
#define EGPS$V_VEC	9
#define EGPS$V_NOMOD	10
#define EGPS$V_COM	11
#define EGPS$M_PIC	(1<<EGPS$V_PIC)		/* 0x0001 */
#define EGPS$M_LIB	(1<<EGPS$V_LIB)		/* 0x0002 */
#define EGPS$M_OVR	(1<<EGPS$V_OVR)		/* 0x0004 */
#define EGPS$M_REL	(1<<EGPS$V_REL)		/* 0x0008 */
#define EGPS$M_GBL	(1<<EGPS$V_GBL)		/* 0x0010 */
#define EGPS$M_SHR	(1<<EGPS$V_SHR)		/* 0x0020 */
#define EGPS$M_EXE	(1<<EGPS$V_EXE)		/* 0x0040 */
#define EGPS$M_RD	(1<<EGPS$V_RD)		/* 0x0080 */
#define EGPS$M_WRT	(1<<EGPS$V_WRT)		/* 0x0100 */
#define EGPS$M_VEC	(1<<EGPS$V_VEC)		/* 0x0200 */
#define EGPS$M_NOMOD	(1<<EGPS$V_NOMOD)	/* 0x0400 */
#define EGPS$M_COM	(1<<EGPS$V_COM)		/* 0x0800 */
#define EGPS$K_NAME	12
#define EGPS$C_NAME	12
struct egpsdef {
    unsigned short egps$w_gsdtyp;	/*typ field */
    unsigned short egps$w_size;		/* size of this EGPS */
    unsigned char egps$b_align;		/* P-sect alignment */
    unsigned char egps$b_temp;		/* pad for aligning */
    union {
	unsigned short egps$w_flags;	/* P-sect flags */
	struct {
	    unsigned egps$v_pic : 1;	/* position independent */
	    unsigned egps$v_lib : 1;	/* from a shareable image */
	    unsigned egps$v_ovr : 1;	/* overlaid memory allocation */
	    unsigned egps$v_rel : 1;	/* relocatable */
	    unsigned egps$v_gbl : 1;	/* global scope */
	    unsigned egps$v_shr : 1;	/* shareable */
	    unsigned egps$v_exe : 1;	/* executable */
	    unsigned egps$v_rd	: 1;	/* readable */
	    unsigned egps$v_wrt : 1;	/* writeable */
	    unsigned egps$v_vec : 1;	/* vector psect */
	    unsigned egps$v_nomod : 1;	/* not stored into */
	    unsigned egps$v_com : 1;	/* associated with COMM sym */
	    unsigned		: 4;
	} egps$r_flags_bits;
    } egps$r_flags_overlay;
    unsigned long egps$l_alloc;		/* length of this contribution */
    unsigned char egps$b_namlng;	/* length of p-sect name */
    char egps$t_name[31];		/* name field */
};

#endif	/*_EGPSDEF_H*/
