/* <vms/lib/fjndef.h>
 *
 *	F11DEF - file journal control bit definitions	[not in Starlet]
 */
#ifndef _FJNDEF_H
#define _FJNDEF_H

/*
   File journal control bit definitions. These are identical to, and must
   track, the bits in JOURNAL of $FH2DEF, but are defined relative to the
   journal control byte instead of relative to the file header.
 */
#define FJN$V_ONLY_RU		0
#define FJN$V_RUJNL		1
#define FJN$V_BIJNL		2
#define FJN$V_AIJNL		3
#define FJN$V_ATJNL		4
#define FJN$V_NEVER_RU		5
#define FJN$V_JOURNAL_FILE	6
#define FJN$M_ONLY_RU		(1<<FJN$V_ONLY_RU)	/* 0x01 */
#define FJN$M_RUJNL		(1<<FJN$V_RUJNL)	/* 0x02 */
#define FJN$M_BIJNL		(1<<FJN$V_BIJNL)	/* 0x04 */
#define FJN$M_AIJNL		(1<<FJN$V_AIJNL)	/* 0x08 */
#define FJN$M_ATJNL		(1<<FJN$V_ATJNL)	/* 0x10 */
#define FJN$M_NEVER_RU		(1<<FJN$V_NEVER_RU)	/* 0x20 */
#define FJN$M_JOURNAL_FILE	(1<<FJN$V_JOURNAL_FILE) /* 0x40 */

#define FJN$S_FJNDEF	1
struct fjndef {
    unsigned fjn$v_only_ru	: 1;	/* file is accessible only in recovery unit */
    unsigned fjn$v_rujnl	: 1;	/* enable recovery unit journal */
    unsigned fjn$v_bijnl	: 1;	/* enable before image journal */
    unsigned fjn$v_aijnl	: 1;	/* enable after image journal */
    unsigned fjn$v_atjnl	: 1;	/* enable audit trail journal */
    unsigned fjn$v_never_ru	: 1;	/* file is never accessible in recovery unit */
    unsigned fjn$v_journal_file : 1;	/* this is a journal file */
    unsigned			: 1;	/* padding */
};

#endif	/*_FJNDEF_H*/
