/* <vms/lib/hdrdef.h>
 *
 *	LIB - ANSI header label definitions		[not in Starlet]
 */
#ifndef _HDRDEF_H
#define _HDRDEF_H

#ifndef _HD1DEF_H
#define _HD1DEF_H
/*
   HDR1 ANDSI magnetic tape label
   This is the first label in the file label header set.
   It identifies the file.
 */
#define HD1$S_HD1DEF	80
#define HD1$S_FILEID	17
#define HD1$S_FILESETID 6
#define HD1$S_FILESECNO 4
#define HD1$S_FILESEQNO 4
#define HD1$S_GENNO	4
#define HD1$S_GENVER	2
#define HD1$S_CREATEDT	6
#define HD1$S_EXPIREDT	6
#define HD1$S_BLOCKCNT	6
#define HD1$S_SYSCODE	13
struct hd1def {
    unsigned long hd1$l_hd1lid;		/* label identifier and number 'HDR1' */
    char hd1$t_fileid[17];		/* file identifier */
    char hd1$t_filesetid[6];		/* file set identifier */
    char hd1$t_filesecno[4];		/* file section number */
    char hd1$t_fileseqno[4];		/* file sequence number */
    char hd1$t_genno[4];		/* file generation number */
    char hd1$t_genver[2];		/* file generation version number */
    char hd1$t_createdt[6];		/* creation date ( yyddd) */
    char hd1$t_expiredt[6];		/* expiration date */
    unsigned char hd1$b_filaccess;	/* file access */
    char hd1$t_blockcnt[6];		/* block count */
    char hd1$t_syscode[13];		/* system code */
    char hd1def$$_fill[7];
};
#endif	/*_HD1DEF_H*/


#ifndef _HD2DEF_H
#define _HD2DEF_H
/*
   HDR2 ANSI magnetic tape label
   This is the second label in file label header set.
   The file attributes have been removed from HDR2, and placed in HDR3.
   The fields remain in the definition to support old tapes.
 */
#define HD2$S_HD2DEF	72
#define HD2$S_BLOCKLEN	5
#define HD2$S_RECLEN	5
#define HD2$S_RECATR1	20
#define HD2$S_RECATR2	12
#define HD2$S_BUFOFF	2
struct hd2def {
    unsigned long hd2$l_hd2lid;		/* label identifier and number 'HDR2' */
    unsigned char hd2$b_recformat;	/* record format */
    char hd2$t_blocklen[5];		/* block length */
    char hd2$t_reclen[5];		/* record length */
    char hd2$t_recatr1[20];		/* first 20 bytes of FILES-11 record attributes */
    unsigned	: 8;			/* char fill; */
    unsigned char hd2$b_formcntrl;	/* forms control */
    char hd2$t_recatr2[12];		/* last 12 bytes of FILES-11 record attributes */
    unsigned	: 8;			/* char fill; */
    char hd2$t_bufoff[2];		/* buffer offset */
    char hd2def$$_fill[20];
};
#endif	/*_HD2DEF_H*/


#ifndef _HD3DEF_H
#define _HD3DEF_H
/*
   HDR3 ANSI magnetic tape label
   This is the third label in file label header set.
   It identifies the file attributes.
 */
#define HD3$S_HD3DEF	80
#define HD3$S_RECATR	64
struct hd3def {
    unsigned long hd3$l_hd3lid;		/* label identifies and number 'HDR3' */
    char hd3$t_recatr[64];		/* 64 bytes of FILEs-11 record attributes */
    char hd3def$$_fill[12];
};
#endif	/*_HD3DEF_H*/


#ifndef _HD4DEF_H
#define _HD4DEF_H
/*
   HDR4 ANSI magnetic tape label
   This is the fourth label in file label header set.
   It contains the long filename extension to the HDR1 file identifier
   for VMS long file names.
 */
#define HD4$S_HD4DEF	82
#define HD4$S_FILEID_EXT	62
#define HD4$S_FILEID_EXT_V3	2
struct hd4def {
    unsigned long hd4$l_hd4lid;		/* label identifier and number 'HDR4' */
    unsigned char hd4$b_fileid_ext_size; /* size of file id ext for ANSI 4 volumes */
    char hd4$t_fileid_ext[62];		/* extension of HDR1 fileid */
    char hd4$t_fileid_ext_v3[2];	/* size of file id ext for ANSI 3 volumes */
    char hd4def$$_fill[13];
};
#endif	/*_HD4DEF_H*/

#endif	/*_HDRDEF_H*/
