/* <iacdef.h>
 *
 * Image activation control flags
 */
#ifndef _IACDEF_H
#define _IACDEF_H

#define IAC$V_NOACT	0
#define IAC$V_WRITABLE	1
#define IAC$V_SHAREABLE 2
#define IAC$V_PRIVILEGE 3
#define IAC$V_MERGE	4
#define IAC$V_EXPREG	5
#define IAC$V_P1MERGE	6
#define IAC$V_PARANOID	7
#define IAC$V_LASTCLU	8
#define IAC$V_LIM	9
#define IAC$V_RETRY	10
#define IAC$V_NOCMKRNL	11
#define IAC$V_SEQDEVLOD 12
#define IAC$V_XLINKER	13
#define IAC$V_KP_RESHDR 14
#define IAC$V_IS_RESHDR 15
#define IAC$V_NOTSHARED 16
#define IAC$V_GBLCLUSTR 17
#define IAC$V_SHMIDENT	18
#define IAC$V_NOCOPY	19
#define IAC$V_P1MERG_P0 20
#define IAC$V_SETVECTOR 21
#define IAC$V_PROTECTED 22
#define IAC$M_NOACT	(1<<IAC$V_NOACT)	/* 0x01 */
#define IAC$M_WRITABLE	(1<<IAC$V_WRITABLE)	/* 0x02 */
#define IAC$M_SHAREABLE (1<<IAC$V_SHAREABLE)	/* 0x04 */
#define IAC$M_PRIVILEGE (1<<IAC$V_PRIVILEGE)	/* 0x08 */
#define IAC$M_MERGE	(1<<IAC$V_MERGE)	/* 0x10 */
#define IAC$M_EXPREG	(1<<IAC$V_EXPREG)	/* 0x20 */
#define IAC$M_P1MERGE	(1<<IAC$V_P1MERGE)	/* 0x40 */
#define IAC$M_PARANOID	(1<<IAC$V_PARANOID)	/* 0x80 */
#define IAC$M_LASTCLU	(1<<IAC$V_LASTCLU)	/* 0x0100 */
#define IAC$M_LIM	(1<<IAC$V_LIM)		/* 0x0200 */
#define IAC$M_RETRY	(1<<IAC$V_RETRY)	/* 0x0400 */
#define IAC$M_NOCMKRNL	(1<<IAC$V_NOCMKRNL)	/* 0x0800 */
#define IAC$M_SEQDEVLOD (1<<IAC$V_SEQDEVLOD)	/* 0x1000 */
#define IAC$M_XLINKER	(1<<IAC$V_XLINKER)	/* 0x2000 */
#define IAC$M_KP_RESHDR (1<<IAC$V_KP_RESHDR)	/* 0x4000 */
#define IAC$M_IS_RESHDR (1<<IAC$V_IS_RESHDR)	/* 0x8000 */
#define IAC$M_NOTSHARED (1<<IAC$V_NOTSHARED)	/* 0x010000 */
#define IAC$M_GBLCLUSTR (1<<IAC$V_GBLCLUSTR)	/* 0x020000 */
#define IAC$M_SHMIDENT	(1<<IAC$V_SHMIDENT)	/* 0x040000 */
#define IAC$M_NOCOPY	(1<<IAC$V_NOCOPY)	/* 0x080000 */
#define IAC$M_P1MERG_P0 (1<<IAC$V_P1MERG_P0)	/* 0x100000 */
#define IAC$M_SETVECTOR (1<<IAC$V_SETVECTOR)	/* 0x200000 */
#define IAC$M_PROTECTED (1<<IAC$V_PROTECTED)	/* 0x400000 */
#define IAC$C_LARGEST 6			/*largest flag caller may specify */
union iacdef {
    struct {
	unsigned iac$v_noact	 : 1;	/*do not activate the image (for install) */
	unsigned iac$v_writable  : 1;	/*make image file writable */
	unsigned iac$v_shareable : 1;	/*act. shareable image for executable img */
	unsigned iac$v_privilege : 1;	/*act. share. img for priv executable img */
	unsigned iac$v_merge	 : 1;	/*act 2nd executable img into adr space */
	unsigned iac$v_expreg	 : 1;	/*map image into next free va space */
	unsigned iac$v_p1merge	 : 1;	/*P1 merged activation (legal input flag) */
	unsigned iac$v_paranoid  : 1;	/*go into paranoia mode */
	unsigned iac$v_lastclu	 : 1;	/*last cluster flag */
	unsigned iac$v_lim	 : 1;	/*linkable image */
	unsigned iac$v_retry	 : 1;	/*retry image activation */
	unsigned iac$v_nocmkrnl  : 1;	/*shut off cmkrnl,cmexec-sysver diff */
	unsigned iac$v_seqdevlod : 1;	/*loading from sequential device (net) */
	unsigned iac$v_xlinker	 : 1;	/*cross linker format */
	unsigned iac$v_kp_reshdr : 1;	/*make image header resident */
	unsigned iac$v_is_reshdr : 1;	/*image header is resident */
	unsigned iac$v_notshared : 1;	/*do not set is_shared in kfi entry */
	unsigned iac$v_gblclustr : 1;	/*currently processing gbl isd cluster */
	unsigned iac$v_shmident  : 1;	/*shared memory ident used for gbl sec */
	unsigned iac$v_nocopy	 : 1;	/*no private copy of section in exec img */
	unsigned iac$v_p1merg_p0 : 1;	/*P1 merged activation with P0 address */
					/* range (internal flag only) */
	unsigned iac$v_setvector : 1;	/*signal atlernate entry to set vectors */
	unsigned iac$v_protected : 1;	/*require shareables be /protected */
	unsigned		 : 1;
	unsigned		 : 8;	/* padding */
    } iac$r_iacdef_bits;
};

#endif	/*_IACDEF_H*/
