/* <ladef.h>
 *
 *	LPA-11 characteristics definitions
 */
#ifndef _LADEF_H
#define _LADEF_H

/* microcode type values */
#define LA$K_MRMCODE	1	/* multirequest microcode */
#define LA$K_ADMCODE	2	/* dedicated A/D microcode */
#define LA$K_DAMCODE	3	/* dedicated D/A microcode */
#define LA$V_MCVALID	0
#define LA$M_MCVALID	(1<<LA$V_MCVALID)	/* 0x01 */
#define LA$V_CLOCKA	3
#define LA$V_CLOCKB	4
#define LA$V_AD1	5
#define LA$V_AD2	6
#define LA$V_DA		7
#define LA$V_DIO1	8
#define LA$V_DIO2	9
#define LA$V_DIO3	10
#define LA$V_DIO4	11
#define LA$V_DIO5	12
#define LA$M_CLOCKA	(1<<LA$V_CLOCKA)	/* 0x08 */
#define LA$M_CLOCKB	(1<<LA$V_CLOCKB)	/* 0x10 */
#define LA$M_AD1	(1<<LA$V_AD1)		/* 0x20 */
#define LA$M_AD2	(1<<LA$V_AD2)		/* 0x40 */
#define LA$M_DA		(1<<LA$V_DA)		/* 0x80 */
#define LA$M_DIO1	(1<<LA$V_DIO1)		/* 0x0100 */
#define LA$M_DIO2	(1<<LA$V_DIO2)		/* 0x0200 */
#define LA$M_DIO3	(1<<LA$V_DIO3)		/* 0x0400 */
#define LA$M_DIO4	(1<<LA$V_DIO4)		/* 0x0800 */
#define LA$M_DIO5	(1<<LA$V_DIO5)		/* 0x1000 */
#define LA$V_BFROVRN	23
#define LA$M_BFROVRN	(1<<LA$V_BFROVRN)	/* 0x800000 */
union ladef {
    struct {
	unsigned la$v_mcvalid : 1;	/* microcode valid */
	unsigned la$v_mctype  : 2;	/* microcode type */
	unsigned la$v_config  : 10;	/* device configuration bits */
	unsigned la$v_rate    : 3;	/* clock rate */
	unsigned la$v_preset  : 16;	/* clock preset */
    } la$r_ladef_bits0;
    struct {
	unsigned	      : 3;	/* skip over microcode valid and type */
	unsigned la$v_clocka  : 1;	/* clock A */
	unsigned la$v_clockb  : 1;	/* clock B */
	unsigned la$v_ad1     : 1;	/* A/D ! 1 */
	unsigned la$v_ad2     : 1;	/* A/D ! 2 */
	unsigned la$v_da      : 1;	/* D/A */
	unsigned la$v_dio1    : 1;	/* digital I/O ! 1 */
	unsigned la$v_dio2    : 1;	/* digital I/O ! 2 */
	unsigned la$v_dio3    : 1;	/* digital I/O ! 3 */
	unsigned la$v_dio4    : 1;	/* digital I/O ! 4 */
	unsigned la$v_dio5    : 1;	/* digital I/O ! 5 */
	unsigned	      : 3;
    } la$r_ladef_bits1;
    struct {
	unsigned	      : 23;	/* (in user's command table) */
	unsigned la$v_bfrovrn : 1;	/* buffer overrun non-fatal bit */
    } la$r_ladef_bits2;
};

#endif	/*_LADEF_H*/
