/* <latdef.h>
 *
 *	Local area transport definitions (V5.5)
 */
#ifndef _LATDEF_H
#define _LATDEF_H

#define LAT$V_ETYPE	0
#define LAT$M_ETYPE	0xFFFF
#define LAT$S_ETYPE	16
#define LAT$C_ENT_NODE		1
#define LAT$C_ENT_SERVICE	2
#define LAT$C_ENT_LINK		3
#define LAT$C_ENT_PORT		4
#define LAT$C_ENT_CONNECTION	5
#define LAT$C_ENT_QUEUE_ENTRY	6
#define LAT$C_MAXETYPE	6
#define LAT$V_ESTATUS	0
#define LAT$M_ESTATUS	0x0F
#define LAT$S_ESTATUS	4
#define LAT$C_ENTS_OLD		0	/* must already exist */
#define LAT$C_ENTS_NEW		1	/* must NOT exist; create it */
#define LAT$C_ENTS_UNK		2	/* create if it does not exist */
#define LAT$C_ENTS_DEL		3	/* must exist; delete it */
#define LAT$V_SENSE_NEXT	0x01
#define LAT$V_SENSE_FULL	0x02
#define LAT$V_READ_HISTORY	0x04
#define LAT$M_SENSE_NEXT	(1<<LAT$V_SENSE_NEXT)		/* 0x01 */
#define LAT$M_SENSE_FULL	(1<<LAT$V_SENSE_FULL)		/* 0x02 */
#define LAT$M_READ_HISTORY	(1<<LAT$V_READ_HISTORY)		/* 0x04 */
struct lat$entity {
    unsigned lat$v_etype : 16;
    union {
	unsigned lat$v_estatus : 4;
	union {
	    unsigned char lat$b_eflags;		/* flags for SENSEmode */
	    struct {
		unsigned lat$v_sense_next : 1;	/* wildcard flag */
		unsigned lat$v_sense_full : 1;	/* full (vs. summary) flag */
		unsigned lat$v_read_history : 1; /* used for history buffer */
		unsigned		  : 5;
	    } lat$r_eflagbits;
	} lat$r_eflag;
    } lat$r_estatflags;
};
#define LAT$V_ITEMINDEX 0
#define LAT$M_ITEMINDEX 0x3FFF
#define LAT$S_ITEMINDEX 14
#define LAT$V_STRING	14
#define LAT$V_CLEAR	15
#define LAT$M_STRING	(1<<LAT$V_STRING)	/* 0x4000 */
#define LAT$M_CLEAR	(1<<LAT$V_CLEAR)	/* 0x8000 */

#define LAT$_ITM_STATE		 1	/*entity (node or port) state */
#define LAT$_ITM_CIRCUIT_TIMER	 2	/*circuit timer value */
#define LAT$_ITM_KEEPALIVE_TIMER 3	/*keepalive timer value */
#define LAT$_ITM_MULTICAST_TIMER 4	/*multicast timer value */
#define LAT$_ITM_NODE_LIMIT	 5	/*maximum number of nodes */
#define LAT$_ITM_RETRANSMIT_LIMIT 6	/*retransmit limit value */
#define LAT$_ITM_SERVER_MODE	  7	/*enable LAT master flag */
#define LAT$_ITM_OUTGOING_SES_LIMIT 8	/*outgoing sessions limit */
#define LAT$_ITM_INCOMING_SES_LIMIT 9	/*incoming sessions limit */
#define LAT$_ITM_CONNECTIONS	10	/*enable LAT slave flag */
#define LAT$_ITM_DECNET_ADDRESS 11	/*use decnet address flag */
#define LAT$_ITM_RATING		12	/*static LAT rating value */
#define LAT$_ITM_RATING_TYPE	13	/*dynamic/static rating flag */
#define LAT$_ITM_NODE_TYPE	14	/*local/remote node type flag */
#define LAT$_ITM_NODE_STATUS	15	/*reachable/unreachable flag */
#define LAT$_ITM_SERVICE_STATUS 16	/*available/unavailable flag */
#define LAT$_ITM_PORT_TYPE	17	/*port type value */
#define LAT$_ITM_QUEUED		18	/*queued/nonqueued access flag */
#define LAT$_ITM_DISCONNECT_REASON 19	/*reason for last disconnect */
#define LAT$_ITM_CONNECTED_COUNT   20	/*number of current sessions */
#define LAT$_ITM_SERVICE_TYPE	21	/*service type value */
#define LAT$_ITM_CTNOD_SSZ	22	/*(node) seconds since zeroed */
#define LAT$_ITM_CTNOD_MSGR	23	/*(node) messages received */
#define LAT$_ITM_CTNOD_MSGT	24	/*(node) messages transmitted */
#define LAT$_ITM_CTNOD_SLTR	25	/*(node) slots received */
#define LAT$_ITM_CTNOD_SLTT	26	/*(node) slots transmitted */
#define LAT$_ITM_CTNOD_BYTR	27	/*(node) bytes received */
#define LAT$_ITM_CTNOD_BYTT	28	/*(node) bytes transmitted */
#define LAT$_ITM_CTNOD_MNA	29	/*(node) multiple node addresses */
#define LAT$_ITM_CTNOD_DUP	30	/*(node) duplicates received */
#define LAT$_ITM_CTNOD_MRT	31	/*(node) messages retransmitted */
#define LAT$_ITM_CTNOD_ILM	32	/*(node) illegal messages received */
#define LAT$_ITM_CTNOD_ILS	33	/*(node) illegal slots received */
#define LAT$_ITM_CTNOD_SLCA	34	/*(node) solicitations accepted */
#define LAT$_ITM_CTNOD_SLCR	35	/*(node) solicitations rejected */
#define LAT$_ITM_CTNOD_TER	36	/*(node) transmit errors */
#define LAT$_ITM_CTNOD_RES	37	/*(node) resource errors */
#define LAT$_ITM_CTNOD_NTB	38	/*(node) no transmit buffer */
#define LAT$_ITM_CTNOD_TMO	39	/*(node) virtual circuit timeouts */
#define LAT$_ITM_CTNOD_DOB	40	/*(node) discarded output bytes */
#define LAT$_ITM_CTNOD_LSTER	41	/*(node) last transmit error */
#define LAT$_ITM_CTNOD_PROTO	42	/*(node) protocol error count */
#define LAT$_ITM_CTPRO_IVM	43	/*(protocol) invalid message type received */
#define LAT$_ITM_CTPRO_ISM	44	/*(protocol) invalid start message received */
#define LAT$_ITM_CTPRO_IVS	45	/*(protocol) invalid sequence number */
#define LAT$_ITM_CTPRO_NIZ	46	/*(protocol) zero node index received */
#define LAT$_ITM_CTPRO_ICI	47	/*(protocol) invalid server slot index */
#define LAT$_ITM_CTPRO_CSI	48	/*(protocol) circuit sequence invalid */
#define LAT$_ITM_CTPRO_NLV	49	/*(protocol) circuit index no longer valid */
#define LAT$_ITM_CTPRO_HALT	50	/*(protocol) circuit forced to halt */
#define LAT$_ITM_CTPRO_MIZ	51	/*(protocol) invalid master slot index */
#define LAT$_ITM_CTPRO_SIZ	52	/*(protocol) invalid slave slot index */
#define LAT$_ITM_CTPRO_CRED	53	/*(protocol) invalid credit field */
#define LAT$_ITM_CTPRO_RCSM	54	/*(protocol) repeat master slot create */
#define LAT$_ITM_CTPRO_RDSM	55	/*(protocol) repeat master slot disconnect */
#define LAT$_ITM_CTSRV_SSZ	56	/*(service) seconds since zeroed */
#define LAT$_ITM_CTSRV_MCNA	57	/*(service) connections attempted */
#define LAT$_ITM_CTSRV_MCNC	58	/*(service) connections completed */
#define LAT$_ITM_CTSRV_SCNA	59	/*(service) connections accepted */
#define LAT$_ITM_CTSRV_SCNR	60	/*(service) connections rejected */
#define LAT$_ITM_CTPRT_SSZ	61	/*(port) seconds since zeroed */
#define LAT$_ITM_CTPRT_RMT	62	/*(port) remote accesses */
#define LAT$_ITM_CTPRT_BYTR	63	/*(port) bytes received */
#define LAT$_ITM_CTPRT_BYTT	64	/*(port) bytes transmitted */
#define LAT$_ITM_MAXIMUM_UNITS	65	/*maximum LTA device unit number */
#define LAT$_ITM_SERVICE_CLASS	66	/* port service class item */
#define LAT$_ITM_DISPLAY_NUMBER 67	/* X display number (binary) */
#define LAT$_ITM_CPU_RATING	68	/* CPU rating */
#define LAT$_ITM_SERVICE_RESPONDER 69	/* service responder */
#define LAT$_ITM_CTNOD_MCBXMT	70	/*(node) multicast bytes xmt */
#define LAT$_ITM_CTNOD_MCBRCV	71	/*(node) multicast bytes rcv */
#define LAT$_ITM_CTNOD_MCMXMT	72	/*(node) multicast msgs xmt */
#define LAT$_ITM_CTNOD_MCMRCV	73	/*(node) multicast msgs rcv */
#define LAT$_ITM_CTNOD_SOLFAIL	74	/*(node) solicit failures */
#define LAT$_ITM_CTNOD_ATLOS	75	/*(node) attention slot lost */
#define LAT$_ITM_CTNOD_DATLOS	76	/*(node) user data lost */
#define LAT$_ITM_CTNOD_NOREJ	77	/*(node) no reject slot sent */
#define LAT$_ITM_CTNOD_LOSCT	78	/*(node) node counter lost */
#define LAT$_ITM_CTNOD_LOSSAM	79	/*(node) s.a.m. lossage */
#define LAT$_ITM_CTNOD_NOSAM	80	/*(node) couldn't send s.a.m. */
#define LAT$_ITM_CTNOD_NOSTS	81	/*(node) lost node status */
#define LAT$_ITM_CTNOD_NOXMT	82	/*(node) no link to send on */
#define LAT$_ITM_HISTORY	83	/*(node) history buffer enable */
#define LAT$_ITM_CTNOD_CTLERR	84	/*(node) controller errors */
#define LAT$_ITM_CTNOD_CERRCOD	85	/*(node) last controller error */
#define LAT$_ITM_CTNOD_ISOLA	86	/*(node) (incoming) solicits accepted */
#define LAT$_ITM_CTNOD_ISOLR	87	/*(node) (incoming) solicits rejected */
#define LAT$_ITM_CONNECTED_SESSIONS 88	/* connected session count */
#define LAT$_ITM_CONNECT_TYPE	89	/* connection type */
#define LAT$_ITM_CONNECTION_SESS_LIM 90 /* connection session limit */
#define LAT$_ITM_CTCON_MSGRCV	91	/*(conn) msgs received */
#define LAT$_ITM_CTCON_DUPRCV	92	/*(conn) dup msgs rcvd */
#define LAT$_ITM_CTCON_MSGXMT	93	/*(conn) msgs xmtd */
#define LAT$_ITM_CTCON_MSGILL	94	/*(conn) illegal msgs rcvd */
#define LAT$_ITM_CTCON_MSGRXT	95	/*(conn) msgs retransmitted */
#define LAT$_ITM_CTCON_SLTILL	96	/*(conn) ill slots rcvd */
#define LAT$_ITM_CTCON_DUPNOD	97	/*(conn) duplicate node */
#define LAT$_ITM_CTCON_SECZER	98	/*(conn) seconds since zero */
#define LAT$_ITM_CTCON_BYTRCV	99	/*(conn) bytes received */
#define LAT$_ITM_CTCON_BYTXMT	100	/*(conn) bytes xmtd */
#define LAT$_ITM_CTCON_SLTRCV	101	/*(conn) slots rcvd */
#define LAT$_ITM_CTCON_SLTXMT	102	/*(conn) slots transmitted */
#define LAT$_ITM_CTCON_SOLACP	103	/*(conn) solicits accepted */
#define LAT$_ITM_CTCON_SOLREJ	104	/*(conn) solicits rejected */
#define LAT$_ITM_CTCON_XERR	105	/*(conn) last transmit error */
#define LAT$_ITM_CTCON_XERRCOD	106	/*(conn) last xmt error code */
#define LAT$_ITM_CTCON_ATTLOS	107	/*(conn) attention slot loss */
#define LAT$_ITM_CTCON_DATLOS	108	/*(conn) data loss */
#define LAT$_ITM_CTCON_CANTREJ	109	/*(conn) reject slot loss */
#define LAT$_ITM_SESSION_NUMBER 110	/*(conn) session number for subblock */
#define LAT$_ITM_FORWARD_SESSION_LIMIT	111 /*(node) forward session limit */
#define LAT$_ITM_EXTRA_DATALINK_BUFFERS 112 /*extra datalink buffers */
#define LAT$_ITM_TRANSMIT_BUFFERS_INUSE 113 /*transmit buffers in use */
#ifndef NO_VMS_V6
#define LAT$_ITM_QUE_POS_OBSOLETE  114	/* [superseded by 117,118] */
#endif
#ifndef ONLY_VMS_V6
#define LAT$_ITM_QUEUE_POSITION    114	/*queue position for entry */
#endif
#define LAT$_ITM_QUEUE_DEPTH_LIMIT 115	/*(node) queue depth limit */
#define LAT$_ITM_DEVICE_SEED	   116	/*(node) device seed */
#ifndef NO_VMS_V6
#define LAT$_ITM_NODE_QUEUE_POSITION 117 /*(port) minimum queue position */
#define LAT$_ITM_SERVICE_QUEUE_POSITION 118 /*(port) maximum queue position */
#define LAT$_ITM_DIALUP		119	/*(port) dialup characteristic */
#define LAT$_ITM_AUTOPROMPT	120	/*(port) autoprompt char */
#define LAT$_ITM_RATING_LOAD_PORTION 121 /*(node) portion of rating for load */
#define LAT$_ITM_CTPRT_LCL	122	/*(port) local accesses */
#define LAT$_ITM_CTPRT_SLCA	123	/*(port) solicitations accepted */
#define LAT$_ITM_CTPRT_SLCR	124	/*(port) solicitations rejected */
#define LAT$_ITM_CTPRT_ISOLA	125	/*(node) (incoming) solicits accepted */
#define LAT$_ITM_CTPRT_ISOLR	126	/*(node) (incoming) solicits rejected */
 /* This next item code is only returned (cannot be supplied as SETMODE item).
    It indicates whether or not service on local node is password protected. */
#define LAT$_ITM_PASSWORD	127	/*(svc) password enabled/disabled */
#define LAT$_ITM_HI_CIRCUITS	128	/*(node) hi circuit count */
#define LAT$_ITM_CUR_CIRCUITS	129	/*(node) current circuit count */
#define LAT$_ITM_MAX_CIRCUITS	130	/*(node) maximum virtual circuits */
#define LAT$_ITM_HI_SESSIONS	131	/*(node) hi session count */
#define LAT$_ITM_CUR_SESSIONS	132	/*(node) current session count */
#define LAT$_ITM_MAX_SESSIONS	133	/*(node) maximum session count */
#define LAT$_ITM_HI_OUT_QUEUE	134	/*(node) hi outgoing queue entries */
#define LAT$_ITM_CUR_OUT_QUEUE	135	/*(node) current outgoing q entries */
#define LAT$_ITM_MAX_OUT_QUEUE	136	/*(node) maximum outgoing q entries */
#define LAT$_ITM_HI_IN_QUEUE	137	/*(node) hi incoming queue entries */
#define LAT$_ITM_CUR_IN_QUEUE	138	/*(node) current incoming q entries */
#define LAT$_ITM_MAX_IN_QUEUE	139	/*(node) maximum incoming q entries */
#define LAT$_ITM_HI_SAMS_QUEUED 140	/*(node) hi unprocessed SAMs */
#define LAT$_ITM_CUR_SAMS_QUEUED 141	/*(node) current unprocessed SAMs */
#define LAT$_ITM_MAX_SAMS_QUEUED 142	/*(node) maximum unprocessed SAMs */
#define LAT$_ITM_HI_SOL_QUEUED	143	/*(node) hi unprocessed sol infos */
#define LAT$_ITM_CUR_SOL_QUEUED 144	/*(node) current unprocessed sol infos */
#define LAT$_ITM_MAX_SOL_QUEUED 145	/*(node) maximum unprocessed sol infos */
#define LAT$_ITM_HI_AVAIL_SVCS	146	/*(node) hi available services */
#define LAT$_ITM_CUR_AVAIL_SVCS 147	/*(node) current available services */
#define LAT$_ITM_MAX_AVAIL_SVCS 148	/*(node) maximum available services */
#define LAT$_ITM_HI_REACH_NODES 149	/*(node) hi reachable nodes */
#define LAT$_ITM_CUR_REACH_NODES 150	/*(node) current reachable nodes */
#define LAT$_ITM_MAX_REACH_NODES 151	/*(node) maximum reachable nodes */
#define LAT$_ITM_HI_LCL_SVCS	152	/*(node) hi local services */
#define LAT$_ITM_CUR_LCL_SVCS	153	/*(node) current local services */
#define LAT$_ITM_MAX_LCL_SVCS	154	/*(node) maximum local services */
#define LAT$_ITM_DISCARDED_NODES 155	/*(node) discarded nodes */
#define LAT$_ITM_MAX_DL_BUFFERS 156	/*(conn) maximum datalink buffers */
#define LAT$_ITM_PRODUCT_TYPE	157	/*(conn) product type */
#define LAT$_ITM_REM_PRODUCT_VERSION 158 /*(conn) remote product version */
#define LAT$_ITM_CTPRT_FRAMERR	159	/*(port) framing errors */
#define LAT$_ITM_CTPRT_PARERR	160	/*(port) parity errors */
#define LAT$_ITM_CTPRT_OVERRUN	161	/*(port) data overruns */
#define LAT$_ITM_CTPRO_INVCLASS 162	/*(protocol) protocol error invalid service class */
#define LAT$_ITM_CTPRO_EXCSTART 163	/*(protocol) protocol error (excessive start slots) */
#define LAT$_ITM_CTNOD_XSTR	164	/*(node) remote node too many START slots */
#define LAT$_ITM_PASSWORD_FAILURES 165	/*(service,port) password failures */
#define LAT$_ITM_CTPRO_ILLSAM	166	/*(protocol) Illegal SAMs */
#define LAT$_ITM_TYPEAHEAD	167	/*(port) 1 = typeahd present */
#define LAT$_ITM_CTLAT_RMSG	168	/*(link) LAT msgs rcvd */
#define LAT$_ITM_CTLAT_RBYT	169	/*(link) LAT bytes rcvd */
#define LAT$_ITM_CTLAT_XMSG	170	/*(link) LAT msgs xmt */
#define LAT$_ITM_CTLAT_XBYT	171	/*(link) LAT bytes xmt */
#define LAT$_ITM_CTLAT_MUL_RMSG 172	/*(link) LAT multicast msgs rcvd */
#define LAT$_ITM_CTLAT_MUL_RBYT 173	/*(link) LAT multicast bytes rcvd */
#define LAT$_ITM_CTLAT_MUL_XMSG 174	/*(link) LAT multicast msgs xmt */
#define LAT$_ITM_CTLAT_MUL_XBYT 175	/*(link) LAT multicast bytes xmt */
#define LAT$C_ITM_MAXSCALAR	175
#else
#define LAT$C_ITM_MAXSCALAR	116
#endif
#define LAT$_ITM_IDENTIFICATION		16640	/*entity (node or service) identification */
#define LAT$_ITM_SERVICE_NAME		16641	/*service name */
#define LAT$_ITM_NODE_NAME		16642	/*node name */
#define LAT$_ITM_PORT_NAME		16643	/*port name */
#define LAT$_ITM_CONNECTED_SERVICE_NAME 16644	/*port's connected service name */
#define LAT$_ITM_CONNECTED_NODE_NAME	16645	/*port's connected node name */
#define LAT$_ITM_CONNECTED_PORT_NAME	16646	/*port's connected port name */
#define LAT$_ITM_TARGET_SERVICE_NAME	16647	/*port's target service name */
#define LAT$_ITM_TARGET_NODE_NAME	16648	/*port's target node name */
#define LAT$_ITM_TARGET_PORT_NAME	16649	/*port's target port name */
#define LAT$_ITM_SERVICE_GROUPS		16650	/*enabled service groups bitmask */
#define LAT$_ITM_USER_GROUPS		16651	/*enabled user groups bitmask */
#define LAT$_ITM_LINK_NAME		16652	/*link name */
#define LAT$_ITM_SERVICE_PASSWORD	16653	/*service password */
#define LAT$_ITM_DEVICE_NAME		16654	/*link's device name */
#define LAT$_ITM_DATALINK_ADDRESS	16655	/*6-byte binary ethernet address */
#define LAT$_ITM_PROTOCOL_VERSION	16656	/*LAT protocol version string */
#define LAT$_ITM_SVC_NODE_BLOCK		16657	/*subblock for sense service */
#define LAT$_ITM_NODE_SVC_BLOCK		16658	/*subblock for sense node */
#define LAT$_ITM_DED_PORT_BLOCK		16659	/*subblock for dedicated ports */
#define LAT$_ITM_COUNTERS		16660	/*subblock for counters */
#define LAT$_ITM_PROTOCOL_ERRORS	16661	/*subblock for protocol errors */
#define LAT$_ITM_CONNECTED_LINK_NAME	16662	/*port's connected link name */
#define LAT$_ITM_HISTORY_ENTRY		16663	/*node history buffer entry */
#define LAT$_ITM_CONNECT_ID		16664	/*connect ID name */
#define LAT$_ITM_SESSION_BLOCK		16665	/*subblock for sense connection */
#define LAT$_ITM_QUEUED_ENTRY_ID	16666	/*queued entry ID string */
#ifndef NO_VMS_V6
#define LAT$_ITM_LIM_PORT_BLOCK		16667	/*subblock for limited ports */
#define LAT$_ITM_SERVICE_CLASSES	16668	/*service class bitmask for node */
#define LAT$_ITM_LAT_DEV_CTR_BLOCK	16669	/*link LAT only counters */
#define LAT$C_ITM_MAXSTRING		16669
#else
#define LAT$C_ITM_MAXSTRING		16666
#endif
struct lat$item_entry {
    union {
	unsigned short lat$w_itemcode;
	struct {
	    unsigned lat$v_itemindex	: 14;
	    unsigned lat$v_string	: 1;
	    unsigned lat$v_clear	: 1;
	} lat$r_itm_bits;
    } lat$r_itm_code;
    union {
	struct {
	    unsigned char lat$b_item_bcnt;
	    char lat$t_item_string_value[1];
	} lat$r_item_counted_string;
	unsigned long lat$l_item_scalar_value;
    } lat$r_item_value;
};
#define LAT$C_DISABLED	0
#define LAT$C_ENABLED	1
#define LAT$C_OFF	0
#define LAT$C_ON	1
#define LAT$C_SHUT	2
#define LAT$V_FLUSH_DATA	0
#define LAT$M_FLUSH_DATA	(1<<LAT$V_FLUSH_DATA)	/* 0x01 */
#define LAT$C_PT_FORWARD	0	/*"forward" connection port */
#define LAT$C_PT_INTERACTIVE	1	/*interactive incoming port */
#define LAT$C_PT_APPLICATION	2	/*application port */
#define LAT$C_PT_DEDICATED	3	/*dedicated port */
#define LAT$C_PT_LIMITED	4	/*limited port */
#define LAT$C_NT_LOCAL		0	/*my own node */
#define LAT$C_NT_REMOTE		1	/*the other guy */
#define LAT$C_ST_GENERAL	0	/*general timesharing service */
#define LAT$C_ST_APPLICATION	1	/*application service */
#define LAT$C_ST_LIMITED	2	/*limited service */
#define LAT$C_DYNAMIC		0	/*dynamic calculation */
#define LAT$C_STATIC		1	/*fixed rating */
#define LAT$C_CN_UNKNOWN	0	/*unknown connection type */
#define LAT$C_CN_INCOMING	1	/*slave connection */
#define LAT$C_CN_OUTGOING	2	/*master connection */
#define LAT$C_UNREACHABLE	0	/*known not there */
#define LAT$C_UNKNOWN		1	/*haven't heard in a while */
#define LAT$C_REACHABLE		2	/*I heard from him */
#define LAT$C_UNAVAILABLE	0	/*can't get it */
#define LAT$C_AVAILABLE		1	/*it is there */
#define LAT$C_SERVCLASS_INTERACTIVE	1	/* SC1 = TTDRIVER */
#define LAT$C_SERVCLASS_TESTSERVICE	2	/* SC2 = TEST SERVICE */
#define LAT$C_SERVCLASS_XTRANSPORT	3	/* SC3 = X Transport */
#define LAT$C_SERVCLASS_FONT		4	/* SC4 = X Fonts */
union lat$latsetbits {
    char lat$t_filler[1];
    char lat$t_filler2;
};

#endif	/*_LATDEF_H*/
