/* <lpdef.h>
 *
 *	Line printer characteristics definitions
 */
#ifndef _LPDEF_H
#define _LPDEF_H

#define LP$V_CR		0
#define LP$V_MECHFORM	1
#define LP$V_PRINTALL	2
#define LP$V_DAVFU	3
#define LP$V_WRAP	4
#define LP$V_TRUNCATE	5
#define LP$V_TAB	6
#define LP$V_LOWER	7
#define LP$V_PASSALL	8
#define LP$V_FALLBACK	9
#define LP$V_SIXELS	10
#define LP$V_BITMAPPED	11
#define LP$M_CR		(1<<LP$V_CR)		/* 0x01 */
#define LP$M_MECHFORM	(1<<LP$V_MECHFORM)	/* 0x02 */
#define LP$M_PRINTALL	(1<<LP$V_PRINTALL)	/* 0x04 */
#define LP$M_DAVFU	(1<<LP$V_DAVFU)		/* 0x08 */
#define LP$M_WRAP	(1<<LP$V_WRAP)		/* 0x10 */
#define LP$M_TRUNCATE	(1<<LP$V_TRUNCATE)	/* 0x20 */
#define LP$M_TAB	(1<<LP$V_TAB)		/* 0x40 */
#define LP$M_LOWER	(1<<LP$V_LOWER)		/* 0x80 */
#define LP$M_PASSALL	(1<<LP$V_PASSALL)	/* 0x0100 */
#define LP$M_FALLBACK	(1<<LP$V_FALLBACK)	/* 0x0200 */
#define LP$M_SIXELS	(1<<LP$V_SIXELS)	/* 0x0400 */
#define LP$M_BITMAPPED	(1<<LP$V_BITMAPPED)	/* 0x0800 */
#define LP$V_PAGE_L	24
#define LP$M_PAGE_L	(0xFF<<LP$V_PAGE_L)	/* 0xFF000000 */
#define LP$S_PAGE_L	8

#define LP$_LP11	1
#define LP$_LA11	2
#define LP$_LA180	3
union lpdef {
    struct {
	unsigned lp$v_cr	: 1;	/* carriage return needed */
	unsigned lp$v_mechform	: 1;	/* mechanical form feed */
	unsigned lp$v_printall	: 1;	/* non printable char. accept(DMF-32) */
	unsigned lp$v_davfu	: 1;	/* davfu avail. */
	unsigned lp$v_wrap	: 1;	/* char. wrap mode */
	unsigned lp$v_truncate	: 1;	/* truncate output at carriage width */
	unsigned lp$v_tab	: 1;	/* tab needed */
	unsigned lp$v_lower	: 1;	/* printer has lower case */
	unsigned lp$v_passall	: 1;	/* passall mode */
	unsigned lp$v_fallback	: 1;	/* fallback mode */
	unsigned lp$v_sixels	: 1;	/* handles Sixels */
	unsigned lp$v_bitmapped : 1;	/* handles bit maps */
	unsigned		: 12;	/* spare unused bits */
	unsigned lp$v_page_l	: 8;	/* page length */
    } lp$r_lpdef_bits;
};

#endif	/*_LPDEF_H*/
