/* <mtdef.h>
 *
 *	Magtape status bits
 */
#ifndef _MTDEF_H
#define _MTDEF_H

#define MT$V_SEREXCP	0
#define MT$V_ENAUTOPACK 1
#define MT$V_ENSEREXCP	2
#define MT$V_PARITY	3
#define MT$M_SEREXCP	(1<<MT$V_SEREXCP)	/* 0x01 */
#define MT$M_ENAUTOPACK (1<<MT$V_ENAUTOPACK)	/* 0x02 */
#define MT$M_ENSEREXCP	(1<<MT$V_ENSEREXCP)	/* 0x04 */
#define MT$M_PARITY	(1<<MT$V_PARITY)	/* 0x08 */
#define MT$V_FORMAT	4
#define MT$M_FORMAT	0xF0
#define MT$S_FORMAT	4
#define MT$V_DENSITY	8
#define MT$M_DENSITY	0x1F00
#define MT$S_DENSITY	5
   /* offset not used:	13 */
#define MT$V_LOGSOFT	14
#define MT$V_LOGSOFTOG	15
#define MT$V_BOT	16
#define MT$V_EOF	17
#define MT$V_EOT	18
#define MT$V_HWL	19
#define MT$V_LOST	20
#define MT$V_SUP_NRZI	21
#define MT$V_SUP_PE	22
#define MT$V_SUP_GCR	23
#define MT$M_LOGSOFT	(1<<MT$V_LOGSOFT)	/* 0x4000 */
#define MT$M_LOGSOFTOG	(1<<MT$V_LOGSOFTOG)	/* 0x8000 */
#define MT$M_BOT	(1<<MT$V_BOT)		/* 0x010000 */
#define MT$M_EOF	(1<<MT$V_EOF)		/* 0x020000 */
#define MT$M_EOT	(1<<MT$V_EOT)		/* 0x040000 */
#define MT$M_HWL	(1<<MT$V_HWL)		/* 0x080000 */
#define MT$M_LOST	(1<<MT$V_LOST)		/* 0x100000 */
#define MT$M_SUP_NRZI	(1<<MT$V_SUP_NRZI)	/* 0x200000 */
#define MT$M_SUP_PE	(1<<MT$V_SUP_PE)	/* 0x400000 */
#define MT$M_SUP_GCR	(1<<MT$V_SUP_GCR)	/* 0x800000 */
#define MT$V_SPEED	24
#define MT$M_SPEED	0xFF000000
#define MT$S_SPEED	8
/* recording format defintions */
#define MT$K_DEFAULT	0	/* default format */
#define MT$K_NORMAL11	12	/* PDP-11 normal */
#define MT$K_CORDMP11	13	/* PDP-11 core dump */
#define MT$K_NORMAL15	14	/* PDP-15 normal */
/* recording density and method definitions */
/*	default				 0	*/
/*	9 track				 1 - 7	*/
/*	optical disk			 8 - 9	*/
/*	SCSI compaction codes		10 - 11 */
/*	high performance cartridge	12 - 15 */
/*	block mode			16 - 23 */
/*	reserved			24 - 31 */
#define MT$K_NRZI_800	3	/* NRZI 800 BPI */
#define MT$K_PE_1600	4	/* PE 1600 BPI */
#define MT$K_GCR_6250	5	/* GCR 6250 BPI */
#define MT$K_WOD_6250	8	/* RV80 6250 BPI equivalent */
#define MT$K_SCSI_DC1	10	/* Data Compaction algorithm 1 */
#define MT$K_HPC_40K	12	/* HPC 39872 BPI */
#define MT$K_HPC_COMP	13	/* HPC 39872 compacted */
#define MT$K_XPC_80K	14
#define MT$K_XPC_COMP	15
#define MT$K_BLK_833	17	/* Block (TK50) 833 BPI */
#define MT$K_BLK_1250	18	/* Block (TK70) 1250 BPI */
#define MT$K_BLK_10K	19	/* Block (TF85) 10625 BPI */
#define MT$K_BLK_20K	20	/* Block (TF86) 10626 */
#define MT$K_BLK_60K	21	/* Block (Tx87) 62500 */
#define MT$K_BLK_COMP	22	/* Block (Tx87) compressed 62501 */
#define MT$K_DAT_61K	24	/* DAT cartridge 61000 BPI equivalent */
/* tape speed value definitions */
#define MT$K_SPEED_DEF	0	/* default speed */
#define MT$K_SPEED_25	25	/* 25 IPS */
#define MT$K_SPEED_75	75	/* 75 IPS */
union mtdef {
    struct {
	unsigned mt$v_serexcp	: 1;	/* serious exception present */
	unsigned mt$v_enautopack: 1;	/* enable auto packack */
	unsigned mt$v_enserexcp : 1;	/* enable serious exception mode */
	unsigned mt$v_parity	: 1;	/* parity select (0=odd, 1=even) */
	unsigned mt$v_format	: 4;	/* recording format */
	unsigned mt$v_density	: 5;	/* recording density and method */
	unsigned		: 1;	/* spare unused bit */
	unsigned mt$v_logsoft	: 1;	/* log soft (TU78) errors (0=no, 1=yes) */
	unsigned mt$v_logsoftog : 1;	/* toggle to reverse logsoft state bit */
	unsigned mt$v_bot	: 1;	/* at beginning of tape */
	unsigned mt$v_eof	: 1;	/* at end of file */
	unsigned mt$v_eot	: 1;	/* at end of tape */
	unsigned mt$v_hwl	: 1;	/* tape is hardware writelocked */
	unsigned mt$v_lost	: 1;	/* tape position lost */
	unsigned mt$v_sup_nrzi	: 1;	/* drive supports NRZI (800 BPI) */
	unsigned mt$v_sup_pe	: 1;	/* drive supports PE (1600 BPI) */
	unsigned mt$v_sup_gcr	: 1;	/* drive supports GCR (6250 BPI) */
	unsigned mt$v_speed	: 8;	/* tape speed */
    } mt$r_mtdef_bits;
};

#endif	/*_MTDEF_H*/
