/* <vms/lib/nmbdef.h>
 *
 *	LIB - file name block definitions		[not in Starlet]
 */
#ifndef _NMBDEF_H
#define _NMBDEF_H

/*
   Format of the file name block.  The file name block is used as an internal
   interface to the directory scan routine, and is also the format of a
   directory record.
 */
#define NMB$K_DIRENTRY	16	/* length of directory entry */
#define NMB$C_DIRENTRY	16
#define NMB$V_ALLVER	3
#define NMB$V_ALLTYP	4
#define NMB$V_ALLNAM	5
#define NMB$V_WILD	8
#define NMB$V_NEWVER	9
#define NMB$V_SUPERSEDE 10
#define NMB$V_FINDFID	11
#define NMB$V_LOWVER	14
#define NMB$V_HIGHVER	15
#define NMB$M_ALLVER	(1<<NMB$V_ALLVER)	/* 0x08 */
#define NMB$M_ALLTYP	(1<<NMB$V_ALLTYP)	/* 0x10 */
#define NMB$M_ALLNAM	(1<<NMB$V_ALLNAM)	/* 0x20 */
#define NMB$M_WILD	(1<<NMB$V_WILD)		/* 0x0100 */
#define NMB$M_NEWVER	(1<<NMB$V_NEWVER)	/* 0x0200 */
#define NMB$M_SUPERSEDE (1<<NMB$V_SUPERSEDE)	/* 0x0400 */
#define NMB$M_FINDFID	(1<<NMB$V_FINDFID)	/* 0x0800 */
#define NMB$M_LOWVER	(1<<NMB$V_LOWVER)	/* 0x4000 */
#define NMB$M_HIGHVER	(1<<NMB$V_HIGHVER)	/* 0x8000 */

#define NMB$S_FID	6
#define NMB$S_NAME	6
#define NMB$S_ASCNAMTXT 19

#define NMB$K_LENGTH	40	/* length of name block */
#define NMB$C_LENGTH	40
#define NMB$S_NMBDEF	40

struct nmbdef {
    union {
	unsigned short nmb$w_fid[3];	/* file id */
	struct {
	    unsigned short nmb$w_fid_num; /* fid - file number */
	    unsigned short nmb$w_fid_seq; /* fid - file sequence number */
	    unsigned short nmb$w_fid_rvn; /* fid - relative volume number */
	} nmb$r_fid_fields;
    } nmb$r_fid_overlay;
    struct {
	unsigned short nmb$w_name[3];	/* file name (rad-50) */
    } nmb$r_name;
    unsigned short nmb$w_type;		/* file type (rad-50) */
    short nmb$w_version;		/* version number */
    union {
	unsigned short nmb$w_flags;	/* name status flags */
	struct {
	    unsigned		     : 3;
	    unsigned nmb$v_allver    : 1; /* match all versions */
	    unsigned nmb$v_alltyp    : 1; /* match all types */
	    unsigned nmb$v_allnam    : 1; /* match all names */
	    unsigned		     : 2;
	    unsigned nmb$v_wild      : 1; /* wild cards in file name */
	    unsigned nmb$v_newver    : 1; /* maximize version number */
	    unsigned nmb$v_supersede : 1; /* supersede existing file */
	    unsigned nmb$v_findfid   : 1; /* search for file id */
	    unsigned		     : 2;
	    unsigned nmb$v_lowver    : 1; /* lower version of file exists */
	    unsigned nmb$v_highver   : 1; /* higher version of file exists */
	} nmb$r_flags_bits;
    } nmb$r_flags_overlay;
    unsigned char nmb$b_ascnamsiz;
    char nmb$t_ascnamtxt[19];
    unsigned short nmb$w_context;	/* start point for next find */
};

#endif	/*_NMBDEF_H*/
