/* <opdef.h>
 *
 *	VAX instruction operands (OP codes)
 */
#ifndef _OPDEF_H
#define _OPDEF_H

#define OP$_HALT	0x00	/* 0 */
#define OP$_NOP		0x01	/* 1 */
#define OP$_REI		0x02	/* 2 */
#define OP$_BPT		0x03	/* 3 */
#define OP$_RET		0x04	/* 4 */
#define OP$_RSB		0x05	/* 5 */
#define OP$_LDPCTX	0x06	/* 6 */
#define OP$_SVPCTX	0x07	/* 7 */
#define OP$_CVTPS	0x08	/* 8 */
#define OP$_CVTSP	0x09	/* 9 */
#define OP$_INDEX	0x0A	/* 10 */
#define OP$_CRC		0x0B	/* 11 */
#define OP$_PROBER	0x0C	/* 12 */
#define OP$_PROBEW	0x0D	/* 13 */
#define OP$_INSQUE	0x0E	/* 14 */
#define OP$_REMQUE	0x0F	/* 15 */
#define OP$_BSBB	0x10	/* 16 */
#define OP$_BSB		0x10	/* 16 */
#define OP$_BRB		0x11	/* 17 */
#define OP$_BNEQ	0x12	/* 18 */
#define OP$_BNEQU	0x12	/* 18 */
#define OP$_BEQL	0x13	/* 19 */
#define OP$_BEQLU	0x13	/* 19 */
#define OP$_BGTR	0x14	/* 20 */
#define OP$_BLEQ	0x15	/* 21 */
#define OP$_JSB		0x16	/* 22 */
#define OP$_JMP		0x17	/* 23 */
#define OP$_BGEQ	0x18	/* 24 */
#define OP$_BLSS	0x19	/* 25 */
#define OP$_BGTRU	0x1A	/* 26 */
#define OP$_BLEQU	0x1B	/* 27 */
#define OP$_BVC		0x1C	/* 28 */
#define OP$_BVS		0x1D	/* 29 */
#define OP$_BGEQU	0x1E	/* 30 */
#define OP$_BCC		0x1E	/* 30 */
#define OP$_BLSSU	0x1F	/* 31 */
#define OP$_BCS		0x1F	/* 31 */
#define OP$_ADDP4	0x20	/* 32 */
#define OP$_ADDP	0x20	/* 32 */
#define OP$_ADDP6	0x21	/* 33 */
#define OP$_SUBP4	0x22	/* 34 */
#define OP$_SUBP	0x22	/* 34 */
#define OP$_SUBP6	0x23	/* 35 */
#define OP$_CVTPT	0x24	/* 36 */
#define OP$_MULP	0x25	/* 37 */
#define OP$_CVTTP	0x26	/* 38 */
#define OP$_DIVP	0x27	/* 39 */
#define OP$_MOVC3	0x28	/* 40 */
#define OP$_MOVC	0x28	/* 40 */
#define OP$_CMPC3	0x29	/* 41 */
#define OP$_CMPC	0x29	/* 41 */
#define OP$_SCANC	0x2A	/* 42 */
#define OP$_SPANC	0x2B	/* 43 */
#define OP$_MOVC5	0x2C	/* 44 */
#define OP$_CMPC5	0x2D	/* 45 */
#define OP$_MOVTC	0x2E	/* 46 */
#define OP$_MOVTUC	0x2F	/* 47 */
#define OP$_BSBW	0x30	/* 48 */
#define OP$_BRW		0x31	/* 49 */
#define OP$_CVTWL	0x32	/* 50 */
#define OP$_CVTWB	0x33	/* 51 */
#define OP$_MOVP	0x34	/* 52 */
#define OP$_CMPP3	0x35	/* 53 */
#define OP$_CMPP	0x35	/* 53 */
#define OP$_CVTPL	0x36	/* 54 */
#define OP$_CMPP4	0x37	/* 55 */
#define OP$_EDITPC	0x38	/* 56 */
#define OP$_MATCHC	0x39	/* 57 */
#define OP$_LOCC	0x3A	/* 58 */
#define OP$_SKPC	0x3B	/* 59 */
#define OP$_MOVZWL	0x3C	/* 60 */
#define OP$_ACBW	0x3D	/* 61 */
#define OP$_MOVAW	0x3E	/* 62 */
#define OP$_PUSHAW	0x3F	/* 63 */
#define OP$_ADDF2	0x40	/* 64 */
#define OP$_ADDF	0x40	/* 64 */
#define OP$_ADDF3	0x41	/* 65 */
#define OP$_SUBF2	0x42	/* 66 */
#define OP$_SUBF	0x42	/* 66 */
#define OP$_SUBF3	0x43	/* 67 */
#define OP$_MULF2	0x44	/* 68 */
#define OP$_MULF	0x44	/* 68 */
#define OP$_MULF3	0x45	/* 69 */
#define OP$_DIVF2	0x46	/* 70 */
#define OP$_DIVF	0x46	/* 70 */
#define OP$_DIVF3	0x47	/* 71 */
#define OP$_CVTFB	0x48	/* 72 */
#define OP$_CVTFW	0x49	/* 73 */
#define OP$_CVTFL	0x4A	/* 74 */
#define OP$_CVTRFL	0x4B	/* 75 */
#define OP$_CVTBF	0x4C	/* 76 */
#define OP$_CVTWF	0x4D	/* 77 */
#define OP$_CVTLF	0x4E	/* 78 */
#define OP$_ACBF	0x4F	/* 79 */
#define OP$_MOVF	0x50	/* 80 */
#define OP$_CMPF	0x51	/* 81 */
#define OP$_MNEGF	0x52	/* 82 */
#define OP$_TSTF	0x53	/* 83 */
#define OP$_EMODF	0x54	/* 84 */
#define OP$_POLYF	0x55	/* 85 */
#define OP$_CVTFD	0x56	/* 86 */
/*	  reserved	0x57	\* 87 */
#define OP$_ADAWI	0x58	/* 88 */
/*	  reserved	0x59	\* 89 */
/*	  reserved	0x5A	\* 90 */
/*	  reserved	0x5B	\* 91 */
#define OP$_INSQHI	0x5C	/* 92 */
#define OP$_INSQTI	0x5D	/* 93 */
#define OP$_REMQHI	0x5E	/* 94 */
#define OP$_REMQTI	0x5F	/* 95 */
#define OP$_ADDD2	0x60	/* 96 */
#define OP$_ADDD	0x60	/* 96 */
#define OP$_ADDD3	0x61	/* 97 */
#define OP$_SUBD2	0x62	/* 98 */
#define OP$_SUBD	0x62	/* 98 */
#define OP$_SUBD3	0x63	/* 99 */
#define OP$_MULD2	0x64	/* 100 */
#define OP$_MULD	0x64	/* 100 */
#define OP$_MULD3	0x65	/* 101 */
#define OP$_DIVD2	0x66	/* 102 */
#define OP$_DIVD	0x66	/* 102 */
#define OP$_DIVD3	0x67	/* 103 */
#define OP$_CVTDB	0x68	/* 104 */
#define OP$_CVTDW	0x69	/* 105 */
#define OP$_CVTDL	0x6A	/* 106 */
#define OP$_CVTRDL	0x6B	/* 107 */
#define OP$_CVTBD	0x6C	/* 108 */
#define OP$_CVTWD	0x6D	/* 109 */
#define OP$_CVTLD	0x6E	/* 110 */
#define OP$_ACBD	0x6F	/* 111 */
#define OP$_MOVD	0x70	/* 112 */
#define OP$_CMPD	0x71	/* 113 */
#define OP$_MNEGD	0x72	/* 114 */
#define OP$_TSTD	0x73	/* 115 */
#define OP$_EMODD	0x74	/* 116 */
#define OP$_POLYD	0x75	/* 117 */
#define OP$_CVTDF	0x76	/* 118 */
/*	  reserved	0x77	\* 119 */
#define OP$_ASHL	0x78	/* 120 */
#define OP$_ASHQ	0x79	/* 121 */
#define OP$_EMUL	0x7A	/* 122 */
#define OP$_EDIV	0x7B	/* 123 */
#define OP$_CLRQ	0x7C	/* 124 */
#define OP$_CLRD	0x7C	/* 124 */
#define OP$_CLRG	0x7C	/* 124 */
#define OP$_MOVQ	0x7D	/* 125 */
#define OP$_MOVAQ	0x7E	/* 126 */
#define OP$_MOVAD	0x7E	/* 126 */
#define OP$_MOVAG	0x7E	/* 126 */
#define OP$_PUSHAQ	0x7F	/* 127 */
#define OP$_PUSHAD	0x7F	/* 127 */
#define OP$_PUSHAG	0x7F	/* 127 */
#define OP$_ADDB2	0x80	/* 128 */
#define OP$_ADDB	0x80	/* 128 */
#define OP$_ADDB3	0x81	/* 129 */
#define OP$_SUBB2	0x82	/* 130 */
#define OP$_SUBB	0x82	/* 130 */
#define OP$_SUBB3	0x83	/* 131 */
#define OP$_MULB2	0x84	/* 132 */
#define OP$_MULB	0x84	/* 132 */
#define OP$_MULB3	0x85	/* 133 */
#define OP$_DIVB2	0x86	/* 134 */
#define OP$_DIVB	0x86	/* 134 */
#define OP$_DIVB3	0x87	/* 135 */
#define OP$_BISB2	0x88	/* 136 */
#define OP$_BISB	0x88	/* 136 */
#define OP$_BISB3	0x89	/* 137 */
#define OP$_BICB2	0x8A	/* 138 */
#define OP$_BICB	0x8A	/* 138 */
#define OP$_BICB3	0x8B	/* 139 */
#define OP$_XORB2	0x8C	/* 140 */
#define OP$_XORB	0x8C	/* 140 */
#define OP$_XORB3	0x8D	/* 141 */
#define OP$_MNEGB	0x8E	/* 142 */
#define OP$_CASEB	0x8F	/* 143 */
#define OP$_MOVB	0x90	/* 144 */
#define OP$_CMPB	0x91	/* 145 */
#define OP$_MCOMB	0x92	/* 146 */
#define OP$_BITB	0x93	/* 147 */
#define OP$_CLRB	0x94	/* 148 */
#define OP$_TSTB	0x95	/* 149 */
#define OP$_INCB	0x96	/* 150 */
#define OP$_DECB	0x97	/* 151 */
#define OP$_CVTBL	0x98	/* 152 */
#define OP$_CVTBW	0x99	/* 153 */
#define OP$_MOVZBL	0x9A	/* 154 */
#define OP$_MOVZBW	0x9B	/* 155 */
#define OP$_ROTL	0x9C	/* 156 */
#define OP$_ACBB	0x9D	/* 157 */
#define OP$_MOVAB	0x9E	/* 158 */
#define OP$_PUSHAB	0x9F	/* 159 */
#define OP$_ADDW2	0xA0	/* 160 */
#define OP$_ADDW	0xA0	/* 160 */
#define OP$_ADDW3	0xA1	/* 161 */
#define OP$_SUBW2	0xA2	/* 162 */
#define OP$_SUBW	0xA2	/* 162 */
#define OP$_SUBW3	0xA3	/* 163 */
#define OP$_MULW2	0xA4	/* 164 */
#define OP$_MULW	0xA4	/* 164 */
#define OP$_MULW3	0xA5	/* 165 */
#define OP$_DIVW2	0xA6	/* 166 */
#define OP$_DIVW	0xA6	/* 166 */
#define OP$_DIVW3	0xA7	/* 167 */
#define OP$_BISW2	0xA8	/* 168 */
#define OP$_BISW	0xA8	/* 168 */
#define OP$_BISW3	0xA9	/* 169 */
#define OP$_BICW2	0xAA	/* 170 */
#define OP$_BICW	0xAA	/* 170 */
#define OP$_BICW3	0xAB	/* 171 */
#define OP$_XORW2	0xAC	/* 172 */
#define OP$_XORW	0xAC	/* 172 */
#define OP$_XORW3	0xAD	/* 173 */
#define OP$_MNEGW	0xAE	/* 174 */
#define OP$_CASEW	0xAF	/* 175 */
#define OP$_MOVW	0xB0	/* 176 */
#define OP$_CMPW	0xB1	/* 177 */
#define OP$_MCOMW	0xB2	/* 178 */
#define OP$_BITW	0xB3	/* 179 */
#define OP$_CLRW	0xB4	/* 180 */
#define OP$_TSTW	0xB5	/* 181 */
#define OP$_INCW	0xB6	/* 182 */
#define OP$_DECW	0xB7	/* 183 */
#define OP$_BISPSW	0xB8	/* 184 */
#define OP$_BICPSW	0xB9	/* 185 */
#define OP$_POPR	0xBA	/* 186 */
#define OP$_PUSHR	0xBB	/* 187 */
#define OP$_CHMK	0xBC	/* 188 */
#define OP$_CHME	0xBD	/* 189 */
#define OP$_CHMS	0xBE	/* 190 */
#define OP$_CHMU	0xBF	/* 191 */
#define OP$_ADDL2	0xC0	/* 192 */
#define OP$_ADDL	0xC0	/* 192 */
#define OP$_ADDL3	0xC1	/* 193 */
#define OP$_SUBL2	0xC2	/* 194 */
#define OP$_SUBL	0xC2	/* 194 */
#define OP$_SUBL3	0xC3	/* 195 */
#define OP$_MULL2	0xC4	/* 196 */
#define OP$_MULL	0xC4	/* 196 */
#define OP$_MULL3	0xC5	/* 197 */
#define OP$_DIVL2	0xC6	/* 198 */
#define OP$_DIVL	0xC6	/* 198 */
#define OP$_DIVL3	0xC7	/* 199 */
#define OP$_BISL2	0xC8	/* 200 */
#define OP$_BISL	0xC8	/* 200 */
#define OP$_BISL3	0xC9	/* 201 */
#define OP$_BICL2	0xCA	/* 202 */
#define OP$_BICL	0xCA	/* 202 */
#define OP$_BICL3	0xCB	/* 203 */
#define OP$_XORL2	0xCC	/* 204 */
#define OP$_XORL	0xCC	/* 204 */
#define OP$_XORL3	0xCD	/* 205 */
#define OP$_MNEGL	0xCE	/* 206 */
#define OP$_CASEL	0xCF	/* 207 */
#define OP$_MOVL	0xD0	/* 208 */
#define OP$_CMPL	0xD1	/* 209 */
#define OP$_MCOML	0xD2	/* 210 */
#define OP$_BITL	0xD3	/* 211 */
#define OP$_CLRL	0xD4	/* 212 */
#define OP$_CLRF	0xD4	/* 212 */
#define OP$_TSTL	0xD5	/* 213 */
#define OP$_INCL	0xD6	/* 214 */
#define OP$_DECL	0xD7	/* 215 */
#define OP$_ADWC	0xD8	/* 216 */
#define OP$_SBWC	0xD9	/* 217 */
#define OP$_MTPR	0xDA	/* 218 */
#define OP$_MFPR	0xDB	/* 219 */
#define OP$_MOVPSL	0xDC	/* 220 */
#define OP$_PUSHL	0xDD	/* 221 */
#define OP$_POPL	0x8ED0	/* 36560 */
#define OP$_MOVAL	0xDE	/* 222 */
#define OP$_MOVAF	0xDE	/* 222 */
#define OP$_PUSHAL	0xDF	/* 223 */
#define OP$_PUSHAF	0xDF	/* 223 */
#define OP$_BBS		0xE0	/* 224 */
#define OP$_BBC		0xE1	/* 225 */
#define OP$_BBSS	0xE2	/* 226 */
#define OP$_BBCS	0xE3	/* 227 */
#define OP$_BBSC	0xE4	/* 228 */
#define OP$_BBCC	0xE5	/* 229 */
#define OP$_BBSSI	0xE6	/* 230 */
#define OP$_BBCCI	0xE7	/* 231 */
#define OP$_BLBS	0xE8	/* 232 */
#define OP$_BLBC	0xE9	/* 233 */
#define OP$_FFS		0xEA	/* 234 */
#define OP$_FFC		0xEB	/* 235 */
#define OP$_CMPV	0xEC	/* 236 */
#define OP$_CMPZV	0xED	/* 237 */
#define OP$_EXTV	0xEE	/* 238 */
#define OP$_EXTZV	0xEF	/* 239 */
#define OP$_INSV	0xF0	/* 240 */
#define OP$_ACBL	0xF1	/* 241 */
#define OP$_AOBLSS	0xF2	/* 242 */
#define OP$_AOBLEQ	0xF3	/* 243 */
#define OP$_SOBGEQ	0xF4	/* 244 */
#define OP$_SOBGTR	0xF5	/* 245 */
#define OP$_CVTLB	0xF6	/* 246 */
#define OP$_CVTLW	0xF7	/* 247 */
#define OP$_ASHP	0xF8	/* 248 */
#define OP$_CVTLP	0xF9	/* 249 */
#define OP$_CALLG	0xFA	/* 250 */
#define OP$_CALLS	0xFB	/* 251 */
#define OP$_XFC		0xFC	/* 252 */
#define OP$_ESCD	0xFD	/* 253 */
#define OP$_ESCE	0xFE	/* 254 */
#define OP$_ESCF	0xFF	/* 255 */
#define OP$_BUGW	0xFEFF	/* 65279 */
#define OP$_BUGL	0xFDFF	/* 65023 */
#define OP$_CVTDH	0x32FD	/* 13053 */
#define OP$_CVTGF	0x33FD	/* 13309 */
#define OP$_ADDG2	0x40FD	/* 16637 */
#define OP$_ADDG3	0x41FD	/* 16893 */
#define OP$_SUBG2	0x42FD	/* 17149 */
#define OP$_SUBG3	0x43FD	/* 17405 */
#define OP$_MULG2	0x44FD	/* 17661 */
#define OP$_MULG3	0x45FD	/* 17917 */
#define OP$_DIVG2	0x46FD	/* 18173 */
#define OP$_DIVG3	0x47FD	/* 18429 */
#define OP$_ADDH2	0x60FD	/* 24829 */
#define OP$_ADDH3	0x61FD	/* 25085 */
#define OP$_SUBH2	0x62FD	/* 25341 */
#define OP$_SUBH3	0x63FD	/* 25597 */
#define OP$_MULH2	0x64FD	/* 25853 */
#define OP$_MULH3	0x65FD	/* 26109 */
#define OP$_DIVH2	0x66FD	/* 26365 */
#define OP$_DIVH3	0x67FD	/* 26621 */
#define OP$_CVTGB	0x48FD	/* 18685 */
#define OP$_CVTGW	0x49FD	/* 18941 */
#define OP$_CVTGL	0x4AFD	/* 19197 */
#define OP$_CVTRGL	0x4BFD	/* 19453 */
#define OP$_CVTBG	0x4CFD	/* 19709 */
#define OP$_CVTWG	0x4DFD	/* 19965 */
#define OP$_CVTLG	0x4EFD	/* 20221 */
#define OP$_ACBG	0x4FFD	/* 20477 */
#define OP$_CVTHB	0x68FD	/* 26877 */
#define OP$_CVTHW	0x69FD	/* 27133 */
#define OP$_CVTHL	0x6AFD	/* 27389 */
#define OP$_CVTRHL	0x6BFD	/* 27645 */
#define OP$_CVTBH	0x6CFD	/* 27901 */
#define OP$_CVTWH	0x6DFD	/* 28157 */
#define OP$_CVTLH	0x6EFD	/* 28413 */
#define OP$_ACBH	0x6FFD	/* 28669 */
#define OP$_MOVG	0x50FD	/* 20733 */
#define OP$_CMPG	0x51FD	/* 20989 */
#define OP$_MNEGG	0x52FD	/* 21245 */
#define OP$_TSTG	0x53FD	/* 21501 */
#define OP$_EMODG	0x54FD	/* 21757 */
#define OP$_POLYG	0x55FD	/* 22013 */
#define OP$_CVTGH	0x56FD	/* 22269 */
#define OP$_MOVH	0x70FD	/* 28925 */
#define OP$_CMPH	0x71FD	/* 29181 */
#define OP$_MNEGH	0x72FD	/* 29437 */
#define OP$_TSTH	0x73FD	/* 29693 */
#define OP$_EMODH	0x74FD	/* 29949 */
#define OP$_POLYH	0x75FD	/* 30205 */
#define OP$_CVTHG	0x76FD	/* 30461 */
#define OP$_CLRH	0x7CFD	/* 31997 */
#define OP$_CLRO	0x7CFD	/* 31997 */
#define OP$_MOVO	0x7DFD	/* 32253 */
#define OP$_MOVAH	0x7EFD	/* 32509 */
#define OP$_MOVAO	0x7EFD	/* 32509 */
#define OP$_PUSHAH	0x7FFD	/* 32765 */
#define OP$_PUSHAO	0x7FFD	/* 32765 */
#define OP$_CVTFH	0x98FD	/* 39165 */
#define OP$_CVTFG	0x99FD	/* 39421 */
#define OP$_CVTHF	0xF6FD	/* 63229 */
#define OP$_CVTHD	0xF7FD	/* 63485 */

#endif	/*_OPDEF_H*/
