/* <posix_servicedef.h>
 *
 *	POSIX something-or-other (V5.5)
 */
#ifndef _POSIX_SERVICEDEF_H
#define _POSIX_SERVICEDEF_H

/* The following definitions are passed in the ctrl parameter. */
#define POSIX$C_BLOCK_FORK	1	/* block fork execution */
#define POSIX$C_UNBLOCK_FORK	2	/* unblock fork execution */
#define POSIX$C_DISABLE_FORK	3	/* disable fork */
#define POSIX$C_SETUP_CALLBACK	4	/* setup image callback */
#define POSIX$C_SYSTEM_CALLBACK 5	/* setup system callback */
#define POSIX$C_PROCESS_CALLBACK 6	/* setup process permanent callback */
#define POSIX$C_CANCEL_CALLBACK 7	/* cancel a callback */
#define POSIX$C_CONTINUE	8	/* continue callbacks */
#define POSIX$C_TEST_CALLS	9	/* temporary value for testing */
#define POSIX$C_MAX_CNTRL	9
#define POSIX$K_MAX_CNTRL	9
/*
 *  The following definitions are for the 'when' mask.	They define when
 *  callbacks are to be made.
 */
#define POSIX$V_CALL_BEFORE_COPY	0
#define POSIX$V_CALL_IN_CHILD		1
#define POSIX$V_CALL_AFTER_CHILD	2
#define POSIX$V_CALL_ON_FAILURE		3
#define POSIX$V_CALL_BEFORE_COPY_FAIL	4
#define POSIX$V_CALL_IN_CHILD_FAIL	5
#define POSIX$V_CALL_AFTER_CHILD_FAIL	6
#define POSIX$M_CALL_BEFORE_COPY	(1<<POSIX$V_CALL_BEFORE_COPY)	/* 0x01 */
#define POSIX$M_CALL_IN_CHILD		(1<<POSIX$V_CALL_IN_CHILD)	/* 0x02 */
#define POSIX$M_CALL_AFTER_CHILD	(1<<POSIX$V_CALL_AFTER_CHILD)	/* 0x04 */
#define POSIX$M_CALL_ON_FAILURE		(1<<POSIX$V_CALL_ON_FAILURE)	/* 0x08 */
#define POSIX$M_CALL_BEFORE_COPY_FAIL	(1<<POSIX$V_CALL_BEFORE_COPY_FAIL) /* 0x10 */
#define POSIX$M_CALL_IN_CHILD_FAIL	(1<<POSIX$V_CALL_IN_CHILD_FAIL)    /* 0x20 */
#define POSIX$M_CALL_AFTER_CHILD_FAIL	(1<<POSIX$V_CALL_AFTER_CHILD_FAIL) /* 0x40 */

#endif	/*_POSIX_SERVICEDEF_H*/
