/* <prcdef.h>
 *
 *	$CREPRC status flags and item codes
 */
#ifndef _PRCDEF_H
#define _PRCDEF_H

#define PRC$V_SSRWAIT	0
#define PRC$V_SSFEXCU	1
#define PRC$V_PSWAPM	2
#define PRC$V_NOACNT	3
#define PRC$V_BATCH	4
#define PRC$V_HIBER	5
#define PRC$V_NOUAF	6
#define PRC$V_NETWRK	7
#define PRC$V_DISAWS	8
#define PRC$V_DETACH	9
#define PRC$V_INTER	10
#define PRC$V_IMGDMP	11
#define PRC$V_CLISPEC	12
#define PRC$V_NOPASSWORD 13
#define PRC$V_DEBUG	14
#define PRC$V_DBGTRU	15
#ifndef NO_VMS_V6
#define PRC$V_SUBSYSTEM 16
#define PRC$V_TCB	17
#endif
#define PRC$V_LOGIN	PRC$V_NOUAF

#define PRC$M_SSRWAIT	(1<<PRC$V_SSRWAIT)	/* 0x01 */
#define PRC$M_SSFEXCU	(1<<PRC$V_SSFEXCU)	/* 0x02 */
#define PRC$M_PSWAPM	(1<<PRC$V_PSWAPM)	/* 0x04 */
#define PRC$M_NOACNT	(1<<PRC$V_NOACNT)	/* 0x08 */
#define PRC$M_BATCH	(1<<PRC$V_BATCH)	/* 0x10 */
#define PRC$M_HIBER	(1<<PRC$V_HIBER)	/* 0x20 */
#define PRC$M_NOUAF	(1<<PRC$V_NOUAF)	/* 0x40 */
#define PRC$M_NETWRK	(1<<PRC$V_NETWRK)	/* 0x80 */
#define PRC$M_DISAWS	(1<<PRC$V_DISAWS)	/* 0x0100 */
#define PRC$M_DETACH	(1<<PRC$V_DETACH)	/* 0x0200 */
#define PRC$M_INTER	(1<<PRC$V_INTER)	/* 0x0400 */
#define PRC$M_IMGDMP	(1<<PRC$V_IMGDMP)	/* 0x0800 */
#define PRC$M_CLISPEC	(1<<PRC$V_CLISPEC)	/* 0x1000 */
#define PRC$M_NOPASSWORD (1<<PRC$V_NOPASSWORD)	/* 0x2000 */
#define PRC$M_DEBUG	(1<<PRC$V_DEBUG)	/* 0x4000 */
#define PRC$M_DBGTRU	(1<<PRC$V_DBGTRU)	/* 0x8000 */
#ifndef NO_VMS_V6
#define PRC$M_SUBSYSTEM (1<<PRC$V_SUBSYSTEM)	/* 0x010000 */
#define PRC$M_TCB	(1<<PRC$V_TCB)		/* 0x020000 */
#endif
#define PRC$M_LOGIN	(1<<PRC$V_LOGIN)	/* 0x40 */

union prcdef {
    struct {
	unsigned prc$v_ssrwait : 1;	/* resource wait disable */
	unsigned prc$v_ssfexcu : 1;	/* system service fail exception mode */
	unsigned prc$v_pswapm  : 1;	/* process swap mode */
	unsigned prc$v_noacnt  : 1;	/* accounting message disable */
	unsigned prc$v_batch   : 1;	/* batch indicator */
	unsigned prc$v_hiber   : 1;	/* hibernate before calling initial image */
	unsigned prc$v_nouaf   : 1;	/* bypass login verification for detached proc. */
	unsigned prc$v_netwrk  : 1;	/* network indicator */
	unsigned prc$v_disaws  : 1;	/* disable working set adjust */
	unsigned prc$v_detach  : 1;	/* detached process */
	unsigned prc$v_inter   : 1;	/* interactive indicator */
	unsigned prc$v_imgdmp  : 1;	/* image dump requested */
	unsigned prc$v_clispec : 1;	/* pass CLI specifications */
	unsigned prc$v_nopassword : 1;	/* don't prompt for username and password */
	unsigned prc$v_debug   : 1;	/* /debug desired */
	unsigned prc$v_dbgtru  : 1;	/* debugger present */
#ifndef NO_VMS_V6
	unsigned prc$v_subsystem : 1;	/* inherit protected subsystem identifiers */
	unsigned prc$v_tcb     : 1;	/* process is part of TCB */
	unsigned	       : 14;
#else
	unsigned	       : 16;
#endif
    } prc$r_prcdef_bits;
    struct {
	unsigned	       : 6;
	unsigned prc$v_login   : 1;	/* bypass login verification for detached proc. */
	unsigned	       : 1;
    } prc$r_prcdef_obsolete;
};

/* create process item list data identifier definitions */
#define PRC$_LISTEND	0	/* end of list (must be first code) */
#define PRC$_PGFLCHAR	1	/* page file characteristics */
#define PRC$_PGFLINDEX	2	/* page file index */
#define PRC$_INPUT_ATT	3	/* SYS$INPUT attributes */
#define PRC$_OUTPUT_ATT 4	/* SYS$OUTPUT attributes */
#define PRC$_ERROR_ATT	5	/* SYS$ERROR attributes */
#define PRC$_CLASS	6	/* process classification */

#endif	/*_PRCDEF_H*/
