/* <prvdef.h>
 *
 *	Privilege bit definitions
 */
#ifndef _PRVDEF_H
#define _PRVDEF_H

/* first privilege longword */
#define PRV$V_CMKRNL	0
#define PRV$V_CMEXEC	1
#define PRV$V_SYSNAM	2
#define PRV$V_GRPNAM	3
#define PRV$V_ALLSPOOL	4
#define PRV$V_DETACH	5
#define PRV$V_DIAGNOSE	6
#define PRV$V_LOG_IO	7
#define PRV$V_GROUP	8
#define PRV$V_NOACNT	9
#define PRV$V_ACNT	PRV$V_NOACNT
#define PRV$V_PRMCEB	10
#define PRV$V_PRMMBX	11
#define PRV$V_PSWAPM	12
#define PRV$V_SETPRI	13
#define PRV$V_ALTPRI	PRV$V_SETPRI
#define PRV$V_SETPRV	14
#define PRV$V_TMPMBX	15
#define PRV$V_WORLD	16
#define PRV$V_MOUNT	17
#define PRV$V_OPER	18
#define PRV$V_EXQUOTA	19
#define PRV$V_NETMBX	20
#define PRV$V_VOLPRO	21
#define PRV$V_PHY_IO	22
#define PRV$V_BUGCHK	23
#define PRV$V_PRMGBL	24
#define PRV$V_SYSGBL	25
#define PRV$V_PFNMAP	26
#define PRV$V_SHMEM	27
#define PRV$V_SYSPRV	28
#define PRV$V_BYPASS	29
#define PRV$V_SYSLCK	30
#define PRV$V_SHARE	31

#define PRV$M_CMKRNL	(1<<PRV$V_CMKRNL)	/* 0x01 */
#define PRV$M_CMEXEC	(1<<PRV$V_CMEXEC)	/* 0x02 */
#define PRV$M_SYSNAM	(1<<PRV$V_SYSNAM)	/* 0x04 */
#define PRV$M_GRPNAM	(1<<PRV$V_GRPNAM)	/* 0x08 */
#define PRV$M_ALLSPOOL	(1<<PRV$V_ALLSPOOL)	/* 0x10 */
#define PRV$M_DETACH	(1<<PRV$V_DETACH)	/* 0x20 */
#define PRV$M_DIAGNOSE	(1<<PRV$V_DIAGNOSE)	/* 0x40 */
#define PRV$M_LOG_IO	(1<<PRV$V_LOG_IO)	/* 0x80 */
#define PRV$M_GROUP	(1<<PRV$V_GROUP)	/* 0x0100 */
#define PRV$M_ACNT	(1<<PRV$V_ACNT)		/* 0x0200 */
#define PRV$M_NOACNT	(1<<PRV$V_NOACNT)	/* 0x0200 */
#define PRV$M_PRMCEB	(1<<PRV$V_PRMCEB)	/* 0x0400 */
#define PRV$M_PRMMBX	(1<<PRV$V_PRMMBX)	/* 0x0800 */
#define PRV$M_PSWAPM	(1<<PRV$V_PSWAPM)	/* 0x1000 */
#define PRV$M_ALTPRI	(1<<PRV$V_ALTPRI)	/* 0x2000 */
#define PRV$M_SETPRI	(1<<PRV$V_SETPRI)	/* 0x2000 */
#define PRV$M_SETPRV	(1<<PRV$V_SETPRV)	/* 0x4000 */
#define PRV$M_TMPMBX	(1<<PRV$V_TMPMBX)	/* 0x8000 */
#define PRV$M_WORLD	(1<<PRV$V_WORLD)	/* 0x010000 */
#define PRV$M_MOUNT	(1<<PRV$V_MOUNT)	/* 0x020000 */
#define PRV$M_OPER	(1<<PRV$V_OPER)		/* 0x040000 */
#define PRV$M_EXQUOTA	(1<<PRV$V_EXQUOTA)	/* 0x080000 */
#define PRV$M_NETMBX	(1<<PRV$V_NETMBX)	/* 0x100000 */
#define PRV$M_VOLPRO	(1<<PRV$V_VOLPRO)	/* 0x200000 */
#define PRV$M_PHY_IO	(1<<PRV$V_PHY_IO)	/* 0x400000 */
#define PRV$M_BUGCHK	(1<<PRV$V_BUGCHK)	/* 0x800000 */
#define PRV$M_PRMGBL	(1<<PRV$V_PRMGBL)	/* 0x01000000 */
#define PRV$M_SYSGBL	(1<<PRV$V_SYSGBL)	/* 0x02000000 */
#define PRV$M_PFNMAP	(1<<PRV$V_PFNMAP)	/* 0x04000000 */
#define PRV$M_SHMEM	(1<<PRV$V_SHMEM)	/* 0x08000000 */
#define PRV$M_SYSPRV	(1<<PRV$V_SYSPRV)	/* 0x10000000 */
#define PRV$M_BYPASS	(1<<PRV$V_BYPASS)	/* 0x20000000 */
#define PRV$M_SYSLCK	(1<<PRV$V_SYSLCK)	/* 0x40000000 */
#define PRV$M_SHARE	(1<<PRV$V_SHARE)	/* 0x80000000 */

/* second privilege longword */
#define PRV$V_UPGRADE	32
#define PRV$V_DOWNGRADE 33
#define PRV$V_GRPPRV	34
#define PRV$V_READALL	35
#define PRV$V_TMPJNL	36	/* obsolete */
#define PRV$V_PRMJNL	37	/* obsolete */
#ifndef NO_VMS_V6
#define PRV$V_IMPORT	36
#define PRV$V_AUDIT	37
#endif
#define PRV$V_SECURITY	38
#define PRV2$V_UPGRADE	 0
#define PRV2$V_DOWNGRADE 1
#define PRV2$V_GRPPRV	 2
#define PRV2$V_READALL	 3
#define PRV2$V_TMPJNL	 4
#define PRV2$V_PRMJNL	 5
#ifndef NO_VMS_V6
#define PRV2$V_IMPORT	 4
#define PRV2$V_AUDIT	 5
#endif
#define PRV2$V_SECURITY  6

#define PRV2$M_UPGRADE	(1<<PRV2$V_UPGRADE)	/* 0x01 */
#define PRV2$M_DOWNGRADE (1<<PRV2$V_DOWNGRADE)	/* 0x02 */
#define PRV2$M_GRPPRV	(1<<PRV2$V_GRPPRV)	/* 0x04 */
#define PRV2$M_READALL	(1<<PRV2$V_READALL)	/* 0x08 */
#define PRV2$M_TMPJNL	(1<<PRV2$V_TMPJNL)	/* 0x10 */
#define PRV2$M_PRMJNL	(1<<PRV2$V_PRMJNL)	/* 0x20 */
#ifndef NO_VMS_V6
#define PRV2$M_IMPORT	(1<<PRV2$V_IMPORT)	/* 0x10 */
#define PRV2$M_AUDIT	(1<<PRV2$V_AUDIT)	/* 0x20 */
#endif
#define PRV2$M_SECURITY (1<<PRV2$V_SECURITY)	/* 0x40 */

#ifndef NO_VMS_V6
#define PRV$K_NUMBER_OF_PRIVS	39	/* total number of privilege bits */
#endif

union prvdef {
    struct {
	unsigned prv$v_cmkrnl	: 1;	/* may change mode to kernel */
	unsigned prv$v_cmexec	: 1;	/* may change mode to exec */
	unsigned prv$v_sysnam	: 1;	/* may insert in system logical name table */
	unsigned prv$v_grpnam	: 1;	/* may insert in group logical name table */
	unsigned prv$v_allspool : 1;	/* may allocate spooled device */
	unsigned prv$v_detach	: 1;	/* may create detached processes */
	unsigned prv$v_diagnose : 1;	/* may diagnose devices */
	unsigned prv$v_log_io	: 1;	/* may do logical I/O */
	unsigned prv$v_group	: 1;	/* may affect other processes in same group */
	unsigned prv$v_noacnt	: 1;	/* may suppress accounting message */
	unsigned prv$v_prmceb	: 1;	/* may create permanent common event clusters */
	unsigned prv$v_prmmbx	: 1;	/* may create permanent mailbox */
	unsigned prv$v_pswapm	: 1;	/* may change process swap mode */
	unsigned prv$v_setpri	: 1;	/* may set any priority value */
	unsigned prv$v_setprv	: 1;	/* may set any privilege bits */
	unsigned prv$v_tmpmbx	: 1;	/* may create temporary mailbox */
	unsigned prv$v_world	: 1;	/* may affect other processes in the world */
	unsigned prv$v_mount	: 1;	/* may execute mount ACP functions */
	unsigned prv$v_oper	: 1;	/* operator privilege */
	unsigned prv$v_exquota	: 1;	/* may exceed quotas */
	unsigned prv$v_netmbx	: 1;	/* may create network device */
	unsigned prv$v_volpro	: 1;	/* may override volume protection */
	unsigned prv$v_phy_io	: 1;	/* may do physical I/O */
	unsigned prv$v_bugchk	: 1;	/* may make bug check error log entries */
	unsigned prv$v_prmgbl	: 1;	/* may create permanent global sections */
	unsigned prv$v_sysgbl	: 1;	/* may create system wide global sections */
	unsigned prv$v_pfnmap	: 1;	/* may map to section by PFN */
	unsigned prv$v_shmem	: 1;	/* may allocate structures in shared memory */
	unsigned prv$v_sysprv	: 1;	/* eligible for system protection field */
	unsigned prv$v_bypass	: 1;	/* may bypass UIC based protection */
	unsigned prv$v_syslck	: 1;	/* may create system wide locks */
	unsigned prv$v_share	: 1;	/* may assign channel to non-shared device */
	unsigned prv$v_upgrade	: 1;	/* may upgrade integrity */
	unsigned prv$v_downgrade: 1;	/* may downgrade secrecy */
	unsigned prv$v_grpprv	: 1;	/* group access via system protection field */
	unsigned prv$v_readall	: 1;	/* read access to everything */
	unsigned prv$v_import	: 1;	/* may set classification for unlabeled object */
	unsigned prv$v_audit	: 1;	/* may direct audit to system security audit log */
	unsigned prv$v_security : 1;	/* may perform security functions */
	unsigned		: 1;	/* (reserved for SEVMS) */
	unsigned		: 24;
    } prv$r_prvdef_bits0;
    struct {
	unsigned		: 9;	/* skip 9 */
	unsigned prv$v_acnt	: 1;	/* may suppress accounting messages (NOACNT) */
	unsigned		: 3;	/* skip 3 */
	unsigned prv$v_altpri	: 1;	/* may set any priority vale (SETPRI) */
	unsigned		: 2;
	unsigned		: 16;
	unsigned		: 32;
    } prv$r_prvdef_bits1;
    struct {
	unsigned prv$l_l1_bits;		/* bits in first longword */
	unsigned prv$l_l2_bits;		/* bits in second longword */
    } prv$r_prvdef_bits2;
};

#ifndef NO_VMS_V6
#define PRV$V_SORTED	0
#define PRV$V_BRIEF	1
#define PRV$V_FILLED	2
#define PRV$M_SORTED	(1<<PRV$V_SORTED)	/* 0x01 */
#define PRV$M_BRIEF	(1<<PRV$V_BRIEF)	/* 0x02 */
#define PRV$M_FILLED	(1<<PRV$V_FILLED)	/* 0x04 */
struct prvdsp_bits {
    unsigned prv$v_sorted	: 1;	/* sort privilege list */
    unsigned prv$v_brief	: 1;	/* display only privilege names */
    unsigned prv$v_filled	: 1;	/* display names in columns */
    unsigned			: 29;
};
#endif

#endif	/*_PRVDEF_H*/
