/* <prxdef.h>
 */
#ifndef _PRXDEF_H
#define _PRXDEF_H

#define PRX$K_ADD		1
#define PRX$K_DELETE		2
#define PRX$K_SHOW		3
#define PRX$K_VERIFY		4
#define PRX$K_PERFORMANCE	5
#define PRX$K_ZERO_PERFORMANCE	6
#define PRX$K_CREATE		7
#define PRX$K_STOP		8
#define PRX$K_START		9
#define PRX$K_MAX_PROXY_CODE	10
#define PRX$K_PERFORMANCE_LENGTH 48

struct prx$performance {
    unsigned prx$l_total_messages;
    unsigned prx$l_total_exceptions;
    unsigned prx$l_shows;
    unsigned prx$l_adds;
    unsigned prx$l_deletes;
    unsigned prx$l_verifys;
    unsigned prx$l_performance;
    unsigned prx$l_creates;
    unsigned prx$l_stops;
    unsigned prx$l_starts;
    unsigned prx$l_audits;
    unsigned prx$l_invalid_messages;
};

#define PRX$V_IGNORE_RETURN	0
#define PRX$V_BYPASS_EXPAND	1
#define PRX$V_RESERVE_1		2
#define PRX$V_DEFAULT		8
#define PRX$V_EXACT		9
#define PRX$V_DELETE_ALLOWED	10
#define PRX$M_IGNORE_RETURN	(1<<PRX$V_IGNORE_RETURN)	/* 0x0001 */
#define PRX$M_BYPASS_EXPAND	(1<<PRX$V_BYPASS_EXPAND)	/* 0x0002 */
#define PRX$M_RESERVE_1		0x00FC
#define PRX$M_DEFAULT		(1<<PRX$V_DEFAULT)		/* 0x0100 */
#define PRX$M_EXACT		(1<<PRX$V_EXACT)		/* 0x0200 */
#define PRX$M_DELETE_ALLOWED	(1<<PRX$V_DELETE_ALLOWED)	/* 0x0400 */
#define PRX$K_HEADER_LENGTH	8

struct prx$header {
    unsigned		prx$l_context;
    union {
	unsigned	prx$l_flags;
	struct {
	    unsigned prx$v_ignore_return  : 1;
	    unsigned prx$v_bypass_expand  : 1;
	    unsigned prx$v_reserve_1	  : 6;
	    unsigned prx$v_default	  : 1;
	    unsigned prx$v_exact	  : 1;
	    unsigned prx$v_delete_allowed : 1;
	    unsigned			  : 21;
	} prx$r_flags_fields;
    } prx$r_flags_overlay;
};

struct prx$generic_desc1 {
    unsigned short	prx$w_desc_length;
    unsigned short	prx$w_fill;
    char		prx$t_desc_data[1];
};

#define PRX$K_USER_NAME_LENGTH	32
#define PRX$K_REMOTE_NODE_NAME_LENGTH 1024
#define PRX$K_MAX_LOCAL_USERS	16
#define PRX$K_LOCAL_USER_ENTRY	36
struct prx$data {
    unsigned short	prx$w_local_user_length;
    unsigned	: 16;
    char		prx$t_local_user_name[32];
    unsigned short	prx$w_remote_user_length;
    unsigned	: 16;
    char		prx$t_remote_user_name[32];
    unsigned short	prx$w_remote_node_length;
    unsigned	: 16;
    char		prx$t_remote_node_name[1024];
};
#define PRX$K_DATA_LENGTH	1100

struct prx$bufsiz_summary {
    unsigned short	prx$w_bufsiz_user;	/* proxy user length */
    unsigned short	prx$w_bufsiz_node;	/* proxy node length */
    unsigned short	prx$w_bufsiz_local_count; /* number of local users */
    unsigned short	prx$w_bufsiz_def_user;	/* length of default user */
};

#define PRX$K_MAX_REPLY 1692
union prx$reply {
    struct {
	unsigned	prx$l_reply_status;	/* status of request */
    } prx$r_generic_reply;
    struct {
	unsigned	prx$l_reply_status;	/* status of request */
	unsigned short	prx$w_valid_user;	/* length of proxy user_name */
	unsigned    : 16;
	char		prx$t_valid_user[32];	/* proxy usernname */
    } prx$r_verify_reply;
    struct {
	unsigned	prx$l_reply_status;	/* status of request */
	unsigned	prx$l_show_context;	/* returned context */
	unsigned short	prx$w_show_def_user;	/* length of default user_name */
	unsigned    : 16;
	char		prx$t_show_def_user[32]; /* default user_name */
	unsigned short prx$w_show_rem_user;	/* length of remote user_name */
	unsigned    : 16;
	char		prx$t_show_rem_user[32]; /* remote user_name */
	unsigned short	prx$w_show_local_count; /* count of local user_names */
	unsigned short	prx$w_show_local_size;	/* size of local user_name (bytes) */
	char		prx$t_show_local_data[1]; /* start of local user_names */
    } prx$r_show_reply;
};
#define PRX$K_MAX_LENGTH	1108

#endif	/*_PRXDEF_H*/
