/* <pscandef.h>
 *
 *	$PROCESS_SCAN item code definitions (VMS V5.2 and later)
 */
#ifndef _PSCANDEF_H
#define _PSCANDEF_H

/* item code definitions */
#define PSCAN$_BEGIN	0
#define PSCAN$_ACCOUNT	1	/* match on account name */
#define PSCAN$_AUTHPRI	2	/* match on authorized priority */
#define PSCAN$_CURPRIV	3	/* match on current privs */
#define PSCAN$_GRP	4	/* match on GRP field */
#define PSCAN$_HW_MODEL 5	/* match on system's HW_MODEL */
#define PSCAN$_HW_NAME	6	/* match on system's HW_NAME */
#define PSCAN$_JOBPRCCNT 7	/* match on job subprocess count */
#define PSCAN$_JOBTYPE	8	/* match on job origin type field */
#define PSCAN$_MASTER_PID 9	/* match on PID of master process */
#define PSCAN$_MEM	10	/* match on MEM field */
#define PSCAN$_MODE	11	/* match on process mode */
#define PSCAN$_NODE_CSID 12	/* match on system's CSID */
#define PSCAN$_NODENAME 13	/* match on system's nodename */
#define PSCAN$_OWNER	14	/* match on PID of owner */
#define PSCAN$_PRCCNT	15	/* match on subprocess count */
#define PSCAN$_PRCNAM	16	/* match on process name */
#define PSCAN$_PRI	17	/* match on current priority */
#define PSCAN$_PRIB	18	/* match on base priority */
#define PSCAN$_STATE	19	/* match on process state */
#define PSCAN$_STS	20	/* match on process status */
#define PSCAN$_TERMINAL 21	/* match on terminal name */
#define PSCAN$_UIC	22	/* match on UIC field */
#define PSCAN$_USERNAME 23	/* match on username */
#define PSCAN$_GETJPI_BUFFER_SIZE 24 /* buffer for blocking */
#define PSCAN$_END	25
#define PSCAN$K_TYPE	129

#define PSCAN$V_OR		0
#define PSCAN$V_BIT_ALL		1
#define PSCAN$V_BIT_ANY		2
#define PSCAN$V_GEQ		3
#define PSCAN$V_GTR		4
#define PSCAN$V_LEQ		5
#define PSCAN$V_LSS		6
#define PSCAN$V_PREFIX_MATCH	7
#define PSCAN$V_WILDCARD	8
#define PSCAN$V_CASE_BLIND	9
#define PSCAN$V_EQL		10
#define PSCAN$V_NEQ		11

#define PSCAN$M_OR		(1<<PSCAN$V_OR)			/* 0x0001 */
#define PSCAN$M_BIT_ALL		(1<<PSCAN$V_BIT_ALL)		/* 0x0002 */
#define PSCAN$M_BIT_ANY		(1<<PSCAN$V_BIT_ANY)		/* 0x0004 */
#define PSCAN$M_GEQ		(1<<PSCAN$V_GEQ)		/* 0x0008 */
#define PSCAN$M_GTR		(1<<PSCAN$V_GTR)		/* 0x0010 */
#define PSCAN$M_LEQ		(1<<PSCAN$V_LEQ)		/* 0x0020 */
#define PSCAN$M_LSS		(1<<PSCAN$V_LSS)		/* 0x0040 */
#define PSCAN$M_PREFIX_MATCH	(1<<PSCAN$V_PREFIX_MATCH)	/* 0x0080 */
#define PSCAN$M_WILDCARD	(1<<PSCAN$V_WILDCARD)		/* 0x0100 */
#define PSCAN$M_CASE_BLIND	(1<<PSCAN$V_CASE_BLIND)		/* 0x0200 */
#define PSCAN$M_EQL		(1<<PSCAN$V_EQL)		/* 0x0400 */
#define PSCAN$M_NEQ		(1<<PSCAN$V_NEQ)		/* 0x0800 */

struct pscan$item_specific_flags {
    unsigned pscan$v_or		: 1;	/* logical OR of items */
    unsigned pscan$v_bit_all	: 1;	/* all bits set in pattern */
    unsigned pscan$v_bit_any	: 1;	/* any bit set in pattern */
    unsigned pscan$v_geq	: 1;
    unsigned pscan$v_gtr	: 1;
    unsigned pscan$v_leq	: 1;
    unsigned pscan$v_lss	: 1;
    unsigned pscan$v_prefix_match : 1;	/* match on leading substring */
    unsigned pscan$v_wildcard	: 1;	/* wildcard pattern */
    unsigned pscan$v_case_blind : 1;	/* ignore case of text strings */
    unsigned pscan$v_eql	: 1;
    unsigned pscan$v_neq	: 1;
    unsigned			: 4;
};

#endif	/*_PSCANDEF_H*/
