/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <rms$routines.h>
 *
 *	RMS routines from Starlet.
 */
#ifndef _RMS$ROUTINES_H
#define _RMS$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif
	/* part of <starlet.h> */

/*  $CLOSE		[RMS] close file */
/*	$CLOSE	fab[,err[,suc]] */
#define sys$close SYS$CLOSE
unsigned long sys$close();
/*  $CONNECT		[RMS] connect file */
/*	$CONNECT rab[,err[,suc]] */
#define sys$connect SYS$CONNECT
unsigned long sys$connect();
/*  $CREATE		[RMS] create file */
/*	$CREATE fab[,err[,suc]] */
#define sys$create SYS$CREATE
unsigned long sys$create();
/*  $DELETE		[RMS] delete record */
/*	$DELETE rab[,err[,suc]] */
#define sys$delete SYS$DELETE
unsigned long sys$delete();
/*  $DISCONNECT		[RMS] disconnect record stream */
/*	$DISCONNECT rab[,err[,suc]] */
#define sys$disconnect SYS$DISCONNECT
unsigned long sys$disconnect();
/*  $DISPLAY		[RMS] display file */
/*	$DISPLAY fab[,err[,suc]] */
#define sys$display SYS$DISPLAY
unsigned long sys$display();
/*  $ENTER		[RMS] enter file into directory */
/*	$ENTER	fab[,err[,suc]] */
#define sys$enter SYS$ENTER
unsigned long sys$enter();
/*  $ERASE		[RMS] erase file */
/*	$ERASE	fab[,err[,suc]] */
#define sys$erase SYS$ERASE
unsigned long sys$erase();
/*  $EXTEND		[RMS] extend file */
/*	$EXTEND fab[,err[,suc]] */
#define sys$extend SYS$EXTEND
unsigned long sys$extend();
/*  $FIND		[RMS] find record in file */
/*	$FIND	rab[,err[,suc]] */
#define sys$find SYS$FIND
unsigned long sys$find();
/*  $FLUSH		[RMS] flush record */
/*	$FLUSH	rab[,err[,suc]] */
#define sys$flush SYS$FLUSH
unsigned long sys$flush();
/*  $FREE		[RMS] free record */
/*	$FREE	rab[,err[,suc]] */
#define sys$free SYS$FREE
unsigned long sys$free();
/*  $GET		[RMS] get record from file */
/*	$GET	rab[,err[,suc]] */
#define sys$get SYS$GET
unsigned long sys$get();
/*  $MODIFY		[RMS] modify file [not documented] */
/*	$MODIFY fab[,err[,suc]] */
#define sys$modify SYS$MODIFY
unsigned long sys$modify();
/*  $NXTVOL		[RMS] go to next volume */
/*	$NXTVOL rab[,err[,suc]] */
#define sys$nxtvol SYS$NXTVOL
unsigned long sys$nxtvol();
/*  $OPEN		[RMS] open file */
/*	$OPEN	fab[,err[,suc]] */
#define sys$open SYS$OPEN
unsigned long sys$open();
/*  $PARSE		[RMS] parse file name */
/*	$PARSE	fab[,err[,suc]] */
#define sys$parse SYS$PARSE
unsigned long sys$parse();
/*  $PUT		[RMS] put record to file */
/*	$PUT	rab[,err[,suc]] */
#define sys$put SYS$PUT
unsigned long sys$put();
/*  $READ		[RMS] read block from file */
/*	$READ	rab[,err[,suc]] */
#define sys$read SYS$READ
unsigned long sys$read();
/*  $RELEASE		[RMS] release record */
/*	$RELEASE rab[,err[,suc]] */
#define sys$release SYS$RELEASE
unsigned long sys$release();
/*  $REMOVE		[RMS] remove file */
/*	$REMOVE fab[,err[,suc]] */
#define sys$remove SYS$REMOVE
unsigned long sys$remove();
/*  $RENAME		[RMS] rename file */
/*	$RENAME oldfab,[err],[suc],newfab */
#define sys$rename SYS$RENAME
unsigned long sys$rename();
/*  $REWIND		[RMS] rewind file */
/*	$REWIND rab[,err[,suc]] */
#define sys$rewind SYS$REWIND
unsigned long sys$rewind();
/*  $RUNDWN		[RMS] rundown process [not documented] */
/*	$RUNDWN [acmode] */
#define sys$rundwn SYS$RUNDWN
unsigned long sys$rundwn();
/*  $SEARCH		[RMS] search for file name */
/*	$SEARCH fab[,err[,suc]] */
#define sys$search SYS$SEARCH
unsigned long sys$search();
/*  $SPACE		[RMS] space to record in file */
/*	$SPACE	rab[,err[,suc]] */
#define sys$space SYS$SPACE
unsigned long sys$space();
/*  $TRUNCATE		[RMS] truncate record */
/*	$TRUNCATE rab[,err[,suc]] */
#define sys$truncate SYS$TRUNCATE
unsigned long sys$truncate();
/*  $UPDATE		[RMS] update record */
/*	$UPDATE fab[,err[,suc]] */
#define sys$update SYS$UPDATE
unsigned long sys$update();
/*  $WAIT		[RMS] wait on file */
/*	$WAIT	rab */
#define sys$wait SYS$WAIT
unsigned long sys$wait();
/*  $WRITE		[RMS] write block to  file */
/*	$WRITE	rab[,err[,suc]] */
#define sys$write SYS$WRITE
unsigned long sys$write();

	/* these three orphans are duplicated in <sys$routines.h> */
/*  $RMSRUNDWN		RMS rundown -- close all files opened by RMS */
/*	SYS$RMSRUNDWN bufadr,typval */
#define sys$rmsrundwn SYS$RMSRUNDWN
unsigned long sys$rmsrundwn(void *,int);	/* (dsc$descriptor_s,byte) */
/*  $SETDDIR		set RMS default directory */
/*	SYS$SETDDIR [newdir],[oldlen],[olddir] */
#define sys$setddir SYS$SETDDIR
unsigned long sys$setddir(const void *,unsigned short *,void *);
/*  $SETDFPROT		set RMS default file protection */
/*	SYS$SETDFPROT [newprot],[oldprot] */
#define sys$setdfprot SYS$SETDFPROT
unsigned long sys$setdfprot(const unsigned short *,unsigned short *);

# ifdef __cplusplus
}
# endif
#endif	/*_RMS$ROUTINES_H*/
