/* <sfdef.h>
 *
 *	Stack frame offset definitions
 */
#ifndef _SFDEF_H
#define _SFDEF_H

#define SF$V_C	  0
#define SF$V_V	  1
#define SF$V_Z	  2
#define SF$V_N	  3
#define SF$V_TBIT 4
#define SF$V_IV   5
#define SF$V_FU   6
#define SF$V_DV   7
#define SF$M_C	  (1<<SF$V_C)		/* 0x01 */
#define SF$M_V	  (1<<SF$V_V)		/* 0x02 */
#define SF$M_Z	  (1<<SF$V_Z)		/* 0x04 */
#define SF$M_N	  (1<<SF$V_N)		/* 0x08 */
#define SF$M_TBIT (1<<SF$V_TBIT)	/* 0x10 */
#define SF$M_IV   (1<<SF$V_IV)		/* 0x20 */
#define SF$M_FU   (1<<SF$V_FU)		/* 0x40 */
#define SF$M_DV   (1<<SF$V_DV)		/* 0x80 */

#define sfdef sf$frame		/* VAX C compability */
struct sfdef {
    void *sf$a_handler;			/* adr. of handler or 0 if no handler */
    union {
	unsigned short sf$w_save_psw; /* saved PSW */
	struct {
	    unsigned sf$v_c    : 1;	/* carry */
	    unsigned sf$v_v    : 1;	/* overflow */
	    unsigned sf$v_z    : 1;	/* zero */
	    unsigned sf$v_n    : 1;	/* negative */
	    unsigned sf$v_tbit : 1;	/* trace trap enable */
	    unsigned sf$v_iv   : 1;	/* integer overflow enable */
	    unsigned sf$v_fu   : 1;	/* floating underflow enable */
	    unsigned sf$v_dv   : 1;	/* decimal overflow enable */
	    unsigned	       : 8;
	} sf$r_save_psw_bits;
    } sf$r_save_psw_overlay;
    union {
	unsigned short sf$w_save_mask;	/* saved register mask plus flags */
	struct {
	    unsigned sf$v_save_mask : 12; /* register save mask */
	    unsigned		    : 1;  /* MBZ */
	    unsigned sf$v_calls     : 1;  /* 1 if CALLS */
	    unsigned sf$v_stackoffs : 2;  /* SP offset */
	} sf$r_save_mask_bits;
    } sf$r_save_mask_overlay;
    unsigned long sf$l_save_ap;		/* saved AP */
    unsigned long sf$l_save_fp;		/* saved FP */
    unsigned long sf$l_save_pc;		/* saved PC */
    unsigned long sf$l_save_regs;	/* first register saved is saved here */
};

#endif	/*_SFDEF_H*/
