/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <smgdef.h>
 *
 *	Screen Management run-time library definitions
 */
#ifndef _SMGDEF_H
#define _SMGDEF_H

/* Input terminator codes */
#define SMG$K_TRM_NULL_CHAR	0	/* NUL */
#define SMG$K_TRM_CTRLA		1	/* SOH */
#define SMG$K_TRM_CTRLB		2	/* STX */
#define SMG$K_TRM_CTRLC		3	/* ETX */
#define SMG$K_TRM_CTRLD		4	/* EOT */
#define SMG$K_TRM_CTRLE		5	/* ENQ */
#define SMG$K_TRM_CTRLF		6	/* ACK */
#define SMG$K_TRM_CTRLG		7	/* BEL */
#define SMG$K_TRM_CTRLH		8	/* BS */
#define SMG$K_TRM_CTRLI		9	/* HT */
#define SMG$K_TRM_CTRLJ		10	/* LF */
#define SMG$K_TRM_CTRLK		11	/* VT */
#define SMG$K_TRM_CTRLL		12	/* FF */
#define SMG$K_TRM_CTRLM		13	/* CR */
#define SMG$K_TRM_CTRLN		14	/* SO */
#define SMG$K_TRM_CTRLO		15	/* SI */
#define SMG$K_TRM_CTRLP		16	/* DLE */
#define SMG$K_TRM_CTRLQ		17	/* DC1 */
#define SMG$K_TRM_CTRLR		18	/* DC2 */
#define SMG$K_TRM_CTRLS		19	/* DC3 */
#define SMG$K_TRM_CTRLT		20	/* DC4 */
#define SMG$K_TRM_CTRLU		21	/* NAK */
#define SMG$K_TRM_CTRLV		22	/* SYN */
#define SMG$K_TRM_CTRLW		23	/* ETB */
#define SMG$K_TRM_CTRLX		24	/* CAN */
#define SMG$K_TRM_CTRLY		25	/* EM */
#define SMG$K_TRM_CTRLZ		26	/* SUB */
#define SMG$K_TRM_ESCAPE	27	/* ESC */
#define SMG$K_TRM_FS		28	/* FS */
#define SMG$K_TRM_GS		29	/* GS */
#define SMG$K_TRM_RS		30	/* RS */
#define SMG$K_TRM_US		31	/* US */
#define SMG$K_TRM_SPACE		32	/* SP */
#define SMG$K_TRM_EXCLAMATION_POINT 33	/* ! */
#define SMG$K_TRM_DOUBLE_QUOTE	34	/* " double quote " */
#define SMG$K_TRM_NUMBER_SIGN	35	/* # */
#define SMG$K_TRM_DOLLAR_SIGN	36	/* $ */
#define SMG$K_TRM_PERCENT_SIGN	37	/* % */
#define SMG$K_TRM_AMPERSAND	38	/* & */
#define SMG$K_TRM_QUOTE		39	/* ' single quote ' */
#define SMG$K_TRM_LEFT_PAREN	40	/* ( */
#define SMG$K_TRM_RIGHT_PAREN	41	/* ) */
#define SMG$K_TRM_ASTERISK	42	/* * */
#define SMG$K_TRM_PLUS_SIGN	43	/* + */
#define SMG$K_TRM_COMMA_CHAR	44	/* , */
#define SMG$K_TRM_DASH		45	/* - */
#define SMG$K_TRM_DOT		46	/* . */
#define SMG$K_TRM_SLASH		47	/* / */
#define SMG$K_TRM_ZERO		48	/* 0 */
#define SMG$K_TRM_ONE		49	/* 1 */
#define SMG$K_TRM_TWO		50	/* 2 */
#define SMG$K_TRM_THREE		51	/* 3 */
#define SMG$K_TRM_FOUR		52	/* 4 */
#define SMG$K_TRM_FIVE		53	/* 5 */
#define SMG$K_TRM_SIX		54	/* 6 */
#define SMG$K_TRM_SEVEN		55	/* 7 */
#define SMG$K_TRM_EIGHT		56	/* 8 */
#define SMG$K_TRM_NINE		57	/* 9 */
#define SMG$K_TRM_COLON		58	/* : */
#define SMG$K_TRM_SEMICOLON	59	/* ; */
#define SMG$K_TRM_LESS_THAN	60	/* < */
#define SMG$K_TRM_EQUAL		61	/* = */
#define SMG$K_TRM_GREATER_THAN	62	/* > */
#define SMG$K_TRM_QUESTION_MARK 63	/* ? */
#define SMG$K_TRM_AT_SIGN	64	/* @ */
#define SMG$K_TRM_UPPERCASE_A	65	/* A */
#define SMG$K_TRM_UPPERCASE_B	66	/* B */
#define SMG$K_TRM_UPPERCASE_C	67	/* C */
#define SMG$K_TRM_UPPERCASE_D	68	/* D */
#define SMG$K_TRM_UPPERCASE_E	69	/* E */
#define SMG$K_TRM_UPPERCASE_F	70	/* F */
#define SMG$K_TRM_UPPERCASE_G	71	/* G */
#define SMG$K_TRM_UPPERCASE_H	72	/* H */
#define SMG$K_TRM_UPPERCASE_I	73	/* I */
#define SMG$K_TRM_UPPERCASE_J	74	/* J */
#define SMG$K_TRM_UPPERCASE_K	75	/* K */
#define SMG$K_TRM_UPPERCASE_L	76	/* L */
#define SMG$K_TRM_UPPERCASE_M	77	/* M */
#define SMG$K_TRM_UPPERCASE_N	78	/* N */
#define SMG$K_TRM_UPPERCASE_O	79	/* O */
#define SMG$K_TRM_UPPERCASE_P	80	/* P */
#define SMG$K_TRM_UPPERCASE_Q	81	/* Q */
#define SMG$K_TRM_UPPERCASE_R	82	/* R */
#define SMG$K_TRM_UPPERCASE_S	83	/* S */
#define SMG$K_TRM_UPPERCASE_T	84	/* T */
#define SMG$K_TRM_UPPERCASE_U	85	/* U */
#define SMG$K_TRM_UPPERCASE_V	86	/* V */
#define SMG$K_TRM_UPPERCASE_W	87	/* W */
#define SMG$K_TRM_UPPERCASE_X	88	/* X */
#define SMG$K_TRM_UPPERCASE_Y	89	/* Y */
#define SMG$K_TRM_UPPERCASE_Z	90	/* Z */
#define SMG$K_TRM_LEFT_BRACKET	91	/* [ */
#define SMG$K_TRM_BACKSLASH	92	/* \ */
#define SMG$K_TRM_RIGHT_BRACKET 93	/* ] */
#define SMG$K_TRM_CARET		94	/* ^ */
#define SMG$K_TRM_UNDERLINE	95	/* _ */
#define SMG$K_TRM_GRAVE_ACCENT	96	/* ` */
#define SMG$K_TRM_LOWERCASE_A	97	/* a */
#define SMG$K_TRM_LOWERCASE_B	98	/* b */
#define SMG$K_TRM_LOWERCASE_C	99	/* c */
#define SMG$K_TRM_LOWERCASE_D	100	/* d */
#define SMG$K_TRM_LOWERCASE_E	101	/* e */
#define SMG$K_TRM_LOWERCASE_F	102	/* f */
#define SMG$K_TRM_LOWERCASE_G	103	/* g */
#define SMG$K_TRM_LOWERCASE_H	104	/* h */
#define SMG$K_TRM_LOWERCASE_I	105	/* i */
#define SMG$K_TRM_LOWERCASE_J	106	/* j */
#define SMG$K_TRM_LOWERCASE_K	107	/* k */
#define SMG$K_TRM_LOWERCASE_L	108	/* l */
#define SMG$K_TRM_LOWERCASE_M	109	/* m */
#define SMG$K_TRM_LOWERCASE_N	110	/* n */
#define SMG$K_TRM_LOWERCASE_O	111	/* o */
#define SMG$K_TRM_LOWERCASE_P	112	/* p */
#define SMG$K_TRM_LOWERCASE_Q	113	/* q */
#define SMG$K_TRM_LOWERCASE_R	114	/* r */
#define SMG$K_TRM_LOWERCASE_S	115	/* s */
#define SMG$K_TRM_LOWERCASE_T	116	/* t */
#define SMG$K_TRM_LOWERCASE_U	117	/* u */
#define SMG$K_TRM_LOWERCASE_V	118	/* v */
#define SMG$K_TRM_LOWERCASE_W	119	/* w */
#define SMG$K_TRM_LOWERCASE_X	120	/* x */
#define SMG$K_TRM_LOWERCASE_Y	121	/* y */
#define SMG$K_TRM_LOWERCASE_Z	122	/* z */
#define SMG$K_TRM_LEFT_BRACE	123	/* { */
#define SMG$K_TRM_VERTICAL_LINE 124	/* | */
#define SMG$K_TRM_RIGHT_BRACE	125	/* } */
#define SMG$K_TRM_TILDE		126	/* ~ */
#define SMG$K_TRM_DELETE	127	/* DEL */

/* Synonyms for control characters */
#define SMG$K_TRM_NUL		0	/* note: this one is not in Starlet */
#define SMG$K_TRM_BS		8
#define SMG$K_TRM_HT		9
#define SMG$K_TRM_LF		10
#define SMG$K_TRM_VT		11
#define SMG$K_TRM_FF		12
#define SMG$K_TRM_CR		13
#define SMG$K_TRM_ESC		27	/* note: this one is not is Starlet */

/* Keypad keys */
#define SMG$K_TRM_PF1		256
#define SMG$K_TRM_PF2		257
#define SMG$K_TRM_PF3		258
#define SMG$K_TRM_PF4		259
#define SMG$K_TRM_KP0		260
#define SMG$K_TRM_KP1		261
#define SMG$K_TRM_KP2		262
#define SMG$K_TRM_KP3		263
#define SMG$K_TRM_KP4		264
#define SMG$K_TRM_KP5		265
#define SMG$K_TRM_KP6		266
#define SMG$K_TRM_KP7		267
#define SMG$K_TRM_KP8		268
#define SMG$K_TRM_KP9		269
#define SMG$K_TRM_ENTER		270
#define SMG$K_TRM_MINUS		271
#define SMG$K_TRM_COMMA		272
#define SMG$K_TRM_PERIOD	273

/* Cursor positioning keys */
#define SMG$K_TRM_UP		274
#define SMG$K_TRM_DOWN		275
#define SMG$K_TRM_LEFT		276
#define SMG$K_TRM_RIGHT		277

/* symonyms (not in Starlet) */
#define SMG$K_TRM_UP_ARROW	274
#define SMG$K_TRM_DOWN_ARROW	275
#define SMG$K_TRM_LEFT_ARROW	276
#define SMG$K_TRM_RIGHT_ARROW	277

/* Function keys; VK2xx and later keyboards */
#define SMG$K_TRM_F1		281
#define SMG$K_TRM_F2		282
#define SMG$K_TRM_F3		283
#define SMG$K_TRM_F4		284
#define SMG$K_TRM_F5		285
#define SMG$K_TRM_F6		286
#define SMG$K_TRM_F7		287
#define SMG$K_TRM_F8		288
#define SMG$K_TRM_F9		289
#define SMG$K_TRM_F10		290
#define SMG$K_TRM_F11		291
#define SMG$K_TRM_F12		292
#define SMG$K_TRM_F13		293
#define SMG$K_TRM_F14		294
#define SMG$K_TRM_F15		295
#define SMG$K_TRM_F16		296
#define SMG$K_TRM_F17		297
#define SMG$K_TRM_F18		298
#define SMG$K_TRM_F19		299
#define SMG$K_TRM_F20		300

/* Synonyms for function keys */
#define SMG$K_TRM_HELP		295
#define SMG$K_TRM_DO		296

/* Editing keys; VK2xx and later keyboards */
#define SMG$K_TRM_E1		311	/* FIND */
#define SMG$K_TRM_E2		312	/* INSERT_HERE */
#define SMG$K_TRM_E3		313	/* REMOVE */
#define SMG$K_TRM_E4		314	/* SELECT */
#define SMG$K_TRM_E5		315	/* PREV_SCREEN */
#define SMG$K_TRM_E6		316	/* NEXT_SCREEN */

/* Synonyms for editing keys */
#define SMG$K_TRM_FIND		311	/* E1 */
#define SMG$K_TRM_INSERT_HERE	312	/* E2 */
#define SMG$K_TRM_REMOVE	313	/* E3 */
#define SMG$K_TRM_SELECT	314	/* E4 */
#define SMG$K_TRM_PREV_SCREEN	315	/* E5 */
#define SMG$K_TRM_NEXT_SCREEN	316	/* E6 */

/* Locator keys (optional mouse: button actions) */
#define SMG$K_TRM_FIRST_DOWN	321	/* Left button down */
#define SMG$K_TRM_SECOND_DOWN	322	/* Middle button down */
#define SMG$K_TRM_THIRD_DOWN	323	/* Right button down */
#define SMG$K_TRM_FOURTH_DOWN	324	/* Fourth button down */
#define SMG$K_TRM_FIRST_UP	325	/* Left button up */
#define SMG$K_TRM_SECOND_UP	326	/* Middle button up */
#define SMG$K_TRM_THIRD_UP	327	/* Right button up */
#define SMG$K_TRM_FOURTH_UP	328	/* Fourth button up */

/* Conditions */
#define SMG$K_TRM_CANCELLED	508	/* I/O cancelled by SMG$CANCEL_INPUT */
#define SMG$K_TRM_TIMEOUT	509	/* Timeout period expired */
#define SMG$K_TRM_BUFFER_FULL	510	/* Buffer is full */
#define SMG$K_TRM_UNKNOWN	511	/* Unknown terminator */

/* Screen Management request types - These constants are used internally */
/* by SMG$ and should not be used by users.				 */
#define SMG$C_CHANGE_RENDITION	10
#define SMG$C_DELETE_CHARS	11
#define SMG$C_ERASE_DISPLAY	12
#define SMG$C_ERASE_LINE	13
#define SMG$C_HOME_CURSOR	14
#define SMG$C_INSERT_CHARS	15
#define SMG$C_INSERT_LINE	16
#define SMG$C_PUT_CHARS		17
#define SMG$C_PUT_LINE		18
#define SMG$C_PUT_DISPLAY_ENCODED 19
#define SMG$C_RETURN_CURSOR_POS 20
#define SMG$C_PUT_WITH_SCROLL	21
#define SMG$C_SET_CURSOR_ABS	22
#define SMG$C_SET_CURSOR_REL	23
#define SMG$C_DELETE_LINE	24
#define SMG$C_ERASE_CHARS	25
#define SMG$C_SCROLL_DISPLAY_AREA 26
#define SMG$C_CHANGE_VIRTUAL_DISPLAY 27
#define SMG$C_LABEL_BORDER	28
#define SMG$C_END_DISPLAY_UPDATE 29
#define SMG$C_MOVE_TEXT		30

/*	Character Set Codes */
#define SMG$C_UNITED_KINGDOM	0	/* Unused */
#define SMG$C_ASCII		1	/* ASCII char set */
#define SMG$C_SPEC_GRAPHICS	2	/* Line drawing set */
#define SMG$C_ALT_CHAR		3	/* Unused */
#define SMG$C_ALT_GRAPHICS	4	/* Unused */
#define SMG$C_UNKNOWN		5
#define SMG$C_SUPPLEMENTAL	6
#define SMG$C_JIS_ROMAN		7
#define SMG$C_JIS_KANA		8
#define SMG$C_KANJI		9
#define SMG$C_HANZI		10
#define SMG$C_HANYU		11
#define SMG$C_HANGUL		12
#define SMG$C_KS_ROMAN		13

/* corner cursor positions used in SMG$HOME_CURSOR */
#define SMG$C_UPPER_LEFT	0	/* Home cursor to upper left corner */
#define SMG$C_LOWER_LEFT	1	/* Home cursor to lower left corner */
#define SMG$C_UPPER_RIGHT	2	/* Home cursor to upper right corner */
#define SMG$C_LOWER_RIGHT	3	/* Home cursor to lower right corner */

/* label positions used in SMG$LABEL_BORDER */
#define SMG$K_TOP	0	/* Place label on top border */
#define SMG$K_BOTTOM	1	/* Place label on bottom border */
#define SMG$K_LEFT	2	/* Place label on left border */
#define SMG$K_RIGHT	3	/* Place label on right border */

/* menu types used in SMG$CREATE_MENU */
#define SMG$K_BLOCK		0	/* Matrix of menu items */
#define SMG$K_VERTICAL		1	/* Vertical vector of menu items */
#define SMG$K_HORIZONTAL	2	/* Horizontal vector of menu items */

/* master color wheel for screen background colors; SMG$CHANGE_PBD_CHARACTERISTICS */
#define SMG$C_COLOR_UNKNOWN	0	/* Unknown background */
#define SMG$C_COLOR_WHITE	1	/* White background */
#define SMG$C_COLOR_BLACK	2	/* Black background */
#define SMG$C_COLOR_BLUE	3	/* Blue background */
#define SMG$C_COLOR_CYAN	4	/* Cyan background */
#define SMG$C_COLOR_GREEN	5	/* Green background */
#define SMG$C_COLOR_MAGENTA	6	/* Magenta background */
#define SMG$C_COLOR_RED		7	/* Red background */
#define SMG$C_COLOR_YELLOW	8	/* Yellow background */
#define SMG$C_COLOR_LIGHT	9	/* Light background */
#define SMG$C_COLOR_DARK	10	/* Dark background */
#define SMG$C_COLOR_USER1	11	/* User 1 background */
#define SMG$C_COLOR_USER2	12	/* User 2 background */
#define SMG$C_COLOR_USER3	13	/* User 3 background */
#define SMG$C_COLOR_USER4	14	/* User 4 background */
#define SMG$C_COLOR_USER5	15	/* User 5 background */
#define SMG$C_COLOR_USER6	16	/* User 6 background */
#define SMG$C_COLOR_USER7	17	/* User 7 background */
#define SMG$C_COLOR_USER8	18	/* User 8 background */

/* type of terminal, used with SMG$GET_PASTEBOARD_ATTRIBUTES */
#define SMG$K_UNKNOWN		0	/* Unknown type */
#define SMG$K_VT05		1	/* Unused */
#define SMG$K_VT52		2	/* Unused */
#define SMG$K_VT100		3	/* Unused */
#define SMG$K_VTFOREIGN		4	/* Foreign terminal (ft1-8) */
#define SMG$K_HARDCOPY		5	/* Hardcopy device */
#define SMG$K_VTTERMTABLE	6	/* Video terminal */
#define SMG$K_FIRST_PRIV_TYPE	191	/* Used internally by SMG$ */

/*	Define bits, masks, and fields for the control modes. */
#define SMG$K_BUF_ENABLED	0	/* Enable Buffering */
#define SMG$K_MINUPD		1	/* Enable minimal update */
#define SMG$K_CLEAR_SCREEN	2	/* Clear screen on exit */
#define SMG$K_NOTABS		3	/* Don't use physical tabs */
#define SMG$K_PROTECT		4	/* Protect against ASTs */
#define SMG$K_IGNORE		5	/* Don't output PBD if batched */
#define SMG$K_RELEASE_PBD	6	/* Don't touch users part of PBD */
#define SMG$V_BUF_ENABLED	0
#define SMG$V_MINUPD		1
#define SMG$V_CLEAR_SCREEN	2
#define SMG$V_NOTABS		3
#define SMG$V_PROTECT		4
#define SMG$V_IGNORE		5
#define SMG$V_RELEASE_PBD	6
#define SMG$M_BUF_ENABLED	(1<<SMG$V_BUF_ENABLED)		/* 0x01 */
#define SMG$M_MINUPD		(1<<SMG$V_MINUPD)		/* 0x02 */
#define SMG$M_CLEAR_SCREEN	(1<<SMG$V_CLEAR_SCREEN)		/* 0x04 */
#define SMG$M_NOTABS		(1<<SMG$V_NOTABS)		/* 0x08 */
#define SMG$M_PROTECT		(1<<SMG$V_PROTECT)		/* 0x10 */
#define SMG$M_IGNORE		(1<<SMG$V_IGNORE)		/* 0x20 */
#define SMG$M_RELEASE_PBD	(1<<SMG$V_RELEASE_PBD)		/* 0x40 */

#ifndef __ALPHA
struct smg$r_mode_bits {
    unsigned smg$v_buf_enabled	: 1;	/* enable buffering */
    unsigned smg$v_minupd	: 1;	/* enable minimal update (default) */
    unsigned smg$v_clear_screen : 1;	/* clear screen on exit */
    unsigned smg$v_notabs	: 1;	/* don't use physical tabs */
    unsigned smg$v_protect	: 1;	/* protect against ASTs */
    unsigned smg$v_ignore	: 1;	/* don't output PBD if batched */
    unsigned smg$v_release_pbd	: 1;	/* don't touch users part of PBD */
    unsigned			: 25;
};
#endif

/*	Key definition attributes */
#define SMG$V_KEY_NOECHO	0
#define SMG$V_KEY_TERMINATE	1
#define SMG$V_KEY_LOCK		2
#define SMG$V_KEY_PROTECTED	3
#define SMG$V_KEY_SETSTATE	4
#define SMG$M_KEY_NOECHO	(1<<SMG$V_KEY_NOECHO)		/* 0x01 */
#define SMG$M_KEY_TERMINATE	(1<<SMG$V_KEY_TERMINATE)	/* 0x02 */
#define SMG$M_KEY_LOCK		(1<<SMG$V_KEY_LOCK)		/* 0x04 */
#define SMG$M_KEY_PROTECTED	(1<<SMG$V_KEY_PROTECTED)	/* 0x08 */
#define SMG$M_KEY_SETSTATE	(1<<SMG$V_KEY_SETSTATE)		/* 0x10 */
struct smg$r_key_def_attr {
    unsigned smg$v_key_noecho	: 1;	/* don't echo strings */
    unsigned smg$v_key_terminate: 1;	/* this key terminates read */
    unsigned smg$v_key_lock	: 1;	/* lock new state */
    unsigned smg$v_key_protected: 1;	/* definition is protected */
    unsigned smg$v_key_setstate : 1;	/* definition sets a state (output only) */
    unsigned			: 27;
};

/*	  Define bit masks and values for display renditions. */
#define SMG$V_BOLD	0
#define SMG$V_REVERSE	1
#define SMG$V_BLINK	2
#define SMG$V_UNDERLINE 3
#define SMG$V_INVISIBLE 4
#define SMG$V_USER1	5
#define SMG$V_USER2	6
#define SMG$V_USER3	7
#define SMG$V_USER4	8
#define SMG$V_USER5	9
#define SMG$V_USER6	10
#define SMG$V_USER7	11
#define SMG$V_USER8	12
#define SMG$M_BOLD		(1<<SMG$V_BOLD)			/* 0x01 */
#define SMG$M_REVERSE		(1<<SMG$V_REVERSE)		/* 0x02 */
#define SMG$M_BLINK		(1<<SMG$V_BLINK)		/* 0x04 */
#define SMG$M_UNDERLINE		(1<<SMG$V_UNDERLINE)		/* 0x08 */
#define SMG$M_INVISIBLE		(1<<SMG$V_INVISIBLE)		/* 0x10 */
#define SMG$M_USER1		(1<<SMG$V_USER1)		/* 0x0100 */
#define SMG$M_USER2		(1<<SMG$V_USER2)		/* 0x0200 */
#define SMG$M_USER3		(1<<SMG$V_USER3)		/* 0x0400 */
#define SMG$M_USER4		(1<<SMG$V_USER4)		/* 0x0800 */
#define SMG$M_USER5		(1<<SMG$V_USER5)		/* 0x1000 */
#define SMG$M_USER6		(1<<SMG$V_USER6)		/* 0x2000 */
#define SMG$M_USER7		(1<<SMG$V_USER7)		/* 0x4000 */
#define SMG$M_USER8		(1<<SMG$V_USER8)		/* 0x8000 */

#ifndef __ALPHA
struct smg$r_rendition_bits {
    unsigned smg$v_bold		: 1;	/* bold rendition */
    unsigned smg$v_reverse	: 1;	/* reverse video rendition */
    unsigned smg$v_blink	: 1;	/* blink rendition */
    unsigned smg$v_underline	: 1;	/* underline rendition */
    unsigned smg$v_invisible	: 1;	/* Invisible rendition */
    unsigned			: 3;	/* internally used by SMG$ */
    unsigned smg$v_user1	: 1;	/* user rendition 1 */
    unsigned smg$v_user2	: 1;	/* "    " 2 */
    unsigned smg$v_user3	: 1;	/* "    " 3 */
    unsigned smg$v_user4	: 1;	/* "    " 4 */
    unsigned smg$v_user5	: 1;	/* "    " 5 */
    unsigned smg$v_user6	: 1;	/* "    " 6 */
    unsigned smg$v_user7	: 1;	/* "    " 7 */
    unsigned smg$v_user8	: 1;	/* "    " 8 */
    unsigned			: 16;
};
#endif

#define SMG$M_NORMAL	0x00000000	/* no bits set */

/*	Display attribute mask values */
#define SMG$V_BORDER		0
#define SMG$V_TRUNC_ICON	1
#define SMG$V_DISPLAY_CONTROLS	2
#define SMG$V_USER_DISPLAY	3
#define SMG$V_BLOCK_BORDER	4
#define SMG$V_PROTECT_DISPLAY	5
#define SMG$M_BORDER		(1<<SMG$V_BORDER)		/* 0x01 */
#define SMG$M_TRUNC_ICON	(1<<SMG$V_TRUNC_ICON)		/* 0x02 */
#define SMG$M_DISPLAY_CONTROLS	(1<<SMG$V_DISPLAY_CONTROLS)	/* 0x04 */
#define SMG$M_USER_DISPLAY	(1<<SMG$V_USER_DISPLAY)		/* 0x08 */
#define SMG$M_BLOCK_BORDER	(1<<SMG$V_BLOCK_BORDER)		/* 0x10 */
#define SMG$M_PROTECT_DISPLAY	(1<<SMG$V_PROTECT_DISPLAY)	/* 0x20 */

#ifndef __ALPHA
struct smg$r_display_attributes {
    unsigned smg$v_border	: 1;	/* display is bordered */
    unsigned smg$v_trunc_icon	: 1;	/* truncation icon enabled */
    unsigned smg$v_display_controls : 1; /* display carriage controls */
    unsigned smg$v_user_display : 1;	/* user display for DEBUG */
    unsigned smg$v_block_border : 1;	/* display is block bordered */
    unsigned smg$v_protect_display : 1; /* protect display against ASTs */
    unsigned			: 26;
};
#endif

/*	bits used with subprocess manipulation. */
#define SMG$V_DATA_FOLLOWS	0
#define SMG$V_SEND_EOF		1
#define SMG$V_NO_PRINT		2
#define SMG$M_DATA_FOLLOWS	(1<<SMG$V_DATA_FOLLOWS)		/* 0x01 */
#define SMG$M_SEND_EOF		(1<<SMG$V_SEND_EOF)		/* 0x02 */
#define SMG$M_NO_PRINT		(1<<SMG$V_NO_PRINT)		/* 0x04 */
struct smg$r_subprocess_flags {
    unsigned smg$v_data_follows : 1;	/* the next call specifies data. */
    unsigned smg$v_send_eof	: 1;	/* send an end-of-file to the subprocess */
    unsigned smg$v_no_print	: 1;	/* do not output command to the display */
    unsigned			: 29;
};

/*	bits used with the FLAGS parameter for SMG$DELETE_PASTEBOARD */
#define SMG$V_ERASE_PBD		0
#define SMG$V_IGNORE_BATCHED	1
#define SMG$M_ERASE_PBD		(1<<SMG$V_ERASE_PBD)		/* 0x01 */
#define SMG$M_IGNORE_BATCHED	(1<<SMG$V_IGNORE_BATCHED)	/* 0x02 */
struct smg$r_delete_pbd_flags {
    unsigned smg$v_erase_pbd	: 1;	/* erase the pasteboard */
    unsigned smg$v_ignore_batched : 1;	/* delete even if pbd is batched */
    unsigned			: 30;
};

/*	bits used with the FLAGS parameter for SMG$CREATE_PASTEBOARD */
#define SMG$V_KEEP_CONTENTS	0
#define SMG$V_WORKSTATION	1
#define SMG$M_KEEP_CONTENTS	(1<<SMG$V_KEEP_CONTENTS)	/* 0x01 */
#define SMG$M_WORKSTATION	(1<<SMG$V_WORKSTATION)		/* 0x02 */
struct smg$r_create_pbd_flags {
    unsigned smg$v_keep_contents: 1;	/* don't erase the pasteboard */
    unsigned smg$v_workstation	: 1;	/* pasteboard is DECwindows terminal */
    unsigned			: 30;
};

/*	bits used with the FLAGS parameter for SMG$READ_xxxx */
#define SMG$V_FUNC_KEYS		0
#define SMG$V_NOKEEP		1
#define SMG$V_NORECALL		2
#define SMG$M_FUNC_KEYS		(1<<SMG$V_FUNC_KEYS)		/* 0x01 */
#define SMG$M_NOKEEP		(1<<SMG$V_NOKEEP)		/* 0x02 */
#define SMG$M_NORECALL		(1<<SMG$V_NORECALL)		/* 0x04 */
struct smg$r_read_flags {
    unsigned smg$v_func_keys	: 1;	/* disable line-editting. */
    unsigned smg$v_nokeep	: 1;	/* don't save input in recall buffer */
    unsigned smg$v_norecall	: 1;	/* disable input recall for this call */
    unsigned			: 29;
};

/*	bits used with the FLAGS parameter for SMG$SET_CURSOR_MODE */
#define SMG$V_CURSOR_OFF	0
#define SMG$V_CURSOR_ON		1
#define SMG$V_SCROLL_JUMP	2
#define SMG$V_SCROLL_SMOOTH	3
#define SMG$M_CURSOR_OFF	(1<<SMG$V_CURSOR_OFF)		/* 0x01 */
#define SMG$M_CURSOR_ON		(1<<SMG$V_CURSOR_ON)		/* 0x02 */
#define SMG$M_SCROLL_JUMP	(1<<SMG$V_SCROLL_JUMP)		/* 0x04 */
#define SMG$M_SCROLL_SMOOTH	(1<<SMG$V_SCROLL_SMOOTH)	/* 0x08 */
struct smg$r_set_cursor_flags {
    unsigned smg$v_cursor_off	: 1;	/* turn the physical cursor off */
    unsigned smg$v_cursor_on	: 1;	/* turn the physical cursor on */
    unsigned smg$v_scroll_jump	: 1;	/* set jump scroll */
    unsigned smg$v_scroll_smooth: 1;	/* set smooth scroll */
    unsigned			: 28;
};

/*	bits used with the FLAGS parameter for SMG$GET_DISPLAY_ATTR */
#define SMG$V_VIEWPORT		0
#define SMG$V_SUBPROCESS	1
#define SMG$V_MENU		2
#define SMG$M_VIEWPORT		(1<<SMG$V_VIEWPORT)		/* 0x01 */
#define SMG$M_SUBPROCESS	(1<<SMG$V_SUBPROCESS)		/* 0x02 */
#define SMG$M_MENU		(1<<SMG$V_MENU)			/* 0x04 */
struct smg$r_get_display_flags {
    unsigned smg$v_viewport	: 1;	/* display contains a viewport */
    unsigned smg$v_subprocess	: 1;	/* display contains a subprocess */
    unsigned smg$v_menu		: 1;	/* display contains a menu */
    unsigned			: 29;
};

/*	bits used with the FLAGS parameter for SMG$PUT_CHARS */
#define SMG$V_ERASE_LINE	0
#define SMG$V_ERASE_TO_EOL	1
#define SMG$M_ERASE_LINE	(1<<SMG$V_ERASE_LINE)		/* 0x01 */
#define SMG$M_ERASE_TO_EOL	(1<<SMG$V_ERASE_TO_EOL)		/* 0x02 */
struct smg$r_put_chars_flags {
    unsigned smg$v_erase_line	: 1;	/* erase the entire line */
    unsigned smg$v_erase_to_eol : 1;	/* erase from cursor to end of line */
    unsigned			: 30;
};

/*	bits used with the FLAGS parameter for SMG$MOVE_TEXT */
#define SMG$V_TEXT_SAVE		0
#define SMG$V_TEXT_ONLY		1
#define SMG$M_TEXT_SAVE		(1<<SMG$V_TEXT_SAVE)		/* 0x01 */
#define SMG$M_TEXT_ONLY		(1<<SMG$V_TEXT_ONLY)		/* 0x02 */
struct smg$r_move_text_flags {
    unsigned smg$v_text_save	: 1;	/* don't erase text after moving it */
    unsigned smg$v_text_only	: 1;	/* don't move attributes */
    unsigned			: 30;
};

/*	bits used with the FLAGS parameter for SMG$PUT_PASTEBOARD and SMG$SNAPSHOT */
#define SMG$V_FORM_FEED		0
#define SMG$M_FORM_FEED		(1<<SMG$V_FORM_FEED)		/* 0x01 */
struct smg$r_snapshot_flags {
    unsigned smg$v_form_feed	: 1;	/* output form feed before first row */
    unsigned			: 31;
};

/*	bits used with the FLAGS parameter for SMG$PUT_xxxx */
#define SMG$V_WRAP_CHAR		0
#define SMG$V_WRAP_WORD		1
#define SMG$M_WRAP_CHAR		(1<<SMG$V_WRAP_CHAR)		 /* 0x01 */
#define SMG$M_WRAP_WORD		(1<<SMG$V_WRAP_WORD)		 /* 0x02 */
struct smg$r_put_line_flags {
    unsigned smg$v_wrap_char	: 1;	/* do character wrapping at end of line */
    unsigned smg$v_wrap_word	: 1;	/* do word wrapping at end of line */
    unsigned			: 30;
};

/*	bits used with the FLAGS parameter for SMG$SET_KEYPAD_MODE */
#define SMG$V_KEYPAD_APPLICATION 0
#define SMG$V_KEYPAD_NUMERIC	 1
#define SMG$M_KEYPAD_APPLICATION (1<<SMG$V_KEYPAD_APPLICATION)	/* 0x01 */
#define SMG$M_KEYPAD_NUMERIC	 (1<<SMG$V_KEYPAD_NUMERIC)	/* 0x02 */
struct smg$r_keypad_modes {
    unsigned smg$v_keypad_application : 1; /* application keypad */
    unsigned smg$v_keypad_numeric : 1;	   /* numeric keypad */
    unsigned			: 30;
};

/*	bits used with the FLAGS parameter for SMG$GET_PASTING_INFO */
#define SMG$V_DISPLAY_PASTED	0
#define SMG$M_DISPLAY_PASTED	(1<<SMG$V_DISPLAY_PASTED)	/* 0x01 */
struct smg$r_pasting_info_flags {
    unsigned smg$v_display_pasted : 1;	/* display is pasted */
    unsigned			: 31;
};

/*	bits used with menu manipulation. */
#define SMG$V_REMOVE_ITEM	0
#define SMG$V_FIXED_FORMAT	1
#define SMG$V_DOUBLE_SPACE	2
#define SMG$V_RETURN_IMMED	3
#define SMG$V_ERASE_MENU	4
#define SMG$V_WIDE_MENU		5
#define SMG$V_WRAP_MENU		6
#define SMG$V_FULL_FIELD	7
#define SMG$M_REMOVE_ITEM	(1<<SMG$V_REMOVE_ITEM)		/* 0x01 */
#define SMG$M_FIXED_FORMAT	(1<<SMG$V_FIXED_FORMAT)		/* 0x02 */
#define SMG$M_DOUBLE_SPACE	(1<<SMG$V_DOUBLE_SPACE)		/* 0x04 */
#define SMG$M_RETURN_IMMED	(1<<SMG$V_RETURN_IMMED)		/* 0x08 */
#define SMG$M_ERASE_MENU	(1<<SMG$V_ERASE_MENU)		/* 0x10 */
#define SMG$M_WIDE_MENU		(1<<SMG$V_WIDE_MENU)		/* 0x20 */
#define SMG$M_WRAP_MENU		(1<<SMG$V_WRAP_MENU)		/* 0x40 */
#define SMG$M_FULL_FIELD	(1<<SMG$V_FULL_FIELD)		/* 0x80 */
struct smg$r_menu_flags {
    unsigned smg$v_remove_item	: 1;	/* only select item once */
    unsigned smg$v_fixed_format : 1;	/* use fixed size cols */
    unsigned smg$v_double_space : 1;	/* double space menu rows */
    unsigned smg$v_return_immed : 1;	/* ret on non-arrow key */
    unsigned smg$v_erase_menu	: 1;	/* erase menu when deleting */
    unsigned smg$v_wide_menu	: 1;	/* wide menu items */
    unsigned smg$v_wrap_menu	: 1;	/* wrap menu items top to bottom */
    unsigned smg$v_full_field	: 1;	/* highlight entire field */
    unsigned			: 24;
};

/*	used with SMG$PUT_LINE_xxxx, SMG$SCROLL_DISPLAY_AREA, and SMG$DRAW_CHAR */
#define SMG$V_UP		0
#define SMG$V_DOWN		1
#define SMG$V_RIGHT		2
#define SMG$V_LEFT		3
#define SMG$M_UP		(1<<SMG$V_UP)			/* 0x01 */
#define SMG$M_DOWN		(1<<SMG$V_DOWN)			/* 0x02 */
#define SMG$M_RIGHT		(1<<SMG$V_RIGHT)		/* 0x04 */
#define SMG$M_LEFT		(1<<SMG$V_LEFT)			/* 0x08 */

#ifndef __ALPHA
struct smg$r_scroll_dirs {
    unsigned smg$v_up		: 1;	/* up */
    unsigned smg$v_down		: 1;	/* down */
    unsigned smg$v_right	: 1;	/* right */
    unsigned smg$v_left		: 1;	/* left */
    unsigned			: 28;
};
#endif

/* Define data structures */
#define SMG$C_BAND_INFORMATION_TABLE	12	/* length of table in bytes */
#define SMG$C_PASTEBOARD_INFO_BLOCK	32	/* length of block in bytes */
#define SMG$C_KEYBOARD_INFO_BLOCK	20	/* length of block in bytes */

union smgdef {
	/*
	   When an out-of-band AST triggers, the user's AST routine
	   will get called.  The first argument passed to his
	   routine is the address of a Band Information Table.
	   The offsets into this table are described below.
	   To make it easy to access from certain languages,
	   the table is arranged so that it is convenient to
	   reference it as a longword vector as well as a byte block.
	 */
    struct {
	unsigned long smg$l_pasteboard_id;	/* pasteboard ID */
	unsigned long smg$l_arg;		/* user's AST argument */
#define smg$l_pasteboard_id smg$r_band_information_table.smg$l_pasteboard_id
#define smg$l_arg smg$r_band_information_table.smg$l_arg
	union {
	    unsigned char smg$b_character;	/* the character typed */
	    unsigned long smg$l_character;	/* the character and 3 spaces */
	} smg$r_character_overlay;
#define smg$b_character smg$r_band_information_table.smg$r_character_overlay.smg$b_character
#define smg$l_character smg$r_band_information_table.smg$r_character_overlay.smg$l_character
    } smg$r_band_information_table;
	/*
	   When SMG$GET_PASTEBOARD_ATTRIBUTES is called,
	   it returns data in a pasteboard information block.
	   The following structure is used to reference fields in this block.
	   Items marked with a plus (+) will be 0 unless the
	   device is a terminal (DEVCLASS=DC$_TERM).
	 */
    struct {
	unsigned long smg$l_devchar;		/* device characteristics */
	unsigned long smg$l_devdepend;		/* specific characteristics (1) */
	unsigned long smg$l_devdepend2;		/* specific characteristics (2) */
	unsigned char smg$b_devclass;		/* device class (e.g. DC$_TERM) */
	unsigned char smg$b_smg_devtype;	/* internal SMG device type */
	unsigned char smg$b_phy_devtype;	/* physical device type (e.g. DT$_VT100) */
	unsigned char smg$b_rows;		/* number of rows on device */
	unsigned short smg$w_width;		/* terminal width */
	unsigned char smg$b_color;		/* PBD background color */
	unsigned char smg$b_parity;		/* parity attributes (+) */
	unsigned short smg$w_speed;		/* terminal Speed (+) */
	unsigned short smg$w_fill;		/* fill characteristics (+) */
	unsigned short smg$w_cursor_row;	/* row where physical cursor is (1-origin) */
	unsigned short smg$w_cursor_col;	/* col where physical cursor is (1-origin) */
	unsigned long smg$l_cursor_did;		/* display id of topmost display that cursor is in. */
						/*  0 if cursor is not in a virtual display	    */
#ifdef __ALPHA
	unsigned long __fill;
#endif

#define smg$b_smg_devtype smg$r_pasteboard_info_block.smg$b_smg_devtype
#define smg$b_rows smg$r_pasteboard_info_block.smg$b_rows
#define smg$b_color smg$r_pasteboard_info_block.smg$b_color
#define smg$b_parity smg$r_pasteboard_info_block.smg$b_parity
#define smg$w_speed smg$r_pasteboard_info_block.smg$w_speed
#define smg$w_fill smg$r_pasteboard_info_block.smg$w_fill
#define smg$w_cursor_row smg$r_pasteboard_info_block.smg$w_cursor_row
#define smg$w_cursor_col smg$r_pasteboard_info_block.smg$w_cursor_col
#define smg$l_cursor_did smg$r_pasteboard_info_block.smg$l_cursor_did
    } smg$r_pasteboard_info_block;
	/*
	   When SMG$GET_KEYBOARD_ATTRIBUTES is called,
	   it returns data in a keyboard information block.
	   The following structure is used to reference fields in this block.
	   Items marked with a plus (+) will be 0 unless the
	   device is a terminal (DEVCLASS=DC$_TERM).
	 */
    struct {
	unsigned long smg$l_devchar;		/* device characteristics */
	unsigned long smg$l_devdepend;		/* specific characteristics (1) */
	unsigned long smg$l_devdepend2;		/* specific characteristics (2) */
	unsigned char smg$b_devclass;		/* device class (e.g. DC$_TERM) */
	unsigned char smg$b_recall_size;	/* size of recall buffer (+) */
	unsigned char smg$b_phy_devtype;	/* physical device type (e.g. DT$_VT100) */
	unsigned char smg$b_typeahead_char;	/* first char in typeahead buffer (+) */
	unsigned short smg$w_width;		/* terminal width */
	unsigned short smg$w_typeahead_count;	/* number of chars in typeahead buffer (+) */
#define smg$l_devchar smg$r_pasteboard_info_block.smg$l_devchar
#define smg$l_devdepend smg$r_pasteboard_info_block.smg$l_devdepend
#define smg$l_devdepend2 smg$r_pasteboard_info_block.smg$l_devdepend2
#define smg$b_devclass smg$r_pasteboard_info_block.smg$b_devclass
#define smg$b_recall_size smg$r_keyboard_info_block.smg$b_recall_size
#define smg$b_phy_devtype smg$r_pasteboard_info_block.smg$b_phy_devtype
#define smg$b_typeahead_char smg$r_keyboard_info_block.smg$b_typeahead_char
#define smg$w_width smg$r_pasteboard_info_block.smg$w_width
#define smg$w_typeahead_count smg$r_keyboard_info_block.smg$w_typeahead_count
    } smg$r_keyboard_info_block;
};

/* Define the out-of-band information table used when an out-of-band */
/* AST routine is called as it's own record.			     */
struct smg$r_out_of_band_table {
    unsigned long smg$l_pbd_id;		/* pasteboard ID */
    unsigned long smg$l_user_arg;	/* user's AST argument */
    union {
	unsigned char smg$b_char;	/* the character typed */
	unsigned long smg$l_char;	/* the character and 3 spaces */
#define smg$b_char smg$r_char_overlay.smg$b_char
#define smg$l_char smg$r_char_overlay.smg$l_char
    } smg$r_char_overlay;
};
#define SMG$C_OUT_OF_BAND_TABLE 12	/* Length of table in bytes */

/* Define the subprocess information table used when a subprocess */
/* AST routine is called as it's own record.			  */
struct smg$r_subprocess_info_table {
    unsigned long smg$l_disp_id;	/* display ID */
    unsigned long smg$l_usr_arg;	/* user's AST argument */
    unsigned long smg$l_status;		/* status of executed command */
};
#define SMG$C_SUBPROCESS_INFO_TABLE 12	/* Length of table in bytes */

/* Define an information table that can be used by both		 */
/* SMG$GET_PASTEBOARD_ATTRIBUTES and SMG$GET_KEYBOARD_ATTRIBUTES */
/* as it's own record.						 */
struct smg$r_attribute_info_block {
    unsigned long smg$l_dev_char;		/* device characteristics */
    unsigned long smg$l_dev_depend;		/* specific characteristics (1) */
    unsigned long smg$l_dev_depend2;		/* specific characteristics (2) */
    unsigned char smg$b_dev_class;		/* device class (e.g. DC$_TERM) */
    union {
	unsigned char smg$b_pbd_type;		/* internal SMG device type */
	unsigned char smg$b_recall_num;		/* size of recall buffer (+) */
#define smg$b_pbd_type smg$r_dev_overlay.smg$b_pbd_type
#define smg$b_recall_num smg$r_dev_overlay.smg$b_recall_num
    } smg$r_dev_overlay;
    unsigned char smg$b_dev_type;		/* physical device type (e.g. DT$_VT100) */
    union {
	unsigned char smg$b_num_rows;		/* number of rows on device */
	unsigned char smg$b_typeahd_char;	/* first char in typeahead buffer (+) */
#define smg$b_num_rows smg$r_row_overlay.smg$b_num_rows
#define smg$b_typeahd_char smg$r_row_overlay.smg$b_typeahd_char
    } smg$r_row_overlay;
    unsigned short smg$w_num_columns;		/* rerminal width */
    union {
	unsigned short smg$w_typeahd_cnt;	/* number of chars in typeahead buffer (+) */
#define smg$w_typeahd_cnt smg$r_count_overlay.smg$w_typeahd_cnt
	struct {
	    unsigned char smg$b_pbd_color;	/* PBD background color */
	    unsigned char smg$b_dev_parity;	/* parity attributes (+) */
#define smg$b_pbd_color smg$r_count_overlay.smg$r_count_struct.smg$b_pbd_color
#define smg$b_dev_parity smg$r_count_overlay.smg$r_count_struct.smg$b_dev_parity
	} smg$r_count_struct;
    } smg$r_count_overlay;
    unsigned short smg$w_dev_speed;		/* terminal Speed (+) */
    unsigned short smg$w_dev_fill;		/* fill characteristics (+) */
    unsigned short smg$w_phys_cursor_row;	/* row where physical cursor is */
    unsigned short smg$w_phys_cursor_col;	/* col where physical cursor is */
    unsigned long smg$l_display_id;		/* display containing phy cursor */
#ifdef __ALPHA
  unsigned long __fill;
#endif
};
#define SMG$C_ATTRIBUTE_INFO_BLOCK 32	/* length of table in bytes */

#endif	/*_SMGDEF_H*/
