/* <smrdef.h>
 *
 *	Define symbiont manager request codes
 */
#ifndef _SMRDEF_H
#define _SMRDEF_H

/* symbiont manager request codes */
#define SMR$K_INITIAL	0	/* initialize a queue */
#define SMR$K_DELETE	1	/* delete the queue */
#define SMR$K_START	2	/* activate or resume printing */
#define SMR$K_PAUSE	3	/* suspend printing for a while */
#define SMR$K_MERGE	4	/* move files form one queue into another */
#define SMR$K_REDIRECT	5	/* assignment of one queue to another */
#define SMR$K_JUSTIFY	6	/* justify print forms (ie: issue FF) */
#define SMR$K_STOP	7	/* disable further de-queing */
#define SMR$K_ENTER	8	/* add a file to a queue */
#define SMR$K_CREJOB	9	/* create a print job */
#define SMR$K_ADDFIL	10	/* add a file to existing job */
#define SMR$K_CLSJOB	11	/* close open job */
#define SMR$K_RMVJOB	12	/* remove job from queue */
#define SMR$K_ALTER	13	/* change a files characteristics */
#define SMR$K_ABORT	14	/* abort current job, start next */
#define SMR$K_RELEASE	15	/* release job from hold list */
#define SMR$K_DETINIT	16	/* detached job has initiated */
#define SMR$K_SYNCJOB	17	/* syncronize with a batch job */
#define SMR$K_ASKQNAM	18	/* get name of queue for log file */

/* assign symbiont manager print job/record option codes */
/* job file options */
#define SMO$K_DELETE	1	/* delete the file after printing */
#define SMO$K_BRSTPAG	2	/* create a burst page */
#define SMO$K_NOBRSTPAG 3	/* inhibit burst page */
#define SMO$K_FLAGPAG	4	/* print a flag page */
#define SMO$K_NOFLAGPAG 5	/* inhibit a flag page */
#define SMO$K_PAGHDR	6	/* print filename as page header */
#define SMO$K_DOUBLE	7	/* double space the listing */
#define SMO$K_NOFEED	8	/* inhibit form feed generation */
#define SMO$K_PAGCNT	9	/* specify page count to print */
#define SMO$K_COPIES	10	/* number of copies to print */
#define SMO$K_FILESIZ	11	/* file size */
#define SMO$K_DESTQUE	12	/* destination queue */
/* options for create job */
#define SMO$K_RLSTIM	32	/* time to hold until queueing */
#define SMO$K_HOLD	33	/* hold the job */
#define SMO$K_JOBPRI	34	/* specify print job/detached job prioity */
#define SMO$K_JOBCOPY	35	/* number of copies of entire job */
#define SMO$K_FORMTYPE	36	/* form type to used when printed */
#define SMO$K_LOWER	37	/* upper/lower case printer only */
#define SMO$K_PARAMS	38	/* supply job parameters */
#define SMO$K_JOBNAME	39	/* supply a name to the job */
#define SMO$K_NOLOWER	40	/* clear lower case required */
#define SMO$K_CPULIM	41	/* cpu time limit */
#define SMO$K_NOCPULM	42	/* no cpu time limit */
#define SMO$K_WSQUOTA	43	/* working set quota */
#define SMO$K_NOWSQUO	44	/* no working set quota */
#define SMO$K_WSDEFLT	45	/* working set default */
#define SMO$K_NOWSDFT	46	/* no working set default */
#define SMO$K_DQCHAR	47	/* char. to be used when printed */
#define SMO$K_LOGFNAM	48	/* log file spec. */
#define SMO$K_LOGQNAM	49	/* queue name for log file */
#define SMO$K_KEEPLOG	50	/* keep log file */
#define SMO$K_NOSPOOL	51	/* don't spool log file */
#define SMO$K_NOKEEPLOG 52	/* delete log file */
#define SMO$K_NOLOG	53	/* create log on null device */
#define SMO$K_NOTIFY	54	/* notify when job completes */
#define SMO$K_NONOTFY	55	/* no notify */
#define SMO$K_WSEXTNT	56	/* WS extent */
#define SMO$K_NOWSEXTNT 57	/* no WS extent */
/* options for init or start a queue */
#define SMO$K_CURFORM	64	/* current forms mounted on device */
#define SMO$K_GENPRT	65	/* allow generic printing */
#define SMO$K_NOGENPRT	66	/* disallow generic printing */
#define SMO$K_DETJOB	67	/* queue is for detached job queuing */
#define SMO$K_GENDEV	68	/* queue is generic device queue */
#define SMO$K_NOGENDEV	69	/* not a generic device */
#define SMO$K_DEFBRST	70	/* queue has burst page by default */
#define SMO$K_NODEFBRST 71	/* no default burst page */
#define SMO$K_DEFFLAG	72	/* queue has flag page by default */
#define SMO$K_NODEFFLAG 73	/* no default flag */
#define SMO$K_TRMDEV	74	/* device is a terminal */
#define SMO$K_NOTRMDEV	75	/* device is not a terminal */
#define SMO$K_JOBLIM	76	/* job limit for batch jobs */
#define SMO$K_INIPRI	77	/* job initial priority */
#define SMO$K_DISWAP	78	/* disable swaping */
#define SMO$K_MCPULM	79	/* max cpu time limit */
#define SMO$K_NOMCPULM	80	/* no max cpu time limit */
#define SMO$K_DCPULM	81	/* default cpu time limit */
#define SMO$K_NODCPULM	82	/* no default cpu time limit */
#define SMO$K_WSQUTA	83	/* working set quota */
#define SMO$K_NOWSQUTA	84	/* no working set quota */
#define SMO$K_WSDFLT	85	/* working set default */
#define SMO$K_NOWSDFLT	86	/* no working set default */
#define SMO$K_CURDQCHAR 87	/* current char. of the queue */
#define SMO$K_SMBNAME	88	/* symbiont name for queue */
#define SMO$K_WSXTANT	89	/* WS extent */
#define SMO$K_NOWSXTNT	90	/* no WS extent */
#define SMO$K_NODISWAP	91	/* enable swapping */
/* options for restart */
#define SMO$K_NEXTJOB	96	/* restart at end beginning of next job */
#define SMO$K_TOPOFILE	97	/* restart job at top-of-file */
#define SMO$K_SPCCNT	98	/* specify pages to space over */
/* options for abort */
#define SMO$K_REQUEUE	112	/* requeue the file */
#define SMO$K_REQDEST	113	/* specify new queue destination */
#define SMO$K_REQPRIO	114	/* specify priority on requeue */

#endif	/*_SMRDEF_H*/
