/* <syidef.h>
 *
 *	Get System Information Data Identifier Definitions.
 */
#ifndef _SYIDEF_H
#define _SYIDEF_H
/* table types */
#define SYI$C_EXETYPE	1	/* Executive cells */
#define SYI$C_FLDTYPE	2	/* Sub-field data */
#define SYI$C_RSDTYPE	3	/* Reduced system data */

/* item codes executive data cells */
#define SYI$_VERSION		4096	/* VMS version number */
#define SYI$_SID		4097	/* system ID register */
#define SYI$_PFCDEFAULT		4098	/* default page fault cluster size */
#define SYI$_PAGTBLPFC		4099	/* default page table page fault cluster */
#define SYI$_SYSPFC		4100	/* page fault cluster for system paging */
#define SYI$_KFILSTCNT		4101	/* (obsolete, to be deleted in a future release) */
#define SYI$_GBLSECTIONS	4102	/* global section count */
#define SYI$_GBLPAGES		4103	/* global page count */
#define SYI$_GBLPAGFIL		4104	/* global page page file page limit */
#define SYI$_MAXPROCESSCNT	4105	/* maximum process count */
#define SYI$_PIXSCAN		4106	/* process scan count */
#define SYI$_PROCSECTCNT	4107	/* process section count */
#define SYI$_MINWSCNT		4108	/* minimum working set size */
#define SYI$_PAGFILCNT		4109	/* number of paging files */
#define SYI$_SWPFILCNT		4110	/* number of swap files */
#define SYI$_SYSMWCNT		4111	/* system working set count */
#define SYI$_INTSTKPAGES	4112	/* interrupt stack size */
#define SYI$_DLCKEXTRASTK	4113	/* extra int stack for deadlock searches */
#define SYI$_BALSETCNT		4114	/* balance set count */
#define SYI$_IRPCOUNT		4115	/* count of I/O packets */
#define SYI$_IRPCOUNTV		4116	/* limit of extension of IRP list */
#define SYI$_WSMAX		4117	/* max size of process working set */
#define SYI$_NPAGEDYN		4118	/* non-paged dynamic pool */
#define SYI$_NPAGEVIR		4119	/* limit of extension of above */
#define SYI$_PAGEDYN		4120	/* paged dynamic pool */
#define SYI$_VIRTUALPAGECNT	4121	/* max virtual page count */
#define SYI$_SPTREQ		4122	/* requested SPT extension */
#define SYI$_EXUSRSTK		4123	/* extra user stack provided */
#define SYI$_LRPCOUNT		4124	/* number of large request packets */
#define SYI$_LRPCOUNTV		4125	/* limit of extension of LRP list */
#define SYI$_LRPSIZE		4126	/* size of large request packet */
#define SYI$_LRPMIN		4127	/* min alloc request for LRPs */
#define SYI$_SRPCOUNT		4128	/* number of small request packets */
#define SYI$_SRPCOUNTV		4129	/* limit of extension of SRP list */
#define SYI$_SRPSIZE		4130	/* size of small request packet */
#define SYI$_SRPMIN		4131	/* min alloc request for SRPs */
#define SYI$_CHANNELCNT		4132	/* number of permanent I/O channels */
#define SYI$_PIOPAGES		4133	/* process I/O pages */
#define SYI$_CTLPAGES		4134	/* control region impure pages */
#define SYI$_CTLIMGLIM		4135	/* limit on use of proc alloc region */
#define SYI$_IMGIOCNT		4136	/* default image I/O address space */
#define SYI$_QUANTUM		4137	/* process quantum */
#define SYI$_MPW_WRTCLUSTER	4138	/* page write cluster factor */
#define SYI$_MPW_HILIMIT	4139	/* modified page list high limit */
#define SYI$_MPW_LOLIMIT	4140	/* modified page list low limit */
#define SYI$_MPW_PRIO		4141	/* modified page writer I/O priority */
#define SYI$_SWP_PRIO		4142	/* swapper I/O priority */
#define SYI$_MPW_THRESH		4143	/* modified page writer lower threshold */
#define SYI$_MPW_WAITLIMIT	4144	/* modified page writer busy wait limit */
#define SYI$_TBSKIPWSL		4145	/* max number WSlist entries to skip */
#define SYI$_PHYSICALPAGES	4146	/* max number of physical pages to use */
#define SYI$_PFRATL		4147	/* page fault rate lower threshold */
#define SYI$_PFRATH		4148	/* page fault rate high threshold */
#define SYI$_PFRATL_SYS		4149	/* PFRATL for the system working set */
#define SYI$_WSINC		4150	/* working set increment */
#define SYI$_WSDEC		4151	/* working set decrement */
#define SYI$_AWSMIN		4152	/* working set minimum */
#define SYI$_AWSTIME		4153	/* working set measurement interval */
#define SYI$_SWPRATE		4154	/* swap rate control (max) */
#define SYI$_SWPOUTPGCNT	4155	/* desired proc page cnt for an outswap */
#define SYI$_SWPALLOCINC	4156	/* swap file allocation increment value */
#define SYI$_IOTA		4157	/* I/O time allowance */
#define SYI$_LONGWAIT		4158	/* when HIB or LEF proc becomes longwait */
#define SYI$_SWPFAIL		4159	/* swap fail count */
#define SYI$_VMSD1		4160	/* reserved to VMS development (DYNAMIC) */
#define SYI$_VMSD2		4161	/* " */
#define SYI$_VMSD3		4162	/* " */
#define SYI$_VMSD4		4163	/* " */
#define SYI$_VMS5		4164	/* reserved to VMS development (STATIC) */
#define SYI$_VMS6		4165	/* " */
#define SYI$_VMS7		4166	/* " */
#define SYI$_VMS8		4167	/* " */
#define SYI$_USERD1		4168	/* reserved for users (DYNAMIC) */
#define SYI$_USERD2		4169	/* " */
#define SYI$_USER3		4170	/* reserved for users (STATIC) */
#define SYI$_USER4		4171	/* " */
#define SYI$_EXTRACPU		4172	/* extra CPU time allowed on expiration */
#define SYI$_MAXSYSGROUP	4173	/* max group code for system UIC */
#define SYI$_MVTIMEOUT		4174	/* timeout for mount verification */
#define SYI$_MAXBUF		4175	/* maximum allowable buffered I/O size */
#define SYI$_DEFMBXBUFQUO	4176	/* def buffer quota for mailbox creation */
#define SYI$_DEFMBXMXMSG	4177	/* def max msg size for mailbox creation */
#define SYI$_DEFMBXNUMMSG	4178	/* def number of messages for " */
#define SYI$_FREELIM		4179	/* desired free list length */
#define SYI$_FREEGOAL		4180	/* target free list length */
#define SYI$_GROWLIM		4181	/* free > growlim to grow proc > wsquota */
#define SYI$_BORROWLIM		4182	/* same as above??? */
#define SYI$_LOCKRETRY		4183	/* multi-CPU lock retry count */
#define SYI$_XFMAXRATE		4184	/* max DR32 data rate */
#define SYI$_LAMAPREGS		4185	/* number of UBA map regs for LPA11 */
#define SYI$_REALTIME_SPTS	4186	/* SPT entries for CONINTERR processes */
#define SYI$_CLISYMTBL		4187	/* number of pages for CLI symbol table */
#define SYI$_LOCKIDTBL		4188	/* size of lock ID table */
#define SYI$_RESHASHTBL		4189	/* size of resource hash table */
#define SYI$_DEADLOCK_WAIT	4190	/* deadlock detection timeout period */
#define SYI$_SCSBUFFCNT		4191	/* SCS buffer descriptor table entries */
#define SYI$_SCSCONNCNT		4192	/* SCS connect descriptor table entries */
#define SYI$_SCSRESPCNT		4193	/* SCS response descriptor table entries */
#define SYI$_SCSMAXDG		4194	/* SCS maximum datagram size */
#define SYI$_SCSMAXMSG		4195	/* SCS max sequenced message size */
#define SYI$_SCSFLOWCUSH	4196	/* SCS flow control cushion */
#define SYI$_SCSSYSTEMID	4197	/* SCS system ID (48 bits) */
#define SYI$_SCSSYSTEMIDH	4198	/* high bits of above */
#define SYI$_SCSNODE		4199	/* SCS system node name */
/* 4200 -- Used to be SCSNODEH. Unused for now. */
#define SYI$_PRCPOLINTERVAL	4201	/* SCA process polling interval */
#define SYI$_PASTIMOUT		4202	/* CI port START/STACK timeout */
#define SYI$_PASTDGBUF		4203	/* CI port DG buffers for START handshake */
#define SYI$_PANUMPOLL		4204	/* number of CI ports to poll */
#define SYI$_PAPOLLINTERVAL	4205	/* time between CI port polls */
#define SYI$_PAPOOLINTERVAL	4206	/* time between SYSAPs pool check */
#define SYI$_TIMEPROMPTWAIT	4207	/* time prompt timeout (when booting) */
#define SYI$_UDABURSTRATE	4208	/* max number of longwords per NPR - 1 */
#define SYI$_LNMSHASHTBL	4209	/* size of system space log name hash table */
#define SYI$_LNMPHASHTBL	4210	/* size of process space " */
#define SYI$_TTY_SCANDELTA	4211	/* delta time for dialup timer scan */
#define SYI$_TTY_DIALTYPE	4212	/* flags for dialup type */
#define SYI$_TTY_SPEED		4213	/* terminal default: speed */
#define SYI$_TTY_RSPEED		4214	/* " " receive speed */
#define SYI$_TTY_PARITY		4215	/* " " parity */
#define SYI$_TTY_BUF		4216	/* " " line width */
#define SYI$_TTY_DEFCHAR	4217	/* " " characteristics */
#define SYI$_TTY_DEFCHAR2	4218	/* " " characteristics, 2nd longword */
#define SYI$_TTY_TYPAHDSZ	4219	/* size of typeahead buffer */
#define SYI$_TTY_ALTYPAHD	4220	/* alternate typeahead size */
#define SYI$_TTY_ALTALARM	4221	/* alt typeahead alarm size */
#define SYI$_TTY_DMASIZE	4222	/* DMA size */
#define SYI$_TTY_PROT		4223	/* default terminal alloc protection */
#define SYI$_TTY_OWNER		4224	/* default terminal owner */
#define SYI$_TTY_CLASSNAME	4225	/* default terminal class name prefix */
#define SYI$_TTY_SILOTIME	4226	/* default silo timeout for DMF32 */
#define SYI$_TTY_DEFPORT	4227	/* default port action parameter */
#define SYI$_RMS_DFMBC		4228	/* RMS default: multi-block count */
#define SYI$_RMS_DFMBFSDK	4229	/* " " multi-buffer count for disk (SEQ) */
#define SYI$_RMS_DFMBFSMT	4230	/* " " multi-buffer count for tape */
#define SYI$_RMS_DFMBFSUR	4231	/* " " multi-buffer count for unit record */
#define SYI$_RMS_DFMBFREL	4232	/* " " multi-buffer count for REL files */
#define SYI$_RMS_DFMBFIDX	4233	/* " " multi-buffer count for ISAM files */
#define SYI$_RMS_DFMBFHSH	4234	/* " " multi-buffer count for HASH files */
#define SYI$_RMS_PROLOGUE	4235	/* " " prolog */
#define SYI$_RMS_EXTEND_SIZE	4236	/* " " file extend quantity */
#define SYI$_RMS_FILEPROT	4237	/* " " file protection */
#define SYI$_PQL_DASTLM		4238	/* def AST limit */
#define SYI$_PQL_MASTLM		4239	/* min " */
#define SYI$_PQL_DBIOLM		4240	/* def buffered I/O limit */
#define SYI$_PQL_MBIOLM		4241	/* min " */
#define SYI$_PQL_DBYTLM		4242	/* def buffered I/O byte count limit */
#define SYI$_PQL_MBYTLM		4243	/* min " */
#define SYI$_PQL_DCPULM		4244	/* def CPU time limit */
#define SYI$_PQL_MCPULM		4245	/* min " */
#define SYI$_PQL_DDIOLM		4246	/* def direct I/O limit */
#define SYI$_PQL_MDIOLM		4247	/* min " */
#define SYI$_PQL_DFILLM		4248	/* def open file limit */
#define SYI$_PQL_MFILLM		4249	/* min " */
#define SYI$_PQL_DPGFLQUOTA	4250	/* def paging file quota */
#define SYI$_PQL_MPGFLQUOTA	4251	/* min " */
#define SYI$_PQL_DPRCLM		4252	/* def sub-process limit */
#define SYI$_PQL_MPRCLM		4253	/* min " */
#define SYI$_PQL_DTQELM		4254	/* def timer queue entry limit */
#define SYI$_PQL_MTQELM		4255	/* min " */
#define SYI$_PQL_DWSDEFAULT	4256	/* def working set default size */
#define SYI$_PQL_MWSDEFAULT	4257	/* min " */
#define SYI$_PQL_DWSQUOTA	4258	/* def working set quota */
#define SYI$_PQL_MWSQUOTA	4259	/* min " */
#define SYI$_PQL_DWSEXTENT	4260	/* def working set extent */
#define SYI$_PQL_MWSEXTENT	4261	/* min " */
#define SYI$_PQL_DENQLM		4262	/* def enqueue limit */
#define SYI$_PQL_MENQLM		4263	/* min " */
#define SYI$_ACP_MAPCACHE	4264	/* number of blocks in bitmap cache */
#define SYI$_ACP_HDRCACHE	4265	/* number of blocks in file header cache */
#define SYI$_ACP_DIRCACHE	4266	/* number of blocks in directory cache */
#define SYI$_ACP_WORKSET	4267	/* ACP working set */
#define SYI$_ACP_FIDCACHE	4268	/* number of cached index file slots */
#define SYI$_ACP_EXTCACHE	4269	/* number of cached disk extents */
#define SYI$_ACP_EXTLIMIT	4270	/* max fraction of disk to cache */
#define SYI$_ACP_QUOCACHE	4271	/* number of file quota entries to cache */
#define SYI$_ACP_SYSACC		4272	/* default access for system volumes */
#define SYI$_ACP_MAXREAD	4273	/* max number of direct blks to read */
#define SYI$_ACP_WINDOW		4274	/* default window size for system volumes */
#define SYI$_ACP_WRITEBACK	4275	/* deferred cache writeback enable */
#define SYI$_ACP_DATACHECK	4276	/* ACP datacheck enable flags */
#define SYI$_ACP_BASEPRIO	4277	/* ACP base priority */
#define SYI$_ACP_SWAPFLGS	4278	/* ACP swap flags */
#define SYI$_DEFPRI		4279	/* default priority for Job Initiations */
#define SYI$_IJOBLIM		4280	/* limit for interactive jobs */
#define SYI$_BJOBLIM		4281	/* limit for batch jobs */
#define SYI$_NJOBLIM		4282	/* limit for network jobs */
#define SYI$_RJOBLIM		4283	/* limit for remote terminal jobs */
#define SYI$_QUORUM		4284	/* connection manager cluster QUORUM */
#define SYI$_VOTES		4285	/* connection manager VOTES from this system */
#define SYI$_RECNXINTERVAL	4286	/* connection manager reconnect interval */
#define SYI$_BOOTTIME		4287	/* 64-bit abs. system time at system boot */
#define SYI$_LOCKIDTBL_MAX	4288	/* maximum size of lock ID table. */
#define SYI$_TAILORED		4289	/* is this system tailored? */
#define SYI$_STARTUP_P1		4290	/* parameters for passing information */
#define SYI$_STARTUP_P2		4291	/* to system startup procedure. */
#define SYI$_STARTUP_P3		4292
#define SYI$_STARTUP_P4		4293
#define SYI$_STARTUP_P5		4294
#define SYI$_STARTUP_P6		4295
#define SYI$_STARTUP_P7		4296
#define SYI$_STARTUP_P8		4297
#define SYI$_CLUSTER_NODES	4298	/* total number of nodes in cluster */
#define SYI$_CLUSTER_VOTES	4299	/* " " " votes " " */
#define SYI$_CLUSTER_QUORUM	4300	/* " quorum in cluster */
#define SYI$_CLUSTER_FSYSID	4301	/* founding systemid */
#define SYI$_CLUSTER_FTIME	4302	/* founding boottime */
#define SYI$_CLUSTER_MEMBER	4303	/* true if in a live cluster */
#define SYI$_NODE_CSID		4304	/* cluster system id of target node */
#define SYI$_NODE_VOTES		4305	/* votes of target node */
#define SYI$_NODE_QUORUM	4306	/* quorum of " " */
#define SYI$_NODE_SYSTEMID	4307	/* systemid of " " */
#define SYI$_NODE_SWINCARN	4308	/* S/W incarnation of " " */
#define SYI$_NODE_SWTYPE	4309	/* S/W type of " " */
#define SYI$_NODE_SWVERS	4310	/* S/W version of " " */
#define SYI$_NODE_HWTYPE	4311	/* H/W type of " " */
#define SYI$_NODE_HWVERS	4312	/* H/W version of " " */
#define SYI$_NODENAME		4313	/* SCS nodename of " " */
#define SYI$_ARCHFLAG		4314	/* flags used by uVAX code */
#define SYI$_SCS_EXISTS		4315	/* flag to indicate presence of SCS */
#define SYI$_DISK_QUORUM	4316	/* cluster quorum device name (in ASCII) */
#define SYI$_XSID		4317	/* extended System Identification Register */
/* 4318 -- Used to be DISK_QUORUM3. Unused for now. */
/* 4319 -- Used to be DISK_QUORUM4. Unused for now. */
#define SYI$_PAMAXPORT		4320	/* max PA port to poll */
#define SYI$_PASANITY		4321	/* PA sanity timer enable/disable switch */
#define SYI$_DEFQUEPRI		4322	/* default Que Priority */
#define SYI$_MAXQUEPRI		4323	/* max Que Priority */
#define SYI$_QDSKINTERVAL	4324	/* disk Quorum Interval */
#define SYI$_ALLOCLASS		4325	/* allocation class */
#define SYI$_LGI_RETRY_LIM	4326	/* login retry limit */
#define SYI$_LGI_RETRY_TMO	4327	/* login retry timeout */
#define SYI$_LGI_BRK_LIM	4328	/* login failure limit */
#define SYI$_LGI_BRK_TMO	4329	/* login suspect timeout */
#define SYI$_LGI_HID_TIM	4330	/* login evasive action time */
#define SYI$_LGI_PWD_TMO	4331	/* system password drop dead time */
#define SYI$_PQL_DJTQUOTA	4332	/* default Job-wide Logical Name Table Creation Quota */
#define SYI$_PQL_MJTQUOTA	4333	/* minimum Job-wide Logical Name Table Creation Quota */
#define SYI$_VAXCLUSTER		4334	/* VAXcluster participation */
#define SYI$_LOCKDIRWT		4335	/* lock manager directory system weight */
#define SYI$_QDSKVOTES		4336	/* votes held by quorum disk */
#define SYI$_DORMANTWAIT	4337	/* when low pri COM proc becomes dormant */
#define SYI$_PAGEFILE_PAGE	4338	/* total pagefile pages */
#define SYI$_SWAPFILE_PAGE	4339	/* total swapfile pages */
#define SYI$_PAGEFILE_FREE	4340	/* free pagefile pages */
#define SYI$_SWAPFILE_FREE	4341	/* free swapfile pages */
#define SYI$_TTY_TIMEOUT	4342	/* seconds for virtual terminal timeout */
#define SYI$_TTY_AUTOCHAR	4343	/* autobaud recognition character */
#define SYI$_PANOPOLL		4344	/* disable/enable CI port polling */
#define SYI$_PE1		4345	/* reserved TO PEDRIVER (DYNAMIC) */
#define SYI$_PE2		4346	/* " */
#define SYI$_PE3		4347	/* " */
#define SYI$_PE4		4348	/* " */
#define SYI$_PE5		4349	/* reserved TO PEDRIVER (STATIC) */
#define SYI$_PE6		4350	/* " */
#define SYI$_RMS_GBLBUFQUO	4351	/* RMS global buffer quota */
#define SYI$_RMS_DFNBC		4352	/* " " network block count */
#define SYI$_ACP_DINDXCACHE	4353	/* file system directory index cache blocks */
#define SYI$_MAXATTACHPRI	4354	/* maximum scheduling prio for ASMP attached processor */
#define SYI$_SMP_CPUS		4355	/* number of CPUs to boot in SMP system */
#define SYI$_SMP_CPUSH		4356	/* hi Number of CPUs to boot in SMP system */
#define SYI$_FALLBACK_MODE	4357	/* cluster fallback mode */
#define SYI$_MPW_LOWAITLIMIT	4358	/* modified page writer lower busy wait limit */
#define SYI$_MPW_IOLIMIT	4359	/* modified page writer max concurrent I/O count */
#define SYI$_S0_PAGING		4360	/* system space paging flags */
#define SYI$_HW_MODEL		4361	/* VAX model number (from SB$B_HWVERS) */
#define SYI$_HW_NAME		4362	/* VAX model name from #/name trans. table */
#define SYI$_SCH_CTLFLAGS	4363	/* CPU scheduling control flags */
#define SYI$_NODE_EVOTES	4364	/* votes expected by target node */
#define SYI$_CLUSTER_EVOTES	4365	/* number of expected votes in cluster */
#define SYI$_MULTIPROCESSING	4366	/* multiprocessor participation */
#define SYI$_FREE_GBLPAGES	4367	/* total, free global pages */
#define SYI$_CONTIG_GBLPAGES	4368	/* maximum, contiguous free global pages */
#define SYI$_FREE_GBLSECTS	4369	/* total, free global sections */
#define SYI$_EXPECTED_VOTES	4370	/* expected votes */
#define SYI$_PU_OPTIONS		4371	/* select PUDRIVER load options */
#define SYI$_WPTTE_SIZE		4372	/* # watchpoint Trace Table Entries */
#define SYI$_WPRE_SIZE		4373	/* watchpoint Restore Entry size */
#define SYI$_SMP_SANITY_CNT	4374	/* # SMP Sanity events bef. timeout */
#define SYI$_SMP_TICK_CNT	4375	/* clock ticks between SMP sanity time cycles */
#define SYI$_QBUS_MULT_INTR	4376	/* uVAX/QBUS multi-level interrupt enable flag */
#define SYI$_SYSTEM_RIGHTS	4377	/* system rights list segment */
#define SYI$_SMP_SPINWAIT	4378	/* SMP normal busywait timeout */
#define SYI$_SMP_LNGSPINWAIT	4379	/* SMP LONG busywait timeout */
#define SYI$_TIME_CONTROL	4380	/* time-related control functions */
#define SYI$_AVAILCPU_CNT	4381	/* number of CPUs in this machine */
#define SYI$_ACTIVECPU_CNT	4382	/* number of CPUs up and running */
/* 4383 -- Used to be LAVC_CONV_BOOT. Unused now. */
/* 4384 -- Used to be LAVC_LOAD_PEA0. Unused now. */
/* 4385 -- Used to be LAVC_PORT_SERV. Unused now. */
#define SYI$_MSCP_LOAD		4386	/* load MSCP server at boot time */
#define SYI$_MSCP_SERVE_ALL	4387	/* serve all disks */
#define SYI$_POOLCHECK		4388	/* pool debugging in MEMORYALC.MAR */
#define SYI$_TAPE_MVTIMEOUT	4389	/* magtape mount verification */
#define SYI$_PSEUDOLOA		4390	/* pseudoloa image size for tape boot */
#define SYI$_MINCLASSPRI	4391	/* min. priority for class scheduling */
#define SYI$_MAXCLASSPRI	4392	/* max. priority for class scheduling */
#define SYI$_MINPRPRI		4393	/* min. priority for preemptive-resume scheduling */
#define SYI$_AUTOCONFIG_ALGO	4394	/* selects which algorithmn SYSGEN uses to autoconfigure. */
#define SYI$_ERRORLOGBUFFERS	4395	/* number of buffers for error logging */
#define SYI$_JOBCTLD		4396	/* dynamic SYSGEN flag to handle job controller diagnostics and Rolling upgrade. */
#define SYI$_WINDOW_SYSTEM	4397	/* default windowing system for workstation */
#define SYI$_MSCP_BUFFER	4398	/* pages allocated to server local pool */
#define SYI$_MSCP_CREDITS	4399	/* number of send credits extended by server */
#define SYI$_BREAKPOINTS	4400	/* mask of INI$BRK callers in exec used in this boot */
#define SYI$_CLOCK_INTERVAL	4401	/* time (in usec) between interval timer clock interrupts */
#define SYI$_DUMPSTYLE		4402	/* mask specifying desired format of dump file (full dump or subset dump) */
#define SYI$_NISCS_PORT_SERV	4403	/* port services flag */
#define SYI$_RSRVPAGCNT		4404	/* no. of pagefile pages to escrow */
#define SYI$_VECTOR_PROC	4405	/* load vector processing */
#define SYI$_VECTOR_MARGIN	4406	/* vector margin */
#define SYI$_AFFINITY_SKIP	4407	/* affinity skip count */
#define SYI$_AFFINITY_TIME	4408	/* affinity queue time */
#define SYI$_VECTOR_EMULATOR	4409	/* vector emulator present flag */
#define SYI$_VP_MASK		4410	/* mask of vector processors */
#define SYI$_VP_NUMBER		4411	/* number of vector processors */
#define SYI$_USED_GBLPAGCNT	4412	/* current count of global pages in use */
#define SYI$_USED_GBLPAGMAX	4413	/* maximum count of global pages in use */
#define SYI$_USED_GBLSECTCNT	4414	/* current count of global sections in use */
#define SYI$_USED_GBLSECTMAX	4415	/* maximum count of global sections in use */
#define SYI$_ERLBUFFERPAGES	4416	/* pages in each ERL Buffer */
#define SYI$_TAPE_ALLOCLASS	4417	/* tape Allocation class */
#define SYI$_PFRATH_SYS		4418	/* PFRATH for the system working set */
#define SYI$_WSINC_SYS		4419	/* WSINC for the system working set */
#define SYI$_WSDEC_SYS		4420	/* WSDEC for the system working set */
#define SYI$_AWSMIN_SYS		4421	/* AWSMIN for the system working set */
#define SYI$_AWSTIME_SYS	4422	/* AWSTIME for the system working set */
#define SYI$_BOOT_STYLE		4423	/* boot Style */
#define SYI$_FT_FLAGS		4424	/* fault Tolerance Flags field */
#define SYI$_SHADOWING		4425	/* shadowing mode */
#define SYI$_SHADOW_SYS_DISK	4426	/* volume shadowed system disk */
#define SYI$_SHADOW_SYS_UNIT	4427	/* shadowed system disk unit number */
#define SYI$_SHADOW_MAX_COPY	4428	/* max shadow copy threads allowed */
#define SYI$_TIMVCFAIL		4429	/* time to detect VC failure */
#define SYI$_SCSI_NOAUTO	4430	/* NOAUTOCONFIGURE for SCSI devices. */
#define SYI$_PRIORITY_OFFSET	4431	/* priority gap for preemption */
#define SYI$_VBN_CACHE_D	4432	/* VBN cache flags dynamic part1 */
#define SYI$_VBN_CACHE_S	4433	/* VBN cache flags static part1 */
#define SYI$_VCC_FLAGS_D	4434	/* VBN cache flags dynamic part2 */
#define SYI$_VCC_FLAGS_S	4435	/* VBN cache flags static part2 */
#define SYI$_VCC_PTES		4436	/* VBN cache number of PTE allocated */
#define SYI$_VCC_MAXSIZE	4437	/* max size of VBN cache */
#define SYI$_VCC_MINSIZE	4438	/* min size of VBN cache */
#define SYI$_VCC_CLMAX		4439	/* max number of cache lines in VBN cache */
#define SYI$_VCC_EQCLASS	4440	/* VBN cache aver. number of Eq. classes per cache line */
#define SYI$_MMG_CTLFLAGS	4441	/* bit mask to control A/T mem mgmt. */
#ifndef NO_VMS_V6
#define SYI$_MAXAUDMSG		4442	/* max # of pages in mailbox message */
#define SYI$_NISCS_MAX_PKTSZ	4443	/* maximum number of bytes allocated for all NISCS packets */
#define SYI$_NISCS_LAN_OVRHD	4444	/* bytes in NISCS packets reserved for other uses (eg DESNC) */
#endif
#define SYI$_DECNET_VERSION	4445	/* version of DECnet-VAX installed */
#define SYI$_TMSCP_LOAD		4446	/* load TMSCP tape server at boot time */
#define SYI$_LGI_CALLOUTS	4447	/* number of LOGINOUT local policy callouts */
#define SYI$_NET_CALLOUTS	4448	/* number of DECNET Login local policy callouts */
#define SYI$_IEEE_ADDRESS	4449	/* 48 bit IEEE unique address - low order 32 bits */
#define SYI$_IEEE_ADDRESSH	4450	/* 48 bit IEEE unique address - high order 16 bits */
#define SYI$_SHADOW_MBR_TMO	4451	/* timeout interval for HBS shadow members */
#define SYI$_PAGE_SIZE		4452	/* memory page size in bytes */
#define SYI$_ARCH_TYPE		4453	/* architecture type */
#define SYI$_ARCH_NAME		4454	/* architecture name */
#define SYI$_CRD_CONTROL	4455	/* CRD scrub/replace control */
#ifdef NO_VMS_V6
#define SYI$_LASTEXE		4456	/*(last index)*/
#else
#define SYI$_SECURITY_POLICY	4456	/* C2/B1 security policy bitmask */
#define SYI$_DNVOSI1		4457	/* DECnet/OSI for VMS */
#define SYI$_VBSS_ENABLE	4458	/* VBSS enable static flags */
#define SYI$_MEMSIZE		4459	/* system memory size */
#define SYI$_XQPCTLD1		4474	/* reserved for XQP use (dynamic) */
#define SYI$_XQPCTL2		4475	/* reserved for XQP use */
#define SYI$_VBSS_ENABLE2	4476	/* VBSS enable dynamic flags */
#define SYI$_DECNET_FULLNAME	4478	/* DECnet/OSI fullname (or DECnet Phase IV node name) */
#define SYI$_SHADOW_SYS_TMO	4493	/* timeout interval for HBS system disk- new and after - shadow members */
#define SYI$_SHADOW_SYS_WAIT	4494	/* timeout interval for HBS system disk- exists - shadow members */
#define SYI$_SYSTEM_CHECK	4497	/* load/enable system problem isolation code */
#define SYI$_LASTEXE		4500	/*(last index)*/
#endif

/* Item codes for sub-field data items. */
#define SYI$_CPU		8192	/* CPU type */
#define SYI$_BUGREBOOT		8193	/* bugcheck reboot enable */
#define SYI$_CRDENABLE		8194	/* memory error checking enable */
#define SYI$_DUMPBUG		8195	/* bugcheck dump enable */
#define SYI$_BUGCHECKFATAL	8196	/* all bugchecks become fatal */
#define SYI$_ACP_MULTIPLE	8197	/* new ACP for each disk class */
#define SYI$_NOAUTOCONFIG	8198	/* auto configuration inhibit */
#define SYI$_NOCLOCK		8199	/* interval timer inhibit */
#define SYI$_NOCLUSTER		8200	/* page read clustering inhibit */
#define SYI$_POOLPAGING		8201	/* enable paging of paged pool */
#define SYI$_SBIERRENABLE	8202	/* SBI error detection enable */
#define SYI$_SETTIME		8203	/* force entry of time at system boot */
#define SYI$_ACP_SHARE		8204	/* enable sharing of F11ACP */
#define SYI$_SYSPAGING		8205	/* enable paging of system code */
#define SYI$_UAFALTERNATE	8206	/* select alternate authorization file */
#define SYI$_WRITABLESYS	8207	/* leave system writable for debugging */
#define SYI$_RESALLOC		8208	/* enable resource allocation checking */
#define SYI$_SSINHIBIT		8209	/* inhibit system services for processes */
#define SYI$_CONCEAL_DEVICES	8210	/* enable concealed devices */
#define SYI$_SAVEDUMP		8211	/* save dump if it's in page file */
#define SYI$_MOUNTMSG		8212	/* enable oper notification of vol mounts */
#define SYI$_DISMOUMSG		8213	/* enable oper notification of vol dism */
#define SYI$_LOADERAPT		8214	/* load alt erase pattern generator */
#define SYI$_LOADCHKPRT		8215	/* load alt protection check routine */
#define SYI$_XCPU		8216	/* CPU subtype (Extended SID info) */
#define SYI$_CJFLOAD		8217	/* load common journaling code */
#define SYI$_CJFSYSRUJ		8218	/* load recovery unit journaling code */
#define SYI$_NODE_AREA		8219	/* system ID node area */
#define SYI$_NODE_NUMBER	8220	/* system ID node number */
#define SYI$_CLASS_PROT		8221	/* non-discretionary check flag */
#define SYI$_CHARACTER_EMULATED 8222	/* character string instructions emulated */
#define SYI$_DECIMAL_EMULATED	8223	/* decimal string instructions emulated */
#define SYI$_D_FLOAT_EMULATED	8224	/* D floating instructions emulated */
#define SYI$_F_FLOAT_EMULATED	8225	/* F floating instructions emulated */
#define SYI$_G_FLOAT_EMULATED	8226	/* G floating instructions emulated */
#define SYI$_H_FLOAT_EMULATED	8227	/* H floating instructions emulated */
#define SYI$_LOADMTACCESS	8228	/* load installation specific access routine */
#define SYI$_ACP_XQP_RES	8229	/* resident XQP */
#define SYI$_WRITESYSPARAMS	8230	/* write active parameters to the system .PAR file */
#define SYI$_LGI_BRK_TERM	8231	/* use term name in breakin detection */
#define SYI$_LGI_BRK_DISUSER	8232	/* disable user account on breakin */
#define SYI$_ACP_REBLDSYSD	8233	/* rebuild system disk when mounting it */
#define SYI$_WS_OPA0		8234	/* workstation using QVSS for OPA0 */
#define SYI$_NOPGFLSWP		8235	/* inhibit swapping into pagefiles */
/* 8236 -- Used to be SHADOWING. Became an EXE item-code. */
#define SYI$_LOAD_SYS_IMAGES	8237	/* load System Images */
#define SYI$_NISCS_CONV_BOOT	8238	/* allow remote conversational boot */
#define SYI$_NISCS_LOAD_PEA0	8239	/* load NI-SCS driver for PEA0 */
#define SYI$_SA_APP		8240	/* booting stand-alone application (SA-BACKUP) */
#define SYI$_LOAD_PWD_POLICY	8241	/* load site-specific password policy */
#define SYI$_FT_ACTIVE		8242	/* CIRRUS system is fully active */
#ifdef NO_VMS_V6
#define SYI$_LASTFLD		8243	/*(last index)*/
#else
#define SYI$_CHECK_CLUSTER	8243	/* VAXCLUSTER=0 sanity check */
#define SYI$_LASTFLD		8246	/*(last index)*/
#endif

/* Definitions for compatability with 1st implementation of sys$getsyi */
#define SYI$C_SFWTYPE		   1	/* system software item */
#define SYI$C_HDWTYPE		   2	/* hardware item */
#define SYI$C_LISTEND		   0	/* itmlst terminator */
#define SYI$_OLDVERSION		 256	/* vms version number */
#define SYI$_LASTSFW		 257	/*(last index)*/
#define SYI$_OLDCPU		 512	/* cpu type */
#define SYI$_OLDSID		 513	/* system id register */
#define SYI$_LASTHDW		 514	/*(last index)*/

#endif	/*_SYIDEF_H*/
