/* <usgdef.h>
 *
 *	Disk usage accounting file produced by analyze/disk_structure utility.
 */
#ifndef _USGDEF_H
#define _USGDEF_H

#define USG$K_IDENT	1	/* identification record */
#define USG$K_FILE	2	/* file record */
#define USG$K_IDENT_LEN 61	/* length of IDENT record */
#define USG$C_IDENT_LEN 61	/* length of IDENT record */
struct usgdef {
    unsigned char usg$b_type;		/* record type */
    unsigned long usg$l_serialnum;	/* pack serial number */
    char usg$t_strucname[12];		/* volume set name */
    char usg$t_volname[12];		/* volume name */
    char usg$t_ownername[12];		/* volume owner name */
    char usg$t_format[12];		/* volume format type */
 /* preceding same as home block */
    unsigned int usg$q_time[2];		/* Time usage file created */
};
#ifndef NO_VMS_V6
#define USG$K_FILE_LEN	1039	/* maximum length of FILE record */
#define USG$C_FILE_LEN	1039
#else
#define USG$K_FILE_LEN	423	/* maximum length of FILE record */
#define USG$C_FILE_LEN	423
#endif

/*** bad alignment! ***/
struct usgdef1 {
    unsigned	: 8;			/* char fill; */
    union {
	unsigned long usg$l_fileowner;		/* file owner UIC */
	struct {
	    unsigned short usg$w_uicmember;	/* UIC member number */
	    unsigned short usg$w_uicgroup;	/* UIC group number */
	} usg$r_fileowner_fields;
    } usg$r_fileowner_overlay;
    unsigned long usg$l_allocated;	/* blocks allocated, including headers */
    unsigned long usg$l_used;		/* blocks used */
    unsigned short usg$w_dir_len;	/* length of directory string */
    unsigned short usg$w_spec_len;	/* length of complete file specification */
    char usg$t_filespec[USG$K_FILE_LEN - 17]; /* file spec "[dir]nam.typ;ver" */
};

#endif	/*_USGDEF_H*/
